Package: EnvStats
Type: Package
Title: Package for Environmental Statistics, Including US EPA Guidance
Version: 3.1.0
Date: 2025-04-17
Authors@R: c(
  person("Steven P.","Millard",email="EnvStats@ProbStatInfo.com",role=c("aut")),
  person("Alexander", "Kowarik", email = "alexander.kowarik@statistik.gv.at", role = c("ctb","cre"),
    comment=c(ORCID="0000-0001-8598-4130")))
Depends: R (>= 3.5.0)
Imports: MASS, ggplot2, nortest
Suggests: lattice, qcc, sp, boot, tinytest, covr, Hmisc
Description: Graphical and statistical analyses of environmental data, with 
  focus on analyzing chemical concentrations and physical parameters, usually in 
  the context of mandated environmental monitoring.  Major environmental 
  statistical methods found in the literature and regulatory guidance documents, 
  with extensive help that explains what these methods do, how to use them, 
  and where to find them in the literature.  Numerous built-in data sets from 
  regulatory guidance documents and environmental statistics literature.  Includes 
  scripts reproducing analyses presented in the book "EnvStats:  An R Package for 
  Environmental Statistics" (Millard, 2013, Springer, ISBN 978-1-4614-8455-4, 
  <doi:10.1007/978-1-4614-8456-1>).
License: GPL (>= 3)
URL: https://github.com/alexkowa/EnvStats,
        https://alexkowa.github.io/EnvStats/
LazyLoad: yes
LazyData: yes
NeedsCompilation: no
Packaged: 2025-04-24 05:09:48 UTC; alex
Author: Steven P. Millard [aut],
  Alexander Kowarik [ctb, cre] (<https://orcid.org/0000-0001-8598-4130>)
Maintainer: Alexander Kowarik <alexander.kowarik@statistik.gv.at>
Repository: CRAN
Date/Publication: 2025-04-24 12:00:07 UTC
Built: R 4.3.3; ; 2025-04-24 15:25:36 UTC; unix

Package: EnvStats
Type: Package
Title: Package for Environmental Statistics, Including US EPA Guidance
Version: 3.1.0
Date: 2025-04-17
Authors@R: c(
  person("Steven P.","Millard",email="EnvStats@ProbStatInfo.com",role=c("aut")),
  person("Alexander", "Kowarik", email = "alexander.kowarik@statistik.gv.at", role = c("ctb","cre"),
    comment=c(ORCID="0000-0001-8598-4130")))
Depends: R (>= 3.5.0)
Imports: MASS, ggplot2, nortest
Suggests: lattice, qcc, sp, boot, tinytest, covr, Hmisc
Description: Graphical and statistical analyses of environmental data, with 
  focus on analyzing chemical concentrations and physical parameters, usually in 
  the context of mandated environmental monitoring.  Major environmental 
  statistical methods found in the literature and regulatory guidance documents, 
  with extensive help that explains what these methods do, how to use them, 
  and where to find them in the literature.  Numerous built-in data sets from 
  regulatory guidance documents and environmental statistics literature.  Includes 
  scripts reproducing analyses presented in the book "EnvStats:  An R Package for 
  Environmental Statistics" (Millard, 2013, Springer, ISBN 978-1-4614-8455-4, 
  <doi:10.1007/978-1-4614-8456-1>).
License: GPL (>= 3)
URL: https://github.com/alexkowa/EnvStats,
        https://alexkowa.github.io/EnvStats/
LazyLoad: yes
LazyData: yes
NeedsCompilation: no
Packaged: 2025-04-24 05:09:48 UTC; alex
Author: Steven P. Millard [aut],
  Alexander Kowarik [ctb, cre] (<https://orcid.org/0000-0001-8598-4130>)
Maintainer: Alexander Kowarik <alexander.kowarik@statistik.gv.at>
Repository: CRAN
Date/Publication: 2025-04-24 12:00:07 UTC
Built: R 4.6.0; ; 2026-04-26 05:24:58 UTC; unix

[![R-CMD-check](https://github.com/alexkowa/EnvStats/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/alexkowa/EnvStats/actions/workflows/R-CMD-check.yaml)
[![Codecov test coverage](https://codecov.io/gh/alexkowa/EnvStats/branch/master/graph/badge.svg)](https://app.codecov.io/gh/alexkowa/EnvStats?branch=master)
[![CRAN](http://www.r-pkg.org/badges/version/EnvStats)](https://CRAN.R-project.org/package=EnvStats)
[![Downloads](http://cranlogs.r-pkg.org/badges/EnvStats)](https://CRAN.R-project.org/package=EnvStats)

## EnvStats

This is the development place for R-package EnvStats

Author: Steven P. Millard

Maintainer: Alexander Kowarik

#####
# File:     Chapter01.R
#
# Purpose:  Reproduce Examples in Chapter 1 of the book:
#
#           Millard, SP. (2013).  EnvStats: An R Package for 
#             Environmental Statistics.  Springer-Verlag.
#
# Author:   Steven P. Millard
#
# Last
# Updated:  2012/12/13
#####

#######################################################################################

library(EnvStats)

############################################################


# 1.10.1 The TcCB data
#---------------------
EPA.94b.tccb.df

head(EPA.94b.tccb.df)

attach(EPA.94b.tccb.df)


############################################################


# 1.10.2 Computing summary statistics
#------------------------------------
summaryStats(TcCB ~ Area, data = EPA.94b.tccb.df)

summaryFull(TcCB ~ Area, data = EPA.94b.tccb.df)


#############################################################


# 1.10.3 Looking at the TcCB data
#--------------------------------

# Figure 1.1
#-----------
windows()
par(mar = c(4, 4, 4, 1) + 0.1)
stripChart(log(TcCB) ~ Area, data = EPA.94b.tccb.df, 
  col = c("red", "blue"), ylab = "Log  [ TcCB (ppb) ]")
mtext("Stripcharts of Log-Transformed TcCB Data", 
  line = 3, cex = 1.25, font = 2)


# Figure 1.2
#-----------
windows()
par(mfrow=c(2,1))
hist(log(TcCB[Area == "Reference"]), 
  xlim = c(-4, 6), col = "blue", 
  xlab = "log [ TcCB (ppb) ]", 
  ylab = "Number of Observations", 
  main = "Reference Area")
hist(log(TcCB[Area == "Cleanup"]), 
  xlim = c(-4, 6), nclass = 30, col = "red", 
  xlab = "log [ TcCB (ppb) ]", 
  ylab = "Number of Observations", 
  main = "Cleanup Area")


# Figure 1.3
#-----------
windows()
boxplot(log(TcCB) ~ Area, col = c("red", "blue"), 
  pars = list(outpch = 16), xlab = "Area", 
  ylab = "Log [ TcCB (ppb) ]",
  main = "Boxplots of Log-Transformed TcCB Data")


#############################################################


# 1.10.4 Quantile (Empirical CDF) Plots
#--------------------------------------

# Figure 1.4
#-----------
windows()
ecdfPlot(TcCB[Area=="Reference"], 
	xlab="TcCB (ppb)", 
	main = "Emipriacal CDF Plot of Reference Area TcCB")


# Figure 1.5
#-----------
windows()
cdfCompare(TcCB[Area=="Reference"], dist="lnorm", 
  xlab="Order Statistics for Reference Area TcCB (ppb)", 
  main=paste("Empirical CDF for ",
    "Reference Area TcCB (solid line)\n",
    "with Fitted Lognormal CDF (dashed line)", sep=""))
legend(0.65, 0.4, legend = c("Empirical CDF", "Fitted Lognormal CDF"), 
  lty = 1:2, col = c(4, 1), lwd = 3, bty = "n")


# Figure 1.6
#-----------
windows()
cdfCompare(log(TcCB[Area=="Reference"]), 
  log(TcCB[Area=="Cleanup"]), 
  xlab="Order Statistics for log [ TcCB (ppb) ]",
  main=paste("CDF for Reference Area (solid line)",
    "with CDF for Cleanup Area (dashed line)", 
    sep="\n"))
legend(1.5, 0.4, legend = c("Reference Area", "Cleanup Area"), lty = 1:2, 
  col = c(4, 1), lwd = 3, bty = "n")



##################################################################


# 1.10.5 Assessing goodness-of-fit with quantile-quantile plots
#--------------------------------------------------------------

# Figure 1.7
#-----------
windows()
qqPlot(TcCB[Area=="Reference"], dist="lnorm", 
  add.line=TRUE, points.col = "blue", 
  ylab="Quantiles of log [ TcCB (ppb) ]", 
  main=paste("Normal Q-Q Plot for",
    "Log-Transformed Reference Area TcCB Data", sep = "\n"))


# Figure 1.8
#-----------
windows()
qqPlot(TcCB[Area=="Reference"], dist="lnorm", plot.type="Tukey", 
  estimate.params=TRUE, add.line=TRUE, points.col = "blue", 
  main=paste("Tukey Mean-Difference Q-Q Plot for",
    "\nReference Area TcCB Fitted to ",
    "Lognormal Distribution", sep=""))


# Figure 1.9
#-----------
windows()
qqPlot(TcCB[Area=="Reference"], dist="gamma", 
  estimate.params = TRUE, digits = 2, 
  add.line=TRUE, points.col = "blue", 
  ylab="Quantiles of TcCB (ppb)", 
  main="Gamma Q-Q Plot for Reference Area TcCB Data")



####################################################################


# 1.10.6 Estimating distribution parameters
#------------------------------------------

elnorm(TcCB[Area=="Reference"], ci=TRUE)

elnormAlt(TcCB[Area=="Reference"], ci=TRUE)

egamma(TcCB[Area=="Reference"], ci=TRUE)

egammaAlt(TcCB[Area=="Reference"], ci=TRUE)



####################################################################


# 1.10.7 Testing for Goodness of Fit
#-----------------------------------

TcCB.ref <- TcCB[Area=="Reference"]

sw.lnorm <- gofTest(TcCB.ref, dist="lnorm")
sw.lnorm

# Figure 1.10
#------------
windows()
plot(sw.lnorm, digits=3)


sw.gamma <- gofTest(TcCB.ref, dist="gamma")
sw.gamma

# Figure 1.11
#------------
windows()
plot(sw.gamma, digits=3)


rm(TcCB.ref, sw.lnorm, sw.gamma)





####################################################################


# 1.10.8 Estimating Quantiles and Computing Confidence Limits
#------------------------------------------------------------

eqlnorm(TcCB[Area=="Reference"], p=0.9, ci=T)


####################################################################


# 1.10.9 Comparing Two Distributions Using Nonparametric Tests
#-------------------------------------------------------------
twoSampleLinearRankTest(TcCB[Area=="Cleanup"], 
	TcCB[Area=="Reference"], alternative="greater")

quantileTest(TcCB[Area=="Cleanup"], TcCB[Area=="Reference"], 
	alternative="greater", target.r=9)


####################################################################

detach("EPA.94b.tccb.df")

#####
# File:     Script - EPA09, Chapter 13 Examples.R
#
# Purpose:  Reproduce Examples in Chapter 13 of the EPA Guidance Document
#
#           USEPA. (2009).  "Statistical Analysis of Ground Water 
#             Monitoring Data at RCRA Facilities, Unified Guidance."
#             EPA 530-R-09-007.
#             Office of Resource Conservation and Recovery, 
#             Program Information and Implementation Division.
#             March 2009.
#
#           Errata are listed in:
#           USEPA. (2010).  "Errata Sheet - March 2009 Unified Guidance."
#             EPA 530/R-09-007a.
#             Office of Resource Conservation and Recovery, 
#             Program Information and Implementation Division.
#             August 9, 2010.
#
# Author:   Steven P. Millard
#
# Last
# Updated:  September 3, 2012
#####

#NOTE:  Unless otherwise noted, differences between what is shown in the
#       EPA Guidance Document and results shown here are due to the 
#       EPA Guidance Document rounding intermediate results prior to 
#       the final result.

#######################################################################################

library(EnvStats)


# Example 13-1, pp. 13-3 to 13-5
#-------------------------------

#NOTE:  The EPA Errata Sheet shows updated values for some summary statistics.

# Stats for Iron, by Well

stats <- summaryStats(Iron.ppm ~ Well, data = EPA.09.Ex.13.1.iron.df, 
	combine.groups = FALSE, digits = 2, stats.in.rows = TRUE)
stats
#       Well.1 Well.2 Well.3 Well.4 Well.5 Well.6
#N        4      4      4      4      4      4   
#Mean    47.01  55.73  90.86  70.43 145.24 156.32
#SD      12.4   20.34  59.35  25.95  92.16  51.2 
#Median  50.05  57.05  76.73  76.95 137.66 171.93
#Min     29.96  32.14  39.25  34.12  60.95  83.1 
#Max     57.97  76.71 170.72  93.69 244.69 198.34


#####
# Figure 13-1

windows()
boxplot(Iron.ppm ~ Well, data = EPA.09.Ex.13.1.iron.df, 
	ylim = c(0, 250), ylab = "Iron (ppm)",
	main = "Figure 13-1. Side-by-Side Iron Boxplots")
points(1:ncol(stats), stats["Mean", ], pch = 5)

# NOTE: with so few observations per well, it is often useful to 
#       look at the raw data (optionally with confidence intervals)

windows()
stripChart(Iron.ppm ~ Well, data = EPA.09.Ex.13.1.iron.df, 
	show.ci = F, location.scale.text.cex = 0.7,
	ylim = c(0, 250), ylab = "Iron (ppm)")
mtext("Alternative Figure 13-1. Side-by-Side Iron Strip Plots", 
	cex = 1.25, font = 2, line = 2.5)

windows()
stripChart(Iron.ppm ~ Well, data = EPA.09.Ex.13.1.iron.df,
	location.scale.text.cex = 0.7,
	ylim = c(0, 300), ylab = "Iron (ppm)")
mtext(paste("Alternative Figure 13-1. Side-by-Side Iron Strip Plots",
	"with 95% Confidence Intervals", sep = "\n"), 
	cex = 1.25, font = 2, line = 1.75)


# Stats for log(Iron), by Well

stats <- summaryStats(log(Iron.ppm) ~ Well, data = EPA.09.Ex.13.1.iron.df, 
	combine.groups = F, digits = 2, stats.in.rows = TRUE)
stats
#       Well.1 Well.2 Well.3 Well.4 Well.5 Well.6
#N      4      4      4      4      4      4     
#Mean   3.82   3.97   4.35   4.19   4.8    5     
#SD     0.3    0.4    0.66   0.45   0.7    0.4   
#Median 3.91   4.02   4.29   4.34   4.8    5.14  
#Min    3.4    3.47   3.67   3.53   4.11   4.42  
#Max    4.06   4.34   5.14   4.54   5.5    5.29

#####
# Figure 13-2

windows()
boxplot(log(Iron.ppm) ~ Well, data = EPA.09.Ex.13.1.iron.df, 
	ylim = c(3, 6), ylab = "Log Iron log(ppm)",
	main = "Figure 13-2. Side-by-Side Log(Iron) Boxplots")
points(1:ncol(stats), stats["Mean",], pch = 5)


windows()
stripChart(log(Iron.ppm) ~ Well, data = EPA.09.Ex.13.1.iron.df, 
	show.ci = F, location.scale.text.cex = 0.7,
	ylim = c(3, 6), ylab = "Log Iron log(ppm)")
mtext("Alternative Figure 13-2. Side-by-Side Log(Iron) Strip Plots",
	cex = 1.15, font = 2, line = 2.5)

windows()
stripChart(log(Iron.ppm) ~ Well, data = EPA.09.Ex.13.1.iron.df,
	location.scale.text.cex = 0.7, 
	ylim = c(3, 6), ylab = "Log(Iron) log(ppm)")
mtext(paste("Alternative Figure 13-2. Side-by-Side Log(Iron) Strip Plots",
	"with 95% Confidence Intervals", sep = "\n"), line = 1.75, 
	cex = 1.15, font = 2)


rm(stats)


#######################################################################################


# Example 13-2, pp. 13-7 to 13-8
#-------------------------------

#NOTE: The EPA Errata Sheet gives updated values for this example.

stats <- summaryStats(log(Iron.ppm) ~ Well, data = EPA.09.Ex.13.1.iron.df,
	digits = 3, combine.groups = TRUE, stats.in.rows = TRUE)
stats
#       Well.1 Well.2 Well.3 Well.4 Well.5 Well.6 Combined
#N       4      4      4      4      4      4     24      
#Mean    3.82   3.965  4.347  4.187  4.803  5      4.354  
#SD      0.296  0.395  0.658  0.453  0.704  0.396  0.623  
#Median  3.91   4.025  4.29   4.34   4.8    5.145  4.275  
#Min     3.4    3.47   3.67   3.53   4.11   4.42   3.4    
#Max     4.06   4.34   5.14   4.54   5.5    5.29   5.5 

fit <- aov(log(Iron.ppm) ~ Well, data = EPA.09.Ex.13.1.iron.df)
anova(fit)
#Analysis of Variance Table
#
#Response: log(Iron.ppm)
#          Df Sum Sq Mean Sq F value  Pr(>F)  
#Well       5 4.3313 0.86626  3.3871 0.02486 *
#Residuals 18 4.6036 0.25575                  
#---
#Signif. codes:  0 ‘***’ 0.001 ‘**’ 0.01 ‘*’ 0.05 ‘.’ 0.1 ‘ ’ 1 


rm(fit, stats)


########################################################################################


# Example 13-3, pp. 13-11 to 13-10
#---------------------------------

#NOTE:  The EPA Errata Sheet gives updated values for this example.

stats <- summaryStats(log(Iron.ppm) ~ Well, 
	data = EPA.09.Ex.13.1.iron.df, 
	combine.groups = F, digits = 3, 
	stats.in.rows = TRUE)

# Unadjusted 99% Upper Prediction Limits
#---------------------------------------
UPLs <- sapply(
	with(EPA.09.Ex.13.1.iron.df, split(Iron.ppm, Well)), 
	function(x, pi.type, conf.level) {
		predIntLnorm(x, pi.type = "upper", 
			conf.level = 0.99)$interval$limits["UPL"]
	})
rbind(stats[c("Mean", "SD", "N"), ], "99% PL" = round(UPLs, 1))
#        Well.1  Well.2   Well.3  Well.4   Well.5   Well.6
#Mean     3.820   3.965    4.347   4.187    4.803    5.000
#SD       0.296   0.395    0.658   0.453    0.704    0.396
#N        4.000   4.000    4.000   4.000    4.000    4.000
#99% PL 205.000 392.200 2181.000 657.200 4340.000 1109.200



# Adjusted 99% Upper Prediction Limits
#-------------------------------------
fit <- aov(log(Iron.ppm) ~ Well, data = EPA.09.Ex.13.1.iron.df)
anova.fit <- anova(fit)
anova.fit
#Analysis of Variance Table
#
#Response: log(Iron.ppm)
#          Df Sum Sq Mean Sq F value  Pr(>F)  
#Well       5 4.3313 0.86626  3.3871 0.02486 *
#Residuals 18 4.6036 0.25575                  
#---
#Signif. codes:  0 ‘***’ 0.001 ‘**’ 0.01 ‘*’ 0.05 ‘.’ 0.1 ‘ ’ 1 

RMSE <- anova.fit["Residuals", "Mean Sq"]
Df  <- anova.fit["Residuals", "Df"]
t.crit <- qt(0.99, df = Df)

UPLs <- sapply(
	with(EPA.09.Ex.13.1.iron.df, split(log(Iron.ppm), Well)), 
	function(x, t.crit, RMSE) {
		exp(mean(x) + t.crit * sqrt(RMSE * (1 + 1/length(x))))
	}, 
	t.crit = t.crit, RMSE = RMSE)
rbind(stats[c("Mean", "SD", "N"), ], "99% PL" = round(UPLs, 1))
#        Well.1  Well.2  Well.3  Well.4  Well.5  Well.6
#Mean     3.820   3.965   4.347   4.187   4.803   5.000
#SD       0.296   0.395   0.658   0.453   0.704   0.396
#N        4.000   4.000   4.000   4.000   4.000   4.000
#99% PL 193.100 223.200 327.200 278.800 515.800 628.400

rm(stats, UPLs, fit, anova.fit, RMSE, Df, t.crit)

#####
# File:     Chapter08.R
#
# Purpose:  Reproduce Examples in Chapter 8 of the book:
#
#           Millard, SP. (2013).  EnvStats: An R Package for 
#             Environmental Statistics.  Springer-Verlag.
#
# Author:   Steven P. Millard
#
# Last
# Updated:  2013/08/27
#####


#######################################################################################

library(EnvStats)

############################################################

# 8.4.1 Quantile (Empirical CDF) Plots for Censored Data 
#-----------------------------------------------------

# Figures 8.1 & 8.2
#------------------

windows()
with(Helsel.Cohn.88.silver.df,
	ecdfPlotCensored(Ag, Censored, 
	xlab = expression(paste("Ag (", mu, "g/L)", sep = "")),
	main = "Empirical CDF Plot for Silver\n(Method of Michael-Schucany)", 
	include.cen = TRUE))

windows()
with(Helsel.Cohn.88.silver.df,
	ecdfPlotCensored(log.Ag, Censored, 
	xlab = expression(paste("log [ Ag (", mu, "g/L) ]", sep = "")), 
	main = "Empirical CDF Plot for Silver\n(Method of Michael-Schucany)", 
	include.cen = TRUE))


#######################################################################################


# 8.4.2 Comparing an Empirical and Hypothesized CDF
#--------------------------------------------------

# Figures 8.3 & 8.4
#------------------

windows()
with(Helsel.Cohn.88.silver.df,
	cdfCompareCensored(Ag, Censored, distribution = "lnorm", 
	xlab = expression(paste("Ag (", mu, "g/L)", sep = ""))))

windows()
with(Helsel.Cohn.88.silver.df,
	cdfCompareCensored(log(Ag), Censored, distribution="norm", 
	xlab = expression(paste("log [ Ag (", mu, "g/L) ]", sep = ""))))


#########################################################################################

# 8.4.3 Comparing Two Empirical CDFs
#-----------------------------------

# Figure 8.5
#-----------

attach(Millard.Deverel.88.df)
Cu.Alluvial <- Cu[Zone == "Alluvial.Fan"]
Cu.Alluvial.cen <- Cu.censored[Zone == "Alluvial.Fan"]
Cu.Basin <- Cu[Zone == "Basin.Trough"]
Cu.Basin.cen <- Cu.censored[Zone == "Basin.Trough"]

windows()
cdfCompareCensored(x = Cu.Alluvial, censored = Cu.Alluvial.cen, 
	y = Cu.Basin, y.censored = Cu.Basin.cen)

detach("Millard.Deverel.88.df")
rm(Cu.Alluvial, Cu.Alluvial.cen, Cu.Basin, Cu.Basin.cen)

#####################################################################################

# 8.4.4 Q-Q Plots for Censored Data
#----------------------------------

# Figure 8.6
#-----------

windows()
with(Modified.TcCB.df, 
	qqPlotCensored(TcCB, Censored, distribution = "lnorm", 
	add.line = TRUE, points.col = "blue"))

###################################################################################

# 8.4.5 Box-Cox Transformations for Censored Data
#------------------------------------------------

# Figure 8.7
#-----------

boxcox.list <- with(Modified.TcCB.df, 
	boxcoxCensored(TcCB, Censored))

windows()
plot(boxcox.list)

rm(boxcox.list)

#################################################################################

# 8.5 Estimating Distribution Parameters
#---------------------------------------

# 8.5.1 The Normal Distribution
#------------------------------

# Estimating Parameters of a Normal Distribution
#-----------------------------------------------

with(EPA.09.Ex.15.1.manganese.df, 
	elnormCensored(Manganese.ppb, Censored))

with(EPA.09.Ex.15.1.manganese.df, 
	elnormCensored(Manganese.ppb, Censored, method = "qq.reg"))

with(EPA.09.Ex.15.1.manganese.df, 
	elnormCensored(Manganese.ppb, Censored, 
	method = "impute.w.qq.reg", prob.method = "hirsch-stedinger"))

with(EPA.09.Ex.15.1.manganese.df, 
	elnormCensored(Manganese.ppb, Censored, 
	method = "impute.w.qq.reg", prob.method = "hirsch-stedinger",
	plot.pos.con = 0))



# Confidence Intervals for the Mean of the Normal Distribution
#-------------------------------------------------------------

with(EPA.09.Ex.15.1.manganese.df, 
	elnormCensored(Manganese.ppb, Censored, ci = TRUE))


#################################################################################

# 8.5.2 The Lognormal Distribution
#---------------------------------

with(Modified.TcCB.df, 
	elnormAltCensored(TcCB, Censored, method = "mle", ci = TRUE))

#################################################################################

# 8.5.3 The Gamma Distribution
#-----------------------------

with(Modified.TcCB.df, 
	egammaAltCensored(TcCB, Censored, ci = TRUE, ci.method = "profile.likelihood"))


#################################################################################

# 8.5.4 Estimating the Mean Nonparametrically
#--------------------------------------------

with(EPA.09.Ex.15.1.manganese.df,
	enparCensored(log(Manganese.ppb), Censored, ci = TRUE))

with(EPA.09.Ex.15.1.manganese.df,
	enparCensored(Manganese.ppb, Censored, ci = TRUE))


#################################################################################

# 8.6 Estimating Distribution Quantiles
#--------------------------------------

# 8.6.1 Parametric Estimates of Quantiles
#----------------------------------------

#--------------------------------------
# The Normal and Lognormal Distribution
#--------------------------------------

# First compute the estimated 90th percentile and 
# associated 95% confidence interval using the complete data.
#------------------------------------------------------------
with(EPA.94b.tccb.df, eqlnorm(TcCB[Area == "Reference"], p = 0.9, ci = TRUE))

# Now compute the estimated 90th percentile and confidence interval 
# using the censored data
#-------------------------------------------------------------------

# Estimate the mean and stanrdard deviation using the MLE method,
# and compute the confidence interval using the formula as if 
# we had complete data.
#-----------------------------------------------------------------
with(Modified.TcCB.df, eqlnormCensored(TcCB, Censored, p = 0.9, ci = TRUE))


# Estimate the mean and stanrdard deviation using imputation 
# with Q-Q regression (robust ROS), and compute the confidence 
# interval using the gpq method.
#-----------------------------------------------------------------

with(Modified.TcCB.df, eqlnormCensored(TcCB, Censored, p = 0.9, 
	method = "impute.w.qq.reg", ci = TRUE, 
	ci.method = "gpq", seed = 47))



#--------------------
# Other Distributions
#--------------------

egamma.list <- with(Modified.TcCB.df, egammaCensored(TcCB, Censored))

eqgamma(egamma.list, p = 0.9)


# Clean up
#---------
rm(egamma.list)

 
##########################################################################

# 8.7 Prediction Intervals
#-------------------------

# 8.7.1 Parametric Prediction Intervals
#--------------------------------------

enorm.list <- with(EPA.09.Ex.18.3.TCE.df, 
	enormCensored(TCE.ppb[Well.type == "Background"], 
		Censored[Well.type == "Background"]))

predIntNorm(enorm.list, k = 4, pi.type = "upper", conf.level = 0.95, method = "exact")

# Clean up
#---------
rm(enorm.list)

##############################################################################

# 8.8 Tolerance Intervals
#------------------------

# 8.8.1 Parametric Tolerance Intervals
#-------------------------------------

# Estimate the mean and stanrdard deviation using the MLE method,
# and compute the tolerance interval using the formula as if 
# we had complete data.
#-----------------------------------------------------------------
with(Modified.TcCB.df, tolIntLnormCensored(TcCB, Censored, ti.type = "upper"))


# Estimate the mean and stanrdard deviation using imputation 
# with Q-Q regression (robust ROS), and compute the tolerence 
# interval using the gpq method.
#-----------------------------------------------------------------
with(Modified.TcCB.df, tolIntLnormCensored(TcCB, Censored, ti.type = "upper", 
	method = "impute.w.qq.reg", ti.method = "gpq", seed = 47))


#############################################################################

# 8.9 Hypothesis Tests
#---------------------

# 8.9.1 Goodness-of-Fit Tests
#----------------------------

sw.list.norm <- with(Modified.TcCB.df, gofTestCensored(TcCB, Censored))
sw.list.norm

sw.list.lnorm <- with(Modified.TcCB.df, gofTestCensored(TcCB, Censored, dist = "lnorm"))
sw.list.lnorm

windows()
plot(sw.list.norm)

windows()
plot(sw.list.lnorm)

# Clean up
#---------
rm(sw.list.norm, sw.list.lnorm)

##############################################################################

# 8.9.2 Nonparametric Tests to Compare Two Groups
#------------------------------------------------

attach(Millard.Deverel.88.df)

Cu.AF <- Cu[Zone=="Alluvial.Fan"]
Cu.AF.cen <- Cu.censored[Zone=="Alluvial.Fan"]
Cu.BT <- Cu[Zone=="Basin.Trough"]
Cu.BT.cen <- Cu.censored[Zone=="Basin.Trough"]
twoSampleLinearRankTestCensored(Cu.AF, Cu.AF.cen, Cu.BT, Cu.BT.cen, 
	test = "normal.scores.2", var = "hypergeometric")

# Clean up
#---------
rm(Cu.AF, Cu.AF.cen, Cu.BT, Cu.BT.cen)

detach("Millard.Deverel.88.df")

#####
# File:     Chapter04.R
#
# Purpose:  Reproduce Examples in Chapter 4 of the book:
#
#           Millard, SP. (2013).  EnvStats: An R Package for 
#             Environmental Statistics.  Springer-Verlag.
#
# Author:   Steven P. Millard
#
# Last
# Updated:  2013/02/03
#####


#######################################################################################

library(EnvStats)

############################################################

# 4.1 Introduction 
#-----------------

# Figure 4.1
#-----------

# Figure 4.1a
#------------
windows()
par(mfrow = c(3, 2), mar = c(3, 3, 3, 1), mgp = c(1.5, 0.5, 0))
pdfPlot(dist = "beta", param.list = list(shape1=2, shape2=4),
  curve.fill.col = "cyan")
pdfPlot(dist = "beta", param.list = list(shape1=1, shape2=1, ncp=1),
  curve.fill.col = "cyan")
pdfPlot(dist = "binom", param.list = list(size=10, prob=0.5),
  hist.col = "cyan")
pdfPlot(dist = "cauchy", param.list = list(location=0, scale=1),
  left.tail.cutoff = 0.01, right.tail.cutoff = 0.01, 
  curve.fill.col = "cyan")
pdfPlot(dist = "chi", param.list = list(df=4),
  curve.fill.col = "cyan")
pdfPlot(dist = "chisq", param.list = list(df=4),
  curve.fill.col = "cyan")


# Figure 4.1b
#------------
windows()
par(mfrow = c(3, 2), mar = c(3, 3, 3, 1), mgp = c(1.5, 0.5, 0))
pdfPlot(dist = "chisq", param.list = list(df=5, ncp=1),
  curve.fill.col = "cyan")
set.seed(21)
epdfPlot(rgamma(100, shape=4, scale=5), curve.fill = TRUE, curve.fill.col = "cyan", 
  xlab = "Observations", 
  main = "Empirical Density Based On 100\nGamma(shape=4, scale=5) Random Numbers",
  cex.main = 1)
pdfPlot(dist = "exp", param.list = list(rate=2),
  curve.fill.col = "cyan")
pdfPlot(dist = "evd", param.list = list(location=0, scale=1),
  curve.fill.col = "cyan")
pdfPlot(dist = "gevd", param.list = list(location=0, scale=1, shape = 0.5),
  curve.fill.col = "cyan", cex.main = 1)
pdfPlot(dist = "f", param.list = list(df1=5, df2=10),
  curve.fill.col = "cyan")


# Figure 4.1c
#------------
windows()
par(mfrow = c(3, 2), mar = c(3, 3, 3, 1), mgp = c(1.5, 0.5, 0))
pdfPlot(dist = "f", param.list = list(df1=5, df2=10, ncp=1),
  curve.fill.col = "cyan")
pdfPlot(dist = "gamma", param.list = list(shape=2, scale=1),
  curve.fill.col = "cyan")
pdfPlot(dist = "gammaAlt", param.list = list(mean=10, cv=0.5),
  curve.fill.col = "cyan")
pdfPlot(dist = "geom", param.list = list(prob=0.5),
  hist.col = "cyan")
pdfPlot(dist = "hyper", param.list = list(m=20, n=15, k=7),
  hist.col = "cyan")
pdfPlot(dist = "logis", param.list = list(location=0, scale=1),
  curve.fill.col = "cyan")


# Figure 4.1d
#------------
windows()
par(mfrow = c(3, 2), mar = c(3, 3, 3, 1), mgp = c(1.5, 0.5, 0))
pdfPlot(dist = "lnorm", param.list = list(meanlog=0, sdlog=1),
  curve.fill.col = "cyan")
pdfPlot(dist = "lnormAlt", param.list = list(mean=10, cv=0.5),
  curve.fill.col = "cyan")
pdfPlot(dist = "lnormMix", param.list = 
  list(meanlog1=0, sdlog1=1, meanlog2=3, sdlog2=0.5, p.mix=0.5),
  right.tail.cutoff = 0.02,
  curve.fill.col = "cyan", cex.main = 1, 
  main = paste("Lognormal Mixture Density", "(meanlog1=0, sdlog1=1,",
  "meanlog2=3, sdlog2=0.5, p.mix=0.5)", sep="\n"))
pdfPlot(dist = "lnormMixAlt", param.list = 
  list(mean1=5, cv1=1, mean2=20, cv2=0.5, p.mix=0.5),
  right.tail.cutoff = 0.01,
  curve.fill.col = "cyan", cex.main=1,
  main = paste("Lognormal Mixture Density", "(mean1=5, cv1=1,",
  "mean2=20, cv2=0.5, p.mix=0.5)", sep="\n"))
pdfPlot(dist = "lnorm3", param.list = list(meanlog=0, sdlog=1, threshold=5),
  right.tail.cutoff = 0.01, curve.fill.col = "cyan", cex.main = 1)
pdfPlot(dist = "lnormTrunc", param.list = 
  list(meanlog=0, sdlog=1, min=0, max=2),
  curve.fill.col = "cyan", cex.main = 1)


# Figure 4.1e
#------------
windows()
par(mfrow = c(3, 2), mar = c(3, 3, 3, 1), mgp = c(1.5, 0.5, 0))
pdfPlot(dist = "lnormTruncAlt", param.list = 
  list(mean=2, cv=1, min=0, max=3),
  curve.fill.col = "cyan")
pdfPlot(dist = "nbinom", param.list = list(size=4, prob=0.5),
  hist.col = "cyan")
pdfPlot(dist = "norm", param.list = list(mean=0, sd=1),
  curve.fill.col = "cyan")
pdfPlot(dist = "normMix", param.list = 
  list(mean1=0, sd1=1, mean2=4, sd2=2, p.mix=0.5),
  curve.fill.col = "cyan", cex.main=1,
  main = paste("Normal Mixture Density", "(mean1=0, sd1=1,",
  "mean2=4, sd2=2, p.mix=0.5)", sep="\n"))
pdfPlot(dist = "normTrunc", param.list = 
  list(mean=10, sd=2, min=8, max=13),
  curve.fill.col = "cyan", cex.main = 1)
pdfPlot(dist = "pareto", param.list = list(location=1, shape=2),
  curve.fill.col = "cyan", right.tail.cutoff = 0.01)


# Figure 4.1f
#------------
windows()
par(mfrow = c(3, 2), mar = c(3, 3, 3, 1), mgp = c(1.5, 0.5, 0))
pdfPlot(dist = "pois", param.list = list(lambda=5),
  hist.col = "cyan")
pdfPlot(dist = "t", param.list = list(df=5),
  curve.fill.col = "cyan")
pdfPlot(dist = "t", param.list = list(df=5, ncp=1),
  curve.fill.col = "cyan")
pdfPlot(dist = "tri", param.list = list(min=0, max=1, mode=0.7),
  curve.fill.col = "cyan")
pdfPlot(dist = "unif", param.list = list(min=0, max=1),
  curve.fill.col = "cyan")
pdfPlot(dist = "weibul", param.list = list(shape=2, scale=1),
  curve.fill.col = "cyan")


# Figure 4.1g
#------------
windows()
par(mfrow = c(3, 2), mar = c(3, 3, 3, 1), mgp = c(1.5, 0.5, 0))
pdfPlot(dist = "wilcox", param.list = list(m=4, n=3),
  hist.col = "cyan")
pdfPlot(dist = "zmlnorm", param.list = list(meanlog=0, sdlog=1, p.zero=0.5),
  right.tail.cutoff = 0.01, curve.fill.col = "cyan", cex.main = 1)
pdfPlot(dist = "zmlnormAlt", param.list = list(mean=2, cv=1, p.zero=0.4),
  right.tail.cutoff = 0.01, curve.fill.col = "cyan", cex.main = 1)
pdfPlot(dist = "zmnorm", param.list = list(mean=5, sd=1, p.zero=0.3),
  curve.fill.col = "cyan")
frame()
frame()



# 4.2.1 Probability Density Function for Lognormal Distribution
#--------------------------------------------------------------

# Figure 4.2
#-----------

windows()
with(EPA.94b.tccb.df, 
  hist(TcCB[Area == "Reference"], freq = FALSE, 
  xlim = c(0, 2), xlab = "TcCB (ppb)", col = "cyan",
  main = "Density Histogram of Reference Area TcCB Data"))


# Figure 4.3
#-----------
windows()
pdfPlot(distribution = "lnormAlt", param.list = list(mean = 0.6, cv = 0.5), 
  curve.fill.col = "cyan")


round(dlnormAlt(seq(0, 2, by = 0.5), mean = 0.6, cv = 0.5), 3)

# Figure 4.4
#-----------
windows()
pdfPlot(distribution = "gammaAlt", param.list = list(mean = 0.6, cv = 0.5))

round(dgammaAlt(seq(0, 2, by = 0.5), mean = 0.6, cv = 0.5), 3)


# 4.3.1 Cumulative Distribution Function for Lognormal Distribution
#------------------------------------------------------------------

# Figure 4.5
#-----------
windows()
cdfPlot(distribution = "lnormAlt", param.list = list(mean = 0.6, cv = 0.5))

round(plnormAlt(seq(0, 2, by = 0.5), mean = 0.6, cv = 0.5), 2)


# 4.4.1 Quantiles for Lognormal Distribution
#-------------------------------------------
qlnormAlt(c(0.5, 0.95), mean = 0.6, cv = 0.5)



# 4.5.1 Generating Random Numbers from a Univariate Distribution
#---------------------------------------------------------------
set.seed(23)
rlnormAlt(5, mean = 0.6, cv = 0.5)


# 4.5.2 Generating Multivariate Normal Random Numbers
#----------------------------------------------------
library(MASS)
set.seed(47)
sd.vec <- c(1, 3)
cor.mat <- matrix(c(1, 0.5, 0.5, 1), ncol = 2)
cov.mat <- diag(sd.vec) %*% cor.mat %*% diag(sd.vec)
mvrnorm(n = 3, mu = c(5, 10), Sigma = cov.mat)

rm(sd.vec, cor.mat, cov.mat)


# 4.5.3 Generating Multivariate Observations Based on Rank Correlations
#----------------------------------------------------------------------
simulateMvMatrix(n = 3, 
  distributions = c(X1 = "norm", X2 = "lnormAlt"),
  param.list = list(X1 = list(mean = 5, sd = 1),
                    X2 = list(mean = 10, cv = 2)),
  cor.mat = matrix(c(1, 0.5, 0.5, 1), ncol=2), seed = 105)

#####
# File:     Script - EPA09, Chapter 21 Examples.R
#
# Purpose:  Reproduce Examples in Chapter 21 of the EPA Guidance Document
#
#           USEPA. (2009).  "Statistical Analysis of Ground Water 
#             Monitoring Data at RCRA Facilities, Unified Guidance."
#             EPA 530-R-09-007.
#             Office of Resource Conservation and Recovery, 
#             Program Information and Implementation Division.
#             March 2009.
#
#           Errata are listed in:
#           USEPA. (2010).  "Errata Sheet - March 2009 Unified Guidance."
#             EPA 530/R-09-007a.
#             Office of Resource Conservation and Recovery, 
#             Program Information and Implementation Division.
#             August 9, 2010.
#
# Author:   Steven P. Millard
#
# Last
# Updated:  October 4, 2012
#####

#NOTE:  Unless otherwise noted, differences between what is shown in the
#       EPA Guidance Document and results shown here are due to the 
#       EPA Guidance Document rounding intermediate results prior to 
#       the final result.

#######################################################################################

library(EnvStats)

# Example 21-1, pp. 21-4 to 21-5
#-------------------------------

# Raw data
#---------

EPA.09.Ex.21.1.aldicarb.df
#   Month   Well Aldicarb.ppb
#1      1 Well.1         19.9
#2      2 Well.1         29.6
#3      3 Well.1         18.7
#4      4 Well.1         24.2
#5      1 Well.2         23.7
#6      2 Well.2         21.9
#7      3 Well.2         26.9
#8      4 Well.2         26.1
#9      1 Well.3          5.6
#10     2 Well.3          3.3
#11     3 Well.3          2.3
#12     4 Well.3          6.9

longToWide(EPA.09.Ex.21.1.aldicarb.df, "Aldicarb.ppb", 
	"Month", "Well", paste.row.name = TRUE)
#        Well.1 Well.2 Well.3
#Month.1   19.9   23.7    5.6
#Month.2   29.6   21.9    3.3
#Month.3   18.7   26.9    2.3
#Month.4   24.2   26.1    6.9



# Step 1:  Summary Statistics and Shapiro-Wilk Tests 
#---------------------------------------------------


# Summary Statistics by Well
#---------------------------

summaryStats(Aldicarb.ppb ~ Well, 
	data = EPA.09.Ex.21.1.aldicarb.df, 
	combine.groups = TRUE, digits = 1, stats.in.rows = TRUE)
#       Well.1 Well.2 Well.3 Combined
#N       4      4      4     12      
#Mean   23.1   24.6    4.5   17.4    
#SD      4.9    2.3    2.1   10      
#Median 22     24.9    4.4   20.9    
#Min    18.7   21.9    2.3    2.3    
#Max    29.6   26.9    6.9   29.6 


summaryFull(Aldicarb.ppb ~ Well, data = EPA.09.Ex.21.1.aldicarb.df,
	stats = c("n", "mean", "sd", "skew"))
#                   Well.1  Well.2  Well.3 
#N                   4       4       4     
#Mean               23.1    24.65    4.525 
#Skew                0.8765 -0.4045  0.1283
#Standard Deviation  4.935   2.283   2.101



# Group Shapiro-Wilk Test Shows p-values for Individual Wells
#------------------------------------------------------------

gofGroupTest(Aldicarb.ppb ~ Well, data = EPA.09.Ex.21.1.aldicarb.df)
#
#Results of Group Goodness-of-Fit Test
#-------------------------------------
#
#Test Method:                     Wilk-Shapiro GOF (Normal Scores)
#
#Hypothesized Distribution:       Normal
#
#Data:                            Aldicarb.ppb
#
#Grouping Variable:               Well
#
#Data Source:                     EPA.09.Ex.21.1.aldicarb.df
#
#Number of Groups:                3
#
#Sample Sizes:                    Well.1 = 4
#                                 Well.2 = 4
#                                 Well.3 = 4
#
#Test Statistic:                  z (G) = 0.618909
#
#P-values for
#Individual Tests:                Well.1 = 0.5469869
#                                 Well.2 = 0.6617847
#                                 Well.3 = 0.7042248
#
#P-value for
#Group Test:                      0.7320118
#
#Alternative Hypothesis:          At least one group
#                                 does not come from a
#                                 Normal Distribution.



# Steps 2-4 Compute 95% Lower Confidence Bounds for the mean 
# and Compare to the standard of 7 ppb 
#-----------------------------------------------------------

# Example for Well 1
#-------------------

Month    <- EPA.09.Ex.21.1.aldicarb.df$Month
Well     <- EPA.09.Ex.21.1.aldicarb.df$Well
Aldicarb <- EPA.09.Ex.21.1.aldicarb.df$Aldicarb.ppb

enorm(Aldicarb[Well == "Well.1"], ci = T, ci.type = "lower")
#
#Results of Distribution Parameter Estimation
#--------------------------------------------
#
#Assumed Distribution:            Normal
#
#Estimated Parameter(s):          mean = 23.10000
#                                 sd   =  4.93491
#
#Estimation Method:               mvue
#
#Data:                            Aldicarb[Well == "Well.1"]
#
#Sample Size:                     4
#
#Confidence Interval for:         mean
#
#Confidence Interval Method:      Exact
#
#Confidence Interval Type:        lower
#
#Confidence Level:                95%
#
#Confidence Interval:             LCL = 17.29318
#                                 UCL =      Inf


# Example for all 3 Wells at Once
#--------------------------------

LCLs <- sapply(split(Aldicarb, Well), 
	function(x) enorm(x, ci = T, ci.type = "lower")$interval$limits["LCL"])
round(LCLs, 2)
#Well.1.LCL Well.2.LCL Well.3.LCL 
#     17.29      21.96       2.05 

LCLs > 7
#Well.1.LCL Well.2.LCL Well.3.LCL 
#      TRUE       TRUE      FALSE


rm(Month, Well, Aldicarb, LCLs)


##########################################################################################


# Example 21-2, pp. 21-7 to 21-8
#-------------------------------

# Raw Data
#---------

EPA.09.Ex.21.2.benzene.df
#  Month Benzene.ppb.orig Benzene.ppb Censored
#1     1              0.5         0.5    FALSE
#2     2              0.5         0.5    FALSE
#3     3              1.6         1.6    FALSE
#4     4              1.8         1.8    FALSE
#5     5              1.1         1.1    FALSE
#6     6             16.1        16.1    FALSE
#7     7              1.6         1.6    FALSE
#8     8             <0.5         0.5     TRUE


# Step 1:  Summary Statistics and Shapiro-Wilk Tests 
#---------------------------------------------------

# Impute non-detect of 0.5 ppb as 0.25 ppb
Benzene      <- EPA.09.Ex.21.2.benzene.df$Benzene.ppb
Censored     <- EPA.09.Ex.21.2.benzene.df$Censored
Benzene[Censored] <- 0.25


# Summary Statistics for raw data
#--------------------------------
summaryStats(Benzene)
#        N Mean  SD Median Min  Max
#Benzene 8  2.9 5.4    1.4 0.2 16.1
 
summaryFull(Benzene, stats = c("n", "mean", "sd", "skew"))
#                    Benzene
#Sample Size:        8      
#Mean:               2.931  
#Skew:               2.76   
#Standard Deviation: 5.353


# Shapiro-Wilk Test on raw data
#------------------------------
gofTest(Benzene)
#
#Results of Goodness-of-Fit Test
#-------------------------------
#
#Test Method:                     Shapiro-Wilk GOF
#
#Hypothesized Distribution:       Normal
#
#Estimated Parameter(s):          mean = 2.931250
#                                 sd   = 5.353299
#
#Estimation Method:               mvue
#
#Data:                            Benzene
#
#Sample Size:                     8
#
#Test Statistic:                  W = 0.5208992
#
#Test Statistic Parameter:        n = 8
#
#P-value:                         1.841521e-05
#
#Alternative Hypothesis:          True cdf does not equal the
#                                 Normal Distribution.



# Summary Statistics for log-transformed data
#--------------------------------------------
log.Benzene <- log(Benzene)

summaryStats(log.Benzene)
#            N Mean  SD Median  Min Max
#log.Benzene 8  0.2 1.3    0.3 -1.4 2.8
 
summaryFull(log.Benzene, stats = c("n", "mean", "sd", "skew"))
#                    log.Benzene
#Sample Size:        8          
#Mean:               0.2037     
#Skew:               1.1215     
#Standard Deviation: 1.2575


# Shapiro-Wilk Test for lognormal distribution
#---------------------------------------------
gofTest(Benzene, dist = "lnorm")
#
#Results of Goodness-of-Fit Test
#-------------------------------
#
#Test Method:                     Shapiro-Wilk GOF
#
#Hypothesized Distribution:       Lognormal
#
#Estimated Parameter(s):          meanlog = 0.2036668
#                                 sdlog   = 1.2574974
#
#Estimation Method:               mvue
#
#Data:                            Benzene
#
#Sample Size:                     8
#
#Test Statistic:                  W = 0.896502
#
#Test Statistic Parameter:        n = 8
#
#P-value:                         0.2686297
#
#Alternative Hypothesis:          True cdf does not equal the
#                                 Lognormal Distribution.


# Steps 2-4 Compute 95% Upper Confidence Bound for 
# the Geometric Mean and compare to MCL of 5 ppb 
#-------------------------------------------------

exp(elnorm(Benzene, ci = T, ci.type = "upper")$interval$limits["UCL"])
#     UCL 
#2.846193 

########################################################################################

# Example 21-3, pp. 21-10 to 21-11
#---------------------------------

# Using the same data as in Example 21-2, 
# compute 95% Upper Confidence Bound for Mean

elnormAlt(Benzene, ci = T, ci.type = "upper")
#
#Results of Distribution Parameter Estimation
#--------------------------------------------
#
#Assumed Distribution:            Lognormal
#
#Estimated Parameter(s):          mean = 2.338968
#                                 cv   = 1.331584
#
#Estimation Method:               mvue
#
#Data:                            Benzene
#
#Sample Size:                     8
#
#Confidence Interval for:         mean
#
#Confidence Interval Method:      Land
#
#Confidence Interval Type:        upper
#
#Confidence Level:                95%
#
#Confidence Interval:             LCL =  0.00000
#                                 UCL = 18.86139


rm(Benzene, Censored, log.Benzene)


##########################################################################################


# Example 21-4, pp. 21-13 to 21-14
#---------------------------------

# Raw Data - same as in Example 21-1
#-----------------------------------

EPA.09.Ex.21.1.aldicarb.df
#   Month   Well Aldicarb.ppb
#1      1 Well.1         19.9
#2      2 Well.1         29.6
#3      3 Well.1         18.7
#4      4 Well.1         24.2
#5      1 Well.2         23.7
#6      2 Well.2         21.9
#7      3 Well.2         26.9
#8      4 Well.2         26.1
#9      1 Well.3          5.6
#10     2 Well.3          3.3
#11     3 Well.3          2.3
#12     4 Well.3          6.9

longToWide(EPA.09.Ex.21.1.aldicarb.df, "Aldicarb.ppb", 
	"Month", "Well", paste.row.name = TRUE)
#        Well.1 Well.2 Well.3
#Month.1   19.9   23.7    5.6
#Month.2   29.6   21.9    3.3
#Month.3   18.7   26.9    2.3
#Month.4   24.2   26.1    6.9



# Compute 99% Lower Confidence Limits for the 95th Percentile
# of Aldicarb for Compliance/Assessment Monitoring
#------------------------------------------------------------

# Example for Well 1
#-------------------

Month    <- EPA.09.Ex.21.1.aldicarb.df$Month
Well     <- EPA.09.Ex.21.1.aldicarb.df$Well
Aldicarb <- EPA.09.Ex.21.1.aldicarb.df$Aldicarb.ppb

eqnorm(Aldicarb[Well == "Well.1"], p = 0.95, method = "qmle", ci = T, 
	ci.type = "lower", conf.level = 0.99)
#
#Results of Distribution Parameter Estimation
#--------------------------------------------
#
#Assumed Distribution:            Normal
#
#Estimated Parameter(s):          mean = 23.10000
#                                 sd   =  4.93491
#
#Estimation Method:               mvue
#
#Estimated Quantile(s):           95'th %ile = 31.21720
#
#Quantile Estimation Method:      qmle
#
#Data:                            Aldicarb[Well == "Well.1"]
#
#Sample Size:                     4
#
#Confidence Interval for:         95'th %ile
#
#Confidence Interval Method:      Exact
#
#Confidence Interval Type:        lower
#
#Confidence Level:                99%
#
#Confidence Interval:             LCL = 25.28550
#                                 UCL =      Inf
#


# Example for all 3 Wells at Once
#--------------------------------

LCLs <- sapply(split(Aldicarb, Well), 
	function(x) eqnorm(x, p = 0.95, method = "qmle", ci = T, 
	ci.type = "lower", conf.level = 0.99)$interval$limits["LCL"])
round(LCLs, 2)
#Well.1.LCL Well.2.LCL Well.3.LCL 
#     25.29      25.66       5.46 

LCLs > 30
#Well.1.LCL Well.2.LCL Well.3.LCL 
#     FALSE      FALSE      FALSE



# Compute 99% Upper Confidence Limits for the 95th Percentile
# of Aldicarb for Corrective Action Monitoring
#------------------------------------------------------------

# Example for Well 1
#-------------------

eqnorm(Aldicarb[Well == "Well.1"], p = 0.95, method = "qmle", ci = T, 
	ci.type = "upper", conf.level = 0.99)
#
#Results of Distribution Parameter Estimation
#--------------------------------------------
#
#Assumed Distribution:            Normal
#
#Estimated Parameter(s):          mean = 23.10000
#                                 sd   =  4.93491
#
#Estimation Method:               mvue
#
#Estimated Quantile(s):           95'th %ile = 31.21720
#
#Quantile Estimation Method:      qmle
#
#Data:                            Aldicarb[Well == "Well.1"]
#
#Sample Size:                     4
#
#Confidence Interval for:         95'th %ile
#
#Confidence Interval Method:      Exact
#
#Confidence Interval Type:        upper
#
#Confidence Level:                99%
#
#Confidence Interval:             LCL =     -Inf
#                                 UCL = 67.92601


# Example for all 3 Wells at Once
#--------------------------------

UCLs <- sapply(split(Aldicarb, Well), 
	function(x) eqnorm(x, p = 0.95, method = "qmle", ci = T, 
	ci.type = "upper", conf.level = 0.99)$interval$limits["UCL"])
round(UCLs, 2)
#Well.1.UCL Well.2.UCL Well.3.UCL 
#     67.93      45.38      23.61 
 
UCLs > 30
#Well.1.UCL Well.2.UCL Well.3.UCL 
#      TRUE       TRUE      FALSE 


rm(Month, Well, Aldicarb, LCLs, UCLs)


#############################################################################################


# Example 21-5, pp. 21-18 to 21-20
#---------------------------------

EPA.09.Ex.21.5.beryllium.df
#   Year Quarter Beryllium.ppb
#1  2002       1          3.17
#2  2002       2          2.32
#3  2002       3          7.37
#4  2002       4          4.44
#5  2003       1          9.50
#6  2003       2         21.36
#7  2003       3          5.15
#8  2003       4         15.70
#9  2004       1          5.58
#10 2004       2          3.39
#11 2004       3          8.44
#12 2004       4         10.25
#13 2005       1          3.65
#14 2005       2          6.15
#15 2005       3          6.94
#16 2005       4          3.74

Be <- EPA.09.Ex.21.5.beryllium.df$Beryllium.ppb


# Steps 1-3:  Nonparametric lower 99% confidence limit for the median
#--------------------------------------------------------------------

eqnpar(Be, p = 0.5, ci = T, ci.type = "lower", approx.conf.level = 0.99)
#
#Results of Distribution Parameter Estimation
#--------------------------------------------
#
#Assumed Distribution:            None
#
#Estimated Quantile(s):           Median = 5.865
#
#Quantile Estimation Method:      Nonparametric
#
#Data:                            Be
#
#Sample Size:                     16
#
#Confidence Interval for:         50'th %ile
#
#Confidence Interval Method:      exact
#
#Confidence Interval Type:        lower
#
#Confidence Level:                99%
#
#Confidence Limit Rank(s):        4 
#
#Confidence Interval:             LCL = 3.65
#                                 UCL =  Inf

# Note, if you want to see the confidence level to 2 digits, do this:

eqnpar.obj <- eqnpar(Be, p = 0.5, ci = T, ci.type = "lower", approx.conf.level = 0.99)
print(eqnpar.obj, conf.cov.sig.digits=4)
#
#Results of Distribution Parameter Estimation
#--------------------------------------------
#
#Assumed Distribution:            None
#
#Estimated Quantile(s):           Median = 5.865
#
#Quantile Estimation Method:      Nonparametric
#
#Data:                            Be
#
#Sample Size:                     16
#
#Confidence Interval for:         50'th %ile
#
#Confidence Interval Method:      exact
#
#Confidence Interval Type:        lower
#
#Confidence Level:                98.94%
#
#Confidence Limit Rank(s):        4 
#
#Confidence Interval:             LCL = 3.65
#                                 UCL =  Inf


# Step 4:  Compute 95% Lower Confidence Bound for 
# the Geometric Mean and compare to Nonparametric LCL 
#----------------------------------------------------

exp(elnorm(Be, ci = T, ci.type = "lower", conf.level = 0.99)$interval$limits["LCL"])
#     LCL 
#4.129290

rm(Be, eqnpar.obj)

#######################################################################################


# Example 21-6, pp. 21-21 to 21-22
#---------------------------------

EPA.09.Ex.21.6.nitrate.df
#   Sampling.Date       Date Nitrate.mg.per.l.orig Nitrate.mg.per.l Censored
#1      7/28/1999 1999-07-28                  <5.0              5.0     TRUE
#2       9/3/1999 1999-09-03                  12.3             12.3    FALSE
#3     11/24/1999 1999-11-24                  <5.0              5.0     TRUE
#4       5/3/2000 2000-05-03                  <5.0              5.0     TRUE
#5      7/14/2000 2000-07-14                   8.1              8.1    FALSE
#6     10/31/2000 2000-10-31                  <5.0              5.0     TRUE
#7     12/14/2000 2000-12-14                    11             11.0    FALSE
#8      3/27/2001 2001-03-27                  35.1             35.1    FALSE
#9      6/13/2001 2001-06-13                  <5.0              5.0     TRUE
#10     9/16/2001 2001-09-16                  <5.0              5.0     TRUE
#11    11/26/2001 2001-11-26                   9.3              9.3    FALSE
#12      3/2/2002 2002-03-02                  10.3             10.3    FALSE



Nitrate <- EPA.09.Ex.21.6.nitrate.df$Nitrate.mg.per.l


# Steps 1-4:  Compute nonparametric 95% LCL for 95th percentile
#--------------------------------------------------------------


eqnpar(Nitrate, p = 0.95, ci = T, ci.type = "lower", approx.conf.level = 0.95)
#
#Results of Distribution Parameter Estimation
#--------------------------------------------
#
#Assumed Distribution:            None
#
#Estimated Quantile(s):           95'th %ile = 22.56
#
#Quantile Estimation Method:      Nonparametric
#
#Data:                            Nitrate
#
#Sample Size:                     12
#
#Confidence Interval for:         95'th %ile
#
#Confidence Interval Method:      exact
#
#Confidence Interval Type:        lower
#
#Confidence Level:                88%
#
#Confidence Limit Rank(s):        11 
#
#Confidence Interval:             LCL = 12.3
#                                 UCL =  Inf


#NOTE:  achieved confidence level is only 88%, so need to either increase
#       the value of approx.conf.level or else set lcl.rank to 10.

eqnpar(Nitrate, p = 0.95, ci = T, ci.type = "lower", lcl.rank = 10)
#
#Results of Distribution Parameter Estimation
#--------------------------------------------
#
#Assumed Distribution:            None
#
#Estimated Quantile(s):           95'th %ile = 22.56
#
#Quantile Estimation Method:      Nonparametric
#
#Data:                            Nitrate
#
#Sample Size:                     12
#
#Confidence Interval for:         95'th %ile
#
#Confidence Interval Method:      exact
#
#Confidence Interval Type:        lower
#
#Confidence Level:                98%
#
#Confidence Limit Rank(s):        10 
#
#Confidence Interval:             LCL =  11
#                                 UCL = Inf


# Compare LCL to acute risk standard of 10 mg/L
eqnpar.obj <- eqnpar(Nitrate, p = 0.95, ci = T, ci.type = "lower", lcl.rank = 10)
eqnpar.obj$interval$limits['LCL']
#LCL 
# 11 

 
eqnpar.obj$interval$limits['LCL'] < 10
#  LCL 
#FALSE 


# Step 5:  Compare nonparametric Upper 95% confidence limit for 95th percentile
#          to a corrective action limit of 10 ppm
#------------------------------------------------------------------------------

eqnpar(Nitrate, p = 0.95, ci = T, ci.type = "upper", approx.conf.level = 0.95)
#
#Results of Distribution Parameter Estimation
#--------------------------------------------
#
#Assumed Distribution:            None
#
#Estimated Quantile(s):           95'th %ile = 22.56
#
#Quantile Estimation Method:      Nonparametric
#
#Data:                            Nitrate
#
#Sample Size:                     12
#
#Confidence Interval for:         95'th %ile
#
#Confidence Interval Method:      exact
#
#Confidence Interval Type:        upper
#
#Confidence Level:                46%
#
#Confidence Limit Rank(s):        12 
#
#Confidence Interval:             LCL = -Inf
#                                 UCL = 35.1

#NOTE: Even using the maximum value as the UCL for the 95'th percentile, 
#      only a confidence level of 46% is achieved.


rm(Nitrate, eqnpar.obj)

#############################################################################################


# Example 21-7, pp. 21-26 to 21-29
#---------------------------------

EPA.09.Ex.21.7.TCE.df
#   Month TCE.ppb
#1      2    54.2
#2      4    44.3
#3      8    45.4
#4     11    38.3
#5     13    27.1
#6     16    30.2
#7     20    28.3
#8     23    17.6
#9     26    14.7
#10    30     4.1

Month <- EPA.09.Ex.21.7.TCE.df$Month
TCE   <- EPA.09.Ex.21.7.TCE.df$TCE.ppb

# Step 1 - Time series plot and regression line
#----------------------------------------------

windows()
plot(Month, TCE, xlim = c(0, 35), ylim = c(0, 60), 
	xlab = "Month Sampled", ylab = "TCE Conc (ppb)",
	main = "Figure 21-3. Time Series Plot and Regression Line of TCE Measurements")
TCE.fit <- lm(TCE ~ Month, data = EPA.09.Ex.21.7.TCE.df)
abline(TCE.fit)

summary(TCE.fit)
#
#Call:
#lm(formula = TCE ~ Month, data = EPA.09.Ex.21.7.TCE.df)
#
#Residuals:
#    Min      1Q  Median      3Q     Max 
#-7.0061 -2.1908  0.9452  2.2057  5.4124 
#
#Coefficients:
#            Estimate Std. Error t value Pr(>|t|)    
#(Intercept)  54.9405     2.4816   22.14 1.83e-08 ***
#Month        -1.6026     0.1402  -11.44 3.09e-06 ***
#---
#Signif. codes:  0 ‘***’ 0.001 ‘**’ 0.01 ‘*’ 0.05 ‘.’ 0.1 ‘ ’ 1 
#
#Residual standard error: 3.95 on 8 degrees of freedom
#Multiple R-squared: 0.9423,     Adjusted R-squared: 0.9351 
#F-statistic: 130.8 on 1 and 8 DF,  p-value: 3.094e-06 

# NOTE:  Estimated slope is -1.6026.  
#        Estimated standard error based on residuals is 3.95, so
#        Estimated variance based on residuals is 3.95^2 = 15.60



# Step 2 - Look at residuals from fit
#------------------------------------
windows()
plot(TCE.fit, which = 2, xlab = "Residual TCE (ppb)", 
	caption = "", 
	main = "Figure 21-4. Probability Plot of TCE Residuals")

gofTest(TCE.fit$residuals)
#
#Results of Goodness-of-Fit Test
#-------------------------------
#
#Test Method:                     Shapiro-Wilk GOF
#
#Hypothesized Distribution:       Normal
#
#Estimated Parameter(s):          mean = -1.332918e-16
#                                 sd   =  3.723714e+00
#
#Estimation Method:               mvue
#
#Data:                            TCE.fit$residuals
#
#Sample Size:                     10
#
#Test Statistic:                  W = 0.9613916
#
#Test Statistic Parameter:        n = 10
#
#P-value:                         0.801618
#
#Alternative Hypothesis:          True cdf does not equal the
#                                 Normal Distribution.


windows()
plot(TCE.fit, which = 1, 
	caption = "", 
	main = "Figure 21-5. Scatterplot of TCE Residuals vs. Regression Line Estimates")


# NOTE: typing the command plot(TCE.fit) will automatically produce
#       4 diagnostic plots involving the residuals



# Steps 3-4:  Compute a 95% upper confidence limit for TCE at months 30 and 26
#-----------------------------------------------------------------------------


# Confidence limits at Month = 30
#--------------------------------
predict(TCE.fit, newdata = data.frame(Month = 30), 
	interval = "confidence", level = 0.9)
#       fit      lwr      upr
#1 6.861126 2.380887 11.34136

# So the upper confidence limit associated with the 90% two-sided confidence limit
# (which is equivalent to the 95% upper confidence limit)
# is equal to 11.34 ppb, which is less than 20 ppb.


# NOTE: The Unified Guidance reports a value of UCL = 13.14, and the 
#       Errata update this value to 12.87.


# Confidence limits at Month = 26
#--------------------------------
predict(TCE.fit, newdata = data.frame(Month = 26), 
	interval = "confidence", level = 0.9)
#       fit    lwr      upr
#1 13.27170 9.6425 16.90091


# So the upper confidence limit associated with the 90% two-sided confidence limit
# (which is equivalent to the 95% upper confidence limit)
# is equal to 16.90 ppb, which is less than 20 ppb.

# NOTE: The Unified Guidance reports a value of UCL = 18.32, and the 
#       Errata update this value to 18.14.


# Step 5 - Compute upper 95% confidence limit ignoring linear trend
#------------------------------------------------------------------
enorm(TCE, ci = T, ci.type = "upper")
#
#Results of Distribution Parameter Estimation
#--------------------------------------------
#
#Assumed Distribution:            Normal
#
#Estimated Parameter(s):          mean = 30.42000
#                                 sd   = 15.50776
#
#Estimation Method:               mvue
#
#Data:                            TCE
#
#Sample Size:                     10
#
#Confidence Interval for:         mean
#
#Confidence Interval Method:      Exact
#
#Confidence Interval Type:        upper
#
#Confidence Level:                95%
#
#Confidence Interval:             LCL =     -Inf
#                                 UCL = 39.40956

rm(TCE, Month, TCE.fit)


#####################################################################################

# Example 21-8, pp. 21-31 to 21-32
#---------------------------------

EPA.09.Ex.17.7.sodium.df
#   Year Sodium.ppm
#1  89.6         56
#2  90.1         53
#3  90.8         51
#4  91.1         55
#5  92.1         52
#6  93.1         60
#7  94.1         62
#8  95.6         59
#9  96.1         61
#10 96.3         63


Na.kendall <- kendallTrendTest(Sodium.ppm ~ Year, 
	data = EPA.09.Ex.17.7.sodium.df, ci = T)
Na.kendall
#
#Results of Hypothesis Test
#--------------------------
#
#Null Hypothesis:                 tau = 0
#
#Alternative Hypothesis:          True tau is not equal to 0
#
#Test Name:                       Kendall's Test for Trend
#                                 (with continuity correction)
#
#Estimated Parameter(s):          tau       =   0.5555556
#                                 slope     =   1.3333333
#                                 intercept = -65.9666667
#
#Estimation Method:               slope:      Theil/Sen Estimator
#                                 intercept:  Conover's Estimator
#
#Data:                            y = Sodium.ppm
#                                 x = Year      
#
#Data Source:                     EPA.09.Ex.17.7.sodium.df
#
#Sample Size:                     10
#
#Test Statistic:                  z = 2.146625
#
#P-value:                         0.03182313
#
#Confidence Interval for:         slope
#
#Confidence Interval Method:      Gilbert's Modification
#                                 of Theil/Sen Method
#
#Confidence Interval Type:        two-sided
#
#Confidence Level:                95%
#
#Confidence Interval:             LCL = 0.3992083
#                                 UCL = 2.3333333

# NOTE:  Theil/Sen estimate of slope is 1.33 with a 
#        2-sided 95% CI of [0.40, 2.33]


# To reproduce Figure 21-6, do the following:

library(boot)

statistic.fcn <- function(data, indices, x.to.predict) {
	df <- data[indices, ]
	kendall.list <- kendallTrendTest(df$Sodium.ppm, df$Year)
	slope     <- kendall.list$estimate['slope']	
	intercept <- kendall.list$estimate['intercept']
	intercept + slope * x.to.predict	
}

n.points <- 101

Year <- EPA.09.Ex.17.7.sodium.df$Year
Na   <- EPA.09.Ex.17.7.sodium.df$Sodium.ppm

x.to.predict <- seq(min(Year), max(Year), length = n.points)

set.seed(27)
boot.out <- boot(data = EPA.09.Ex.17.7.sodium.df, 
	statistic = statistic.fcn, R = 500, 
	x.to.predict = x.to.predict)

LCL <- numeric(n.points)
UCL <- numeric(n.points)

for(i in 1:n.points) {
	boot.ci.obj <- boot.ci(boot.out, conf = 0.95, type = "perc", index = i)
	LCL[i] <- boot.ci.obj$percent[4]
	UCL[i] <- boot.ci.obj$percent[5]
}

windows()
plot(Year, Na, ylim = c(45, 70), pch = 16, 
	xlab = "Sample Year", ylab = "Sodium (ppm)",
	main = "Figure 21-6. 95% Theil-Sen Confidence Band on Sodium Measurements")
abline(a = Na.kendall$estimate['intercept'], b = Na.kendall$estimate['slope'])

lines(x.to.predict, LCL, lty = 3)
lines(x.to.predict, UCL, lty = 3)

legend(90, 70, c("Thiel-Sen Trend", "95% Conf Band"), lty = 1:2)


rm(Year, Na, Na.kendall, statistic.fcn, n.points, x.to.predict, 
	boot.out, LCL, UCL, i, boot.ci.obj)

#####
# File:     Script - EPA09, Chapter 09 Examples.R
#
# Purpose:  Reproduce Examples in Chapter 9 of the EPA Guidance Document
#
#           USEPA. (2009).  "Statistical Analysis of Ground Water 
#             Monitoring Data at RCRA Facilities, Unified Guidance."
#             EPA 530-R-09-007.
#             Office of Resource Conservation and Recovery, 
#             Program Information and Implementation Division.
#             March 2009.
#
# Author:   Steven P. Millard
#
# Last
# Updated:  August 20, 2012
#####

#NOTE:  Unless otherwise noted, differences between what is shown in the
#       EPA Guidance Document and results shown here are due to the 
#       EPA Guidance Document rounding intermediate results prior to 
#       the final result.

#######################################################################################

library(EnvStats)


# Example 9-1, pp. 9-3 to 9-5
#------------------------------

stats <- summaryStats(TCE.mg.per.L ~ Well, 
	data = EPA.09.Table.9.1.TCE.df,
	combine.groups = F, 
	digits = 3, stats.in.rows = TRUE)
stats
#        Well.1 Well.2
#N       14     13    
#Mean     0.063  0.118
#SD       0.079  0.02 
#Median   0.031  0.11 
#Min      0.004  0.099
#Max      0.25   0.17 
#NA's     1      2    
#N.Total 15     15   

Min.Max.mat <- stats[c("Min", "Max"), ]
Min.Max.mat
#    Well.1 Well.2
#Min  0.004  0.099
#Max  0.250  0.170

TCE            <- EPA.09.Table.9.1.TCE.df$TCE.mg.per.L
Date           <- EPA.09.Table.9.1.TCE.df$Date
Well           <- EPA.09.Table.9.1.TCE.df$Well
Data.Qualifier <- EPA.09.Table.9.1.TCE.df$Data.Qualifier

index.Well.1.Min <- Well == "Well.1" & !is.na(TCE) & TCE == Min.Max.mat["Min", "Well.1"]
index.Well.1.Max <- Well == "Well.1" & !is.na(TCE) & TCE == Min.Max.mat["Max", "Well.1"]
index.Well.2.Min <- Well == "Well.2" & !is.na(TCE) & TCE == Min.Max.mat["Min", "Well.2"]
index.Well.2.Max <- Well == "Well.2" & !is.na(TCE) & TCE == Min.Max.mat["Max", "Well.2"]

DQ.vec <- c(paste(Data.Qualifier[index.Well.1.Min], collapse = ","), 
	paste(Data.Qualifier[index.Well.1.Max], collapse = ","),
	paste(Data.Qualifier[index.Well.2.Min], collapse = ","), 
	paste(Data.Qualifier[index.Well.2.Max], collapse = ","))
DQ.mat <- matrix(DQ.vec, 2, 2)
DQ.mat
#     [,1]  [,2]
#[1,] "J,U" "U" 
#[2,] ""    "" 

df <- data.frame(Min.Max.mat[, 1], DQ.mat[, 1], Min.Max.mat[, 2], DQ.mat[, 2])
row.names(df) <- c("Min", "Max")
names(df) <- c("Well.1.TCE", "Well.1.DQ", "Well.2.TCE", "Well.2.DQ")
df
#    Well.1.TCE Well.1.DQ Well.2.TCE Well.2.DQ
#Min      0.004       J,U      0.099         U
#Max      0.250                0.170 

Well.index <- Well == "Well.1"
ND.index   <- Data.Qualifier == "U"
NA.index   <- is.na(TCE)
windows()
plot(Date[Well.index], TCE[Well.index], type = "n", 
	ylim = c(0, max(TCE, na.rm = T)),
	xlab = "Time", ylab = "Trichloroethene (mg/L)")
points(Date[Well.index & !ND.index], TCE[Well.index & !ND.index], 
	cex = 2, pch = 16, col = "blue")
points(Date[Well.index & ND.index], TCE[Well.index & ND.index], 
	cex = 2, pch = 1, col = "blue")
lines(Date[Well.index & !NA.index], TCE[Well.index & !NA.index], 
	lwd = 2, col = "blue")

Well.index <- Well == "Well.2"
points(Date[Well.index & !ND.index], TCE[Well.index & !ND.index], 
	cex = 2, pch = 15, col = "red")
points(Date[Well.index & ND.index], TCE[Well.index & ND.index], 
	cex = 2, pch = 14, col = "red")
lines(Date[Well.index & !NA.index], TCE[Well.index & !NA.index], 
	lwd = 2, lty = 2, col = "red")

legend(Date[1], 0.25, legend = c("Well 1", "Well 2"),
	col = c("blue", "red"), lty = c(1, 2), lwd = rep(2, 2),
	pch = c(16, 15), horiz = T)

title(main = "Figure 9-1. Time Series Plot of Trichloroethene Groudwater\nfor Wells 1 and 2 from 2005-2007")

rm(TCE, Date, Well, Data.Qualifier, stats, Min.Max.mat, 
	index.Well.1.Min, index.Well.1.Max, 
	index.Well.2.Min, index.Well.2.Max, 
	DQ.vec, DQ.mat, df, Well.index, ND.index, NA.index) 


###################################################################
	

# Example 9-2, pp. 9-7 to 9-8, Using Standard Boxplot
#----------------------------------------------------
# NOTE: Instructions for producing Figure 9-2 include
#       "Step 6. Draw the whiskers from each end of the 
#       box to the furthest data point to show the 
#       full range of the data."
#
#       This is not how boxplots are conventionally drawn,
#       so instead the standard boxplot is drawn here, where
#       the lower whisker extends to the smallest value within
#       1.5 x IQR of the 25th Percentile and the upper whisker
#       extends to to the largest value within 1.5 x IQR of 
#       the 75th Percentile.
#
#       To produce a boxplot with whiskers that exetend to
#       the extreme values, set the argument range=0 in the
#       call to the boxplot() function.

stats <- summaryStats(TCE.mg.per.L ~ Well, 
	data = EPA.09.Table.9.1.TCE.df,
	combine.groups = F, digits = 3, stats.in.rows = TRUE)
stats
#        Well.1 Well.2
#N       14     13    
#Mean     0.063  0.118
#SD       0.079  0.02 
#Median   0.031  0.11 
#Min      0.004  0.099
#Max      0.25   0.17 
#NA's     1      2    
#N.Total 15     15

stats.no.ND <- summaryStats(TCE.mg.per.L ~ Well, 
	data = EPA.09.Table.9.1.TCE.df, 
	subset = Data.Qualifier != "U",
	combine.groups = F, digits = 3, stats.in.rows = TRUE)

stats.no.ND
#        Well.1 Well.2
#N       11     10    
#Mean     0.079  0.124
#SD       0.082  0.019
#Median   0.05   0.118
#Min      0.004  0.107
#Max      0.25   0.17 
#NA's     1      2    
#N.Total 12     12

windows()
box.list <- boxplot(TCE.mg.per.L ~ Well, data = EPA.09.Table.9.1.TCE.df,
	boxwex = 0.3, varwidth = T,
	ylab = "Trichloroethene (mg/L)",
	main = "Figure 9-2. Boxplots of Trichloroethene Data for Wells 1 & 2")

points(1:2, stats["Mean",], pch = 8, cex = 0.7)

TCE            <- EPA.09.Table.9.1.TCE.df$TCE.mg.per.L
Well           <- EPA.09.Table.9.1.TCE.df$Well
limits <- sapply(split(TCE, Well), 
	function(x) enorm(x, ci=T)$interval$limits)
#Warning messages:
#1: In is.not.finite.warning(x) :
#  There were 1 nonfinite values in x : 1 NA's
#2: In enorm(x, ci = T) : 1 observations with NA/NaN/Inf in 'x' removed.
#3: In is.not.finite.warning(x) :
#  There were 2 nonfinite values in x : 2 NA's
#4: In enorm(x, ci = T) : 2 observations with NA/NaN/Inf in 'x' removed.

points(1:2, limits["UCL", ], pch = 94, cex = 1.2) 
points(1:2, limits["LCL", ], pch = 118) 

abline(h = 0.23, lty = 3)
text(0.5, 0.24, "PRG = 0.23 mg/L", adj = 0, cex = 0.8)

mtext(paste("FOD =", stats.no.ND["N", ], "/", stats["N", ]), 
	at = 1:2, side = 1, line = 3)

legend(1.25, 0.07, c("outlier > 1.5 x IQR", "95% UCL", "Mean", "95% LCL"), 
	pch = c(1, 94, 8, 118), pt.cex = c(1, 1.2, 0.7, 1),
	bty = "n")

rm(TCE, Well, stats, stats.no.ND, box.list, limits)


###################################################################


# Example 9-3, pp. 9-9 to 9-12
#-----------------------------

TCE  <- EPA.09.Table.9.1.TCE.df$TCE.mg.per.L
Well <- EPA.09.Table.9.1.TCE.df$Well

#####
# Frequency Histograms
#####

##
# Variation 1: Create histograms using the hist() function
windows()
par(mfrow = c(2, 1), mar = c(5, 4, 0, 1) + 0.1, oma = c(0, 0, 3, 0))
hist(TCE[Well == "Well.1"], col = "blue", ylim = c(0, 10),
	xlab = "Trichloroethene (mg/L) in Well 1", 
	ylab = "Frequency", main = "")
hist(TCE[Well == "Well.2"], col = "blue", ylim = c(0, 8),
	xlab = "Trichloroethene (mg/L) in Well 2", 
	ylab = "Frequency", main = "")
mtext("Figure 9-3. Frequency Histrograms of Trichloroethene by Well.", 
	outer=T, line = 1, cex = 1.25, font = 2)

# Variation 2: Force the x-axis to be the same for each histogram
windows()
xlim <- range(TCE, na.rm = T)
par(mfrow = c(2, 1), mar = c(5, 4, 0, 1) + 0.1, oma = c(0, 0, 3, 0))
hist(TCE[Well == "Well.1"], col = "blue", 
	xlim = xlim, ylim = c(0, 10),
	xlab = "Trichloroethene (mg/L) in Well 1", 
	ylab = "Frequency", main = "")
hist(TCE[Well == "Well.2"], col = "blue", 
	xlim = xlim, ylim = c(0, 8),
	xlab = "Trichloroethene (mg/L) in Well 2", 
	ylab = "Frequency", main = "")
mtext("Figure 9-3. Frequency Histrograms of Trichloroethene by Well.", 
	outer=T, line = 1, cex = 1.25, font = 2)


##
# Variation 3: Create histograms using the function 
# histogram in the lattice library.

library(lattice)
windows()
histogram(~ TCE.mg.per.L | Well, data = EPA.09.Table.9.1.TCE.df, 
	type = "count", layout = c(1, 2), 
	xlab = "Trichloroethene (mg/L)", ylab = "Frequency",
	main = "Figure 9-3. Frequency Histrograms of Trichloroethene by Well.")
	


#####
# Relative Frequency Histograms
#####

##
# Variation 1: Create relative frequency histograms using the hist() function
windows()
par(mfrow = c(2, 1), mar = c(5, 4, 0, 1) + 0.1, oma = c(0, 0, 3, 0))
hist(TCE[Well == "Well.1"], freq = F, 
	col = "blue", ylim = c(0, 15), 
	xlab = "Trichloroethene (mg/L) in Well 1", 
	ylab = "Relative Frequency (%)", main = "")
hist(TCE[Well == "Well.2"], freq = F, 
	col = "blue", ylim = c(0, 25),
	xlab = "Trichloroethene (mg/L) in Well 2", 
	ylab = "Relative Frequency (%)", main = "")
mtext("Figure 9-4. Relative Frequency Histrograms of Trichloroethene by Well.", 
	outer=T, line = 1, cex = 1.25, font = 2)

##
# Variation 2: Force the x-axis to be the same for each histogram
windows()
xlim <- range(TCE, na.rm = T)
par(mfrow = c(2, 1), mar = c(5, 4, 0, 1) + 0.1, oma = c(0, 0, 3, 0))
hist(TCE[Well == "Well.1"], freq = F, col = "blue", 
	xlim = xlim, ylim = c(0, 15),
	xlab = "Trichloroethene (mg/L) in Well 1", 
	ylab = "Relative Frequency (%)", main = "")
hist(TCE[Well == "Well.2"], freq = F, col = "blue", 
	xlim = xlim, ylim = c(0, 25),
	xlab = "Trichloroethene (mg/L) in Well 2", 
	ylab = "Relative Frequency (%)", main = "")
mtext("Figure 9-4. Relative Frequency Histrograms of Trichloroethene by Well.", 
	outer=T, line = 1, cex = 1.25, font = 2)

##
# Variation 3: Create relative frequency histograms using the function 
#              histogram in the lattice library.

library(lattice)
windows()
histogram(~ TCE.mg.per.L | Well, data = EPA.09.Table.9.1.TCE.df, 
	type = "percent", layout = c(1, 2), 
	xlab = "Trichloroethene (mg/L)", ylab = "Relative Frequency (%)",
	main = "Figure 9-4. Relative Frequency Histrograms of Trichloroethene by Well.")

rm(TCE, Well, xlim)


###################################################################


# Example 9-4, pp. 9-13 to 9-14
#------------------------------

As    <- EPA.09.Table.9.3.df$Arsenic.mg.per.L
As.DQ <- EPA.09.Table.9.3.df$Arsenic.Data.Qualifier

Hg    <- EPA.09.Table.9.3.df$Mercury.mg.per.L
Hg.DQ <- EPA.09.Table.9.3.df$Mercury.Data.Qualifier

ND.ind <- rep("", length(As))
ND.ind[As.DQ != "U" & Hg.DQ != "U"] <- "both detected"
ND.ind[As.DQ == "U" & Hg.DQ == "U"] <- "both non-detects"
ND.ind[As.DQ == "U" & Hg.DQ != "U"] <- "arsenic non-detect only"
ND.ind[As.DQ != "U" & Hg.DQ == "U"] <- "mercury non-detect only"
ND.ind <- factor(ND.ind, levels = c("both detected", 
	"both non-detects", "arsenic non-detect only", 
	"mercury non-detect only"))

# Summary statistics for Arsenic, setting non-detects to detection limit
summaryStats(As)
#    N Mean  SD Median Min Max
#As 15  0.1 0.1    0.1   0 0.3

# Summary statistics for Mercury, setting non-detects to detection limit
summaryStats(Hg)
#    N Mean  SD Median Min Max NA's n.Total
#Hg 14  0.1 0.1    0.1   0 0.3    1      15


# NOTE: there is one (As,Hg) pair (0.01, 0.02) where both are detects
#       and      one (As,Hg) pair (0.01, 0.02) where both are non-detects
#       so you can't use a solid symbol for one or both or they will
#       not both show up!

lim <- range(As, Hg, na.rm = T)
pch.vec <- c(1, 4, 6, 2)
col.vec <- c("black", "red", "blue", "blue")
levels.ND.ind <- levels(ND.ind)
n.levels <- length(levels(ND.ind))
windows()
plot(As, Hg, type = "n", xlim = lim, ylim = lim, 
	xlab = "Arsenic (mg/L)", ylab = "Mercury (mg/L)",
	main = "Figure 9-5. Sctterplot of Arsenic with Mercury from Well 3")
for(i in 1:n.levels) {
	index <- ND.ind == levels.ND.ind[i]
	points(As[index], Hg[index], lwd = 2,
		pch = pch.vec[i], col = col.vec[i])
}
abline(lm(Hg ~ As))
mtext(paste("Pearson Correlation =", 
	round(cor(As, Hg, use="complete.obs"), 2)), line = 0.5)

legend(0.01, 0.3, levels.ND.ind, pch = pch.vec, 
	col = col.vec, lty = 0, lwd = 2, bty = "n")

rm(As, As.DQ, Hg, Hg.DQ, ND.ind, lim, 
	pch.vec, col.vec, levels.ND.ind, n.levels,
	i, index)


###################################################################


# Example 9-5, pp. 9-15 to 9-16
#------------------------------
	

As    <- EPA.09.Table.9.3.df$Arsenic.mg.per.L
As.DQ <- EPA.09.Table.9.3.df$Arsenic.Data.Qualifier

Hg    <- EPA.09.Table.9.3.df$Mercury.mg.per.L
Hg.DQ <- EPA.09.Table.9.3.df$Mercury.Data.Qualifier

Sr    <- EPA.09.Table.9.3.df$Strontium.mg.per.L
Sr.DQ <- EPA.09.Table.9.3.df$Strontium.Data.Qualifier


lim <- range(As, Hg, Sr, na.rm = T)
pch.vec <- c(1, 4, 6, 2)

cor.vec <- rep(as.numeric(NA), 3)

# First plot Hg vs. As

ND.ind <- rep("", length(As))
ND.ind[As.DQ != "U" & Hg.DQ != "U"] <- "both detected"
ND.ind[As.DQ == "U" & Hg.DQ == "U"] <- "both non-detects"
ND.ind[As.DQ == "U" & Hg.DQ != "U"] <- "As non-detect only"
ND.ind[As.DQ != "U" & Hg.DQ == "U"] <- "Hg non-detect only"
ND.ind <- factor(ND.ind, levels = c("both detected", 
	"both non-detects", "As non-detect only", 
	"Hg non-detect only"))

levels.ND.ind <- levels(ND.ind)
n.levels <- length(levels(ND.ind))
windows()
plot(As, Hg, type = "n", xlim = lim, ylim = lim, 
	xlab = "mg/L", ylab = "mg/L",
	main = "Figure 9-6. Coded Sctterplot of Well 3 Arsenic, Mercury, and Strontium")
for(i in 1:n.levels) {
	index <- ND.ind == levels.ND.ind[i]
	points(As[index], Hg[index], lwd = 2,
		pch = pch.vec[i], col = "blue")
}
abline(lm(Hg ~ As), lwd = 2, col = "blue")
cor.vec[1] <- round(cor(As, Hg, use="complete.obs"), 2)


# Now plot Sr vs. As

ND.ind <- rep("", length(As))
ND.ind[As.DQ != "U" & Sr.DQ != "U"] <- "both detected"
ND.ind[As.DQ == "U" & Sr.DQ == "U"] <- "both non-detects"
ND.ind[As.DQ == "U" & Sr.DQ != "U"] <- "As non-detect only"
ND.ind[As.DQ != "U" & Sr.DQ == "U"] <- "Sr non-detect only"
ND.ind <- factor(ND.ind, levels = c("both detected", 
	"both non-detects", "As non-detect only", 
	"Sr non-detect only"))

levels.ND.ind <- levels(ND.ind)
n.levels <- length(levels(ND.ind))

for(i in 1:n.levels) {
	index <- ND.ind == levels.ND.ind[i]
	points(As[index], Sr[index], lwd = 2,
		pch = pch.vec[i], col = "red")
}
abline(lm(Sr ~ As), lwd = 2, col = "red")
cor.vec[2] <- round(cor(As, Sr, use="complete.obs"), 2)


# Now plot Sr vs. Hg

ND.ind <- rep("", length(Hg))
ND.ind[Hg.DQ != "U" & Sr.DQ != "U"] <- "both detected"
ND.ind[Hg.DQ == "U" & Sr.DQ == "U"] <- "both non-detects"
ND.ind[Hg.DQ == "U" & Sr.DQ != "U"] <- "Hg non-detect only"
ND.ind[Hg.DQ != "U" & Sr.DQ == "U"] <- "Sr non-detect only"
ND.ind <- factor(ND.ind, levels = c("both detected", 
	"both non-detects", "Hg non-detect only", 
	"Sr non-detect only"))

levels.ND.ind <- levels(ND.ind)
n.levels <- length(levels(ND.ind))

for(i in 1:n.levels) {
	index <- ND.ind == levels.ND.ind[i]
	points(Hg[index], Sr[index], lwd = 2,
		pch = pch.vec[i], col = "green")
}
abline(lm(Sr ~ Hg), lwd = 2, col = "green")
cor.vec[3] <- round(cor(As, Sr, use="complete.obs"), 2)


legend(0.01, 0.3, c(paste(
	"Mercury (Y) vs. Arsenic (X), Cor =", 
		cor.vec[1]),
	paste("Strontium (Y) vs. Arsenic (X), Cor =", 
		cor.vec[2]), 
	paste("Strontium (Y) vs. Mercury (X), Cor =",
		cor.vec[3])
	),  
	col = c("blue", "red", "green"), pch = 1, 
	lty = 1, cex = 0.8, lwd = 2, bty = "n")


rm(As, As.DQ, Hg, Hg.DQ, Sr, Sr.DQ, 
	ND.ind, lim, 
	pch.vec, levels.ND.ind, n.levels,
	i, index, cor.vec)



# NOTE:  It is easier to see what is going on by using 
#        matrix scatterplots, rather than
#        a coded scatterplot.

# Matrix scatterplots with:
# non-detects plotted at detection limit, 
# duplitcate points overlaid, 
# no regression lines, and
# no special symbols for non-detects.

dum.df <- EPA.09.Table.9.3.df[, 
	c("Arsenic.mg.per.L", "Mercury.mg.per.L", "Strontium.mg.per.L")]
names(dum.df) <- c("As (mg/L)", "Hg (mg/L)", "Sr (mg/L)")

lim <- range(dum.df, na.rm = T)

windows()
pairs(dum.df, xlim = lim, ylim = lim)


# Matrix scatterplots with:
# non-detects plotted at detection limit, 
# duplitcate points jittered, 
# regression lines included, but
# no special symbols for non-detects,
# points plotted in upper panels,
# Pearson correlations shown in lower panels.

panel <- function(x, y, factor.x = 10, factor.y = 10, ...) {
	points.w.dups(x, y, 
		factor.x = factor.x, 
		factor.y = factor.y, ...)
	abline(lm(y~x))
}

panel.cor <- function(x, y, digits=2, prefix="Cor = ", 
	cex = 2 * par("cex"), ...)
{
    usr <- par("usr"); on.exit(par(usr))
    par(usr = c(0, 1, 0, 1))
    r <- cor(x, y, use = "pairwise.complete.obs")
    txt <- format(c(r, 0.123456789), digits=digits)[1]
    txt <- paste(prefix, txt, sep="")
    text(0.5, 0.5, txt, cex = cex)
}


windows()
set.seed(233)
pairs(dum.df, upper.panel = panel, 
	lower.panel = panel.cor, 
	xlim = lim, ylim = lim)


rm(dum.df, panel, panel.cor, lim)


#################################################################


# Example 9-6, pp. 9-17 to 9-20
#------------------------------

windows()
qqPlot(EPA.09.Table.9.4.nickel.vec, ylim = c(0, 1000),
	plot.pos.con = 0, add.line = T,
	ylab = "Nickel Concentration (ppb)",
	main = "Figure 9.7.  Normal Probability Plot")

windows()
qqPlot(EPA.09.Table.9.4.nickel.vec, dist = "lnorm", 
	plot.pos.con = 0, add.line = T,
	ylab = "log(nickel) Concentration log(ppb)",
	main = "Figure 9.8.  Probability Plot of Log Transformed Nickel Data")

library(ggplot2)
library(EnvStats)
before <- c(12.2, 14.6, 13.4, 11.2, 12.7, 10.4, 15.8, 13.9, 9.5, 14.2)
after <- c(13.5, 15.2, 13.6, 12.8, 13.7, 11.3, 16.5, 13.4, 8.7, 14.6)
data <- data.frame(subject = rep(c(1:10), 2),
                                       time = rep(c("before", "after"), each = 10),
                                       score = c(before, after))
ggplot(data,aes(x=time,y=score))+geom_point()+stat_test_text(paired=TRUE)
ggplot(data,aes(x=time,y=score))+geom_point()+stat_test_text()

#####
# File:     Script - EPA09, Chapter 14 Examples.R
#
# Purpose:  Reproduce Examples in Chapter 14 of the EPA Guidance Document
#
#           USEPA. (2009).  "Statistical Analysis of Ground Water 
#             Monitoring Data at RCRA Facilities, Unified Guidance."
#             EPA 530-R-09-007.
#             Office of Resource Conservation and Recovery, 
#             Program Information and Implementation Division.
#             March 2009.
#
#           Errata are listed in:
#           USEPA. (2010).  "Errata Sheet - March 2009 Unified Guidance."
#             EPA 530/R-09-007a.
#             Office of Resource Conservation and Recovery, 
#             Program Information and Implementation Division.
#             August 9, 2010.
#
# Author:   Steven P. Millard
#
# Last
# Updated:  September 9, 2012
#####

#NOTE:  Unless otherwise noted, differences between what is shown in the
#       EPA Guidance Document and results shown here are due to the 
#       EPA Guidance Document rounding intermediate results prior to 
#       the final result.

#######################################################################################


# Example 14-1, pp. 14-5 to 14-6
#-------------------------------

head(EPA.09.Ex.14.1.manganese.df)
#  Quarter Well Manganese.ppm
#1       1 BW-1         28.14
#2       2 BW-1         29.33
#3       3 BW-1         30.45
#4       4 BW-1         32.42
#5       5 BW-1         34.37
#6       6 BW-1         33.25

Mn.df <- longToWide(EPA.09.Ex.14.1.manganese.df, 
	"Manganese.ppm", "Quarter", "Well",
	paste.row.name = TRUE)
Mn.df
#           BW-1  BW-2  BW-3  BW-4
#Quarter.1 28.14 31.41 27.15 30.46
#Quarter.2 29.33 30.27 30.24 30.60
#Quarter.3 30.45 32.57 29.14 30.96
#Quarter.4 32.42 32.77 30.59 30.70
#Quarter.5 34.37 33.03 34.88 32.71
#Quarter.6 33.25 32.18 30.53 31.76
#Quarter.7 31.02 28.85 30.33 31.85
#Quarter.8 28.50 32.88 30.42 29.58

n.Wells <- ncol(Mn.df)
windows()
matplot(y = Mn.df, type = "l", lty = 1:n.Wells, col = 1:n.Wells, lwd = 2, 
	xlim = c(0, 10), ylim = c(25, 40), 
	xlab = "Quarter", ylab = "Manganese (ppm)",
	main = "Figure 14-2. Manganese Parallel Time Series Plot")
legend(0.5, 40, names(Mn.df), lty = 1:n.Wells, 
	lwd = rep(2, n.Wells), col = 1:n.Wells)

rm(Mn.df, n.Wells)


#######################################################################################


# Example 14-2, pp. 14-9 to 14-12
#--------------------------------

# NOTE: these data are balanced (i.e., equal number of quarters per well).

# Step 1
#-------

Mn.df <- longToWide(EPA.09.Ex.14.1.manganese.df, 
	"Manganese.ppm", "Quarter", "Well",
	paste.row.name = TRUE)
Mn.df
#           BW-1  BW-2  BW-3  BW-4
#Quarter.1 28.14 31.41 27.15 30.46
#Quarter.2 29.33 30.27 30.24 30.60
#Quarter.3 30.45 32.57 29.14 30.96
#Quarter.4 32.42 32.77 30.59 30.70
#Quarter.5 34.37 33.03 34.88 32.71
#Quarter.6 33.25 32.18 30.53 31.76
#Quarter.7 31.02 28.85 30.33 31.85
#Quarter.8 28.50 32.88 30.42 29.58

Mn.w.Qtr.Means.df <- data.frame(Event.Mean = apply(Mn.df, 1, mean), Mn.df)
Mn.w.Qtr.Means.df
#          Event.Mean  BW.1  BW.2  BW.3  BW.4
#Quarter.1    29.2900 28.14 31.41 27.15 30.46
#Quarter.2    30.1100 29.33 30.27 30.24 30.60
#Quarter.3    30.7800 30.45 32.57 29.14 30.96
#Quarter.4    31.6200 32.42 32.77 30.59 30.70
#Quarter.5    33.7475 34.37 33.03 34.88 32.71
#Quarter.6    31.9300 33.25 32.18 30.53 31.76
#Quarter.7    30.5125 31.02 28.85 30.33 31.85
#Quarter.8    30.3450 28.50 32.88 30.42 29.58

Grand.Mean <- mean(unlist(Mn.df))
Grand.Mean
#[1] 31.04188


# Step 2
#-------

fit <- aov(Manganese.ppm ~ factor(Quarter), 
	data = EPA.09.Ex.14.1.manganese.df)
Residuals <- fit$residuals

new.df <- data.frame(EPA.09.Ex.14.1.manganese.df, Residuals)

longToWide(new.df, "Residuals", "Quarter", "Well", 
	paste.row.name = TRUE)
#             BW-1    BW-2    BW-3    BW-4
#Quarter.1 -1.1500  2.1200 -2.1400  1.1700
#Quarter.2 -0.7800  0.1600  0.1300  0.4900
#Quarter.3 -0.3300  1.7900 -1.6400  0.1800
#Quarter.4  0.8000  1.1500 -1.0300 -0.9200
#Quarter.5  0.6225 -0.7175  1.1325 -1.0375
#Quarter.6  1.3200  0.2500 -1.4000 -0.1700
#Quarter.7  0.5075 -1.6625 -0.1825  1.3375
#Quarter.8 -1.8450  2.5350  0.0750 -0.7650


# Step 3
#-------

windows()
qqPlot(Residuals, add.line = T,
	ylab = "Event Mean Residuals (ppm)",
	main = "Figure 14-3. Probability Plot of Manganese Sampling Event Residuals",
	cex.main = 1.1)

gofTest(Residuals, test = "ppcc")

#Results of Goodness-of-Fit Test
#-------------------------------
#
#Test Method:                     PPCC GOF
#
#Hypothesized Distribution:       Normal
#
#Estimated Parameter(s):          mean = -3.989864e-17
#                                 sd   =  1.203236e+00
#
#Estimation Method:               mvue
#
#Data:                            Residuals
#
#Sample Size:                     32
#
#Test Statistic:                  r = 0.9935174
#
#Test Statistic Parameter:        n = 32
#
#P-value:                         0.9125129
#
#Alternative Hypothesis:          True cdf does not equal the
#                                 Normal Distribution.


# Step 4
#-------
varGroupTest(Residuals ~ Quarter, data = new.df)

#Results of Hypothesis Test
#--------------------------
#
#Null Hypothesis:                 Ratio of each pair of variances = 1
#
#Alternative Hypothesis:          At least one variance differs
#
#Test Name:                       Levene's Test for
#                                 Homogenity of Variance
#
#Estimated Parameter(s):          Quarter.1 = 3.921800
#                                 Quarter.2 = 0.297000
#                                 Quarter.3 = 2.011667
#                                 Quarter.4 = 1.289933
#                                 Quarter.5 = 1.087092
#                                 Quarter.6 = 1.264600
#                                 Quarter.7 = 1.614558
#                                 Quarter.8 = 3.473700
#
#Data:                            Residuals
#
#Grouping Variable:               Quarter
#
#Data Source:                     new.df
#
#Sample Sizes:                    Quarter.1 = 4
#                                 Quarter.2 = 4
#                                 Quarter.3 = 4
#                                 Quarter.4 = 4
#                                 Quarter.5 = 4
#                                 Quarter.6 = 4
#                                 Quarter.7 = 4
#                                 Quarter.8 = 4
#
#Test Statistic:                  F = 1.299012
#
#Test Statistic Parameters:       num df   =  7
#                                 denom df = 24
#
#P-value:                         0.2930252


# Steps 5-7
#----------

anova.fit <- anova(fit)
anova.fit
#Analysis of Variance Table
#
#Response: Mn
#                Df Sum Sq Mean Sq F value   Pr(>F)   
#factor(Quarter)  7 52.861  7.5516  4.0382 0.004685 **
#Residuals       24 44.881  1.8700                    
#---
#Signif. codes:  0 *** 0.001 ** 0.01 * 0.05 . 0.1   1 


# Step 8
#-------

n.Wells <- ncol(Mn.df)
n.Qtrs  <- nrow(Mn.df)

Adj.SD <- sqrt( (1/n.Wells) * ( 
	anova.fit["factor(Quarter)", "Mean Sq"] + 
		(n.Wells - 1) * anova.fit["Residuals", "Mean Sq"] ) )
Adj.SD
#[1] 1.813955

#NOTE:  Equation [14.13] for the effective sample size is updated in the
#       EPA Errata Sheet.  All occurrences of T are replaced with TK.

F.T <- anova.fit["factor(Quarter)", "F value"]
Effective.n <- 1 + ( 
	( n.Qtrs * (n.Qtrs - 1) * (F.T + n.Wells - 1)^2 ) / 
	( n.Qtrs * F.T^2 + (n.Qtrs - 1) * (n.Wells - 1) )
	)

Effective.n
#[1] 19.31570


rm(Mn.df, Mn.w.Qtr.Means.df, Grand.Mean, 
	fit, Residuals, new.df, 
	anova.fit, n.Wells, n.Qtrs, Adj.SD, F.T, Effective.n)


#####################################################################################


# Example 14-3, pp. 14-14 to 14-16
#---------------------------------

# Step 1
#-------

head(EPA.09.Ex.14.3.alkalinity.df)
#        Date Alkalinity.mg.per.L
#1 1996-01-26                1400
#2 1996-02-20                1700
#3 1996-03-19                1900
#4 1996-04-22                1800
#5 1996-05-22                1300
#6 1996-06-24                2000

Alk  <- EPA.09.Ex.14.3.alkalinity.df$Alkalinity.mg.per.L
Date <- EPA.09.Ex.14.3.alkalinity.df$Date

windows()
plot(Date, Alk, type = "b", pch = 16,
	xlab = "Sampling Date", ylab = "Total Alkalinity (mg/L)",
	main = "Figure 14-4. Time Series Plot of Total Alkalinity (mg/L)")


# Steps 2-5
#----------
windows()
acf.list <- acf(Alk, 
	main = "Figure 14-5. Sample Autocorrelation Function for Total Alkalinity",
	cex.main = 1.1)
acf.list
#
#Autocorrelations of series Alk, by lag
#
#     0      1      2      3      4      5      6      7      8      9     10 
# 1.000  0.641  0.313  0.043 -0.230 -0.453 -0.496 -0.374 -0.174  0.040  0.171 
#    11     12     13     14     15     16     17 
# 0.303  0.416  0.368  0.228 -0.015 -0.175 -0.382

rm(Alk, Date, acf.list)


######################################################################################


# Example 14-4, p. 14-18
#-----------------------

serialCorrelationTest(EPA.09.Ex.14.4.arsenic.df$Arsenic.ppb)
#
#Results of Hypothesis Test
#--------------------------
#
#Null Hypothesis:                 rho = 0
#
#Alternative Hypothesis:          True rho is not equal to 0
#
#Test Name:                       Rank von Neumann Test for
#                                 Lag-1 Autocorrelation
#                                 (Beta Approximation)
#
#Estimated Parameter(s):          rho = 0.1084613
#
#Estimation Method:               Yule-Walker
#
#Data:                            EPA.09.Ex.14.4.arsenic.df$Arsenic.ppb
#
#Sample Size:                     16
#
#Test Statistic:                  RVN = 1.670588
#
#P-value:                         0.5051189
#
#Confidence Interval for:         rho
#
#Confidence Interval Method:      Normal Approximation
#
#Confidence Interval Type:        two-sided
#
#Confidence Level:                95%
#
#Confidence Interval:             LCL = -0.3786391
#                                 UCL =  0.5955617


####################################################################################


# Example 14-8, p. 14-32 to 14-33
#--------------------------------


# NOTE: The Adjusted Concentrations are already part of EPA.09.Ex.14.8.df.
#       In this example, we will recreate them.

head(EPA.09.Ex.14.8.df)
#     Month Year Unadj.Conc Adj.Conc
#1  January 1983       1.99     2.11
#2 February 1983       2.10     2.14
#3    March 1983       2.12     2.10
#4    April 1983       2.12     2.13
#5      May 1983       2.11     2.12
#6     June 1983       2.15     2.12

Unadj.df <- longToWide(EPA.09.Ex.14.8.df, "Unadj.Conc", "Month", "Year")
Unadj.df
#          1983 1984 1985
#January   1.99 2.01 2.15
#February  2.10 2.10 2.17
#March     2.12 2.17 2.27
#April     2.12 2.13 2.23
#May       2.11 2.13 2.24
#June      2.15 2.18 2.26
#July      2.19 2.25 2.31
#August    2.18 2.24 2.32
#September 2.16 2.22 2.28
#October   2.08 2.13 2.22
#November  2.05 2.08 2.19
#December  2.08 2.16 2.22

Monthly.Avg <- apply(Unadj.df, 1, mean)
Three.Yr.Mean <- mean(EPA.09.Ex.14.8.df$Unadj.Conc)
Adj.df <- round(Unadj.df - Monthly.Avg + Three.Yr.Mean, 2)

names(Unadj.df) <- paste("Unadj", names(Unadj.df), sep = ".")
names(Adj.df) <- paste("Adj", names(Adj.df), sep = ".")

EPA.df <- data.frame(Unadj.df, Monthly.Avg = round(Monthly.Avg, 2), Adj.df)
EPA.df
#          Unadj.1983 Unadj.1984 Unadj.1985 Monthly.Avg Adj.1983 Adj.1984 Adj.1985
#January         1.99       2.01       2.15        2.05     2.11     2.13     2.27
#February        2.10       2.10       2.17        2.12     2.14     2.14     2.21
#March           2.12       2.17       2.27        2.19     2.10     2.15     2.25
#April           2.12       2.13       2.23        2.16     2.13     2.14     2.24
#May             2.11       2.13       2.24        2.16     2.12     2.14     2.25
#June            2.15       2.18       2.26        2.20     2.12     2.15     2.23
#July            2.19       2.25       2.31        2.25     2.11     2.17     2.23
#August          2.18       2.24       2.32        2.25     2.10     2.16     2.24
#September       2.16       2.22       2.28        2.22     2.11     2.17     2.23
#October         2.08       2.13       2.22        2.14     2.10     2.15     2.24
#November        2.05       2.08       2.19        2.11     2.11     2.14     2.25
#December        2.08       2.16       2.22        2.15     2.09     2.17     2.23

round(Three.Yr.Mean, 2)
#[1] 2.17


# Now plot the data

Unadj.Conc <- EPA.09.Ex.14.8.df$Unadj.Conc
Adj.Conc   <- EPA.09.Ex.14.8.df$Adj.Conc
n          <- nrow(EPA.09.Ex.14.8.df)
Time <- paste(substr(EPA.09.Ex.14.8.df$Month, 1, 3), 
	substr(EPA.09.Ex.14.8.df$Year, 3, 4), sep = "-")

windows()
par(mar = c(7, 4, 3, 1) + 0.1, cex.lab = 1.25)
plot(1:n, Unadj.Conc, type = "n", xaxt = "n",
	xlab = "Time (Month)", 
	ylab = "ANALYTE CONCENTRATION (mg/L)", 
	main = "Figure 14-15. Seasonal Time Series Over a Three Year Period",
	cex.main = 1.1)
axis(1, at = 1:n, labels = rep("", n))
at <- (1:n)[substr(Time, 1, 3) %in% c("Jan", "May", "Sep")]
axis(1, at = at, labels = Time[at], cex.axis = 0.8)
points(1:n, Unadj.Conc, pch = 0, type = "o", lwd = 2)
points(1:n, Adj.Conc, pch = 3, type = "o", col = 8, lwd = 2)
abline(h = Three.Yr.Mean, lwd = 2)
legend("topleft", c("Unadjusted", "Adjusted", "3-Year Mean"), bty = "n", 
	pch = c(0, 3, -1), lty = c(1, 1, 1), lwd = 2, col = c(1, 8, 1),
	inset = c(0.05, 0.01))

rm(Unadj.df, Monthly.Avg, Three.Yr.Mean, Adj.df, EPA.df, 
	Unadj.Conc, Adj.Conc, n, Time, at)


#####################################################################################


# Example 14-9, p. 14-35 to 14-36
#--------------------------------

# Step 1
#-------
Mn.df <- longToWide(EPA.09.Ex.14.1.manganese.df, 
	"Manganese.ppm", "Quarter", "Well",
	paste.row.name = TRUE)
Mn.df
#           BW-1  BW-2  BW-3  BW-4
#Quarter.1 28.14 31.41 27.15 30.46
#Quarter.2 29.33 30.27 30.24 30.60
#Quarter.3 30.45 32.57 29.14 30.96
#Quarter.4 32.42 32.77 30.59 30.70
#Quarter.5 34.37 33.03 34.88 32.71
#Quarter.6 33.25 32.18 30.53 31.76
#Quarter.7 31.02 28.85 30.33 31.85
#Quarter.8 28.50 32.88 30.42 29.58

Mn.w.Qtr.Means.df <- data.frame(Event.Mean = apply(Mn.df, 1, mean), Mn.df)
Mn.w.Qtr.Means.df
#          Event.Mean  BW.1  BW.2  BW.3  BW.4
#Quarter.1    29.2900 28.14 31.41 27.15 30.46
#Quarter.2    30.1100 29.33 30.27 30.24 30.60
#Quarter.3    30.7800 30.45 32.57 29.14 30.96
#Quarter.4    31.6200 32.42 32.77 30.59 30.70
#Quarter.5    33.7475 34.37 33.03 34.88 32.71
#Quarter.6    31.9300 33.25 32.18 30.53 31.76
#Quarter.7    30.5125 31.02 28.85 30.33 31.85
#Quarter.8    30.3450 28.50 32.88 30.42 29.58

Grand.Mean <- mean(unlist(Mn.df))
Grand.Mean
#[1] 31.04188

fit <- aov(Manganese.ppm ~ factor(Quarter), 
	data = EPA.09.Ex.14.1.manganese.df)
Residuals <- fit$residuals

new.EPA.df <- data.frame(EPA.09.Ex.14.1.manganese.df, Residuals)

Step.1.df <- data.frame(Event.Mean = Mn.w.Qtr.Means.df$Event.Mean, 
	longToWide(new.EPA.df, "Residuals", "Quarter", "Well", 
	paste.row.name = TRUE), check.names = FALSE)
Step.1.df
#          Event.Mean    BW-1    BW-2    BW-3    BW-4
#Quarter.1    29.2900 -1.1500  2.1200 -2.1400  1.1700
#Quarter.2    30.1100 -0.7800  0.1600  0.1300  0.4900
#Quarter.3    30.7800 -0.3300  1.7900 -1.6400  0.1800
#Quarter.4    31.6200  0.8000  1.1500 -1.0300 -0.9200
#Quarter.5    33.7475  0.6225 -0.7175  1.1325 -1.0375
#Quarter.6    31.9300  1.3200  0.2500 -1.4000 -0.1700
#Quarter.7    30.5125  0.5075 -1.6625 -0.1825  1.3375
#Quarter.8    30.3450 -1.8450  2.5350  0.0750 -0.7650


# Step 2
#-------
Step.2.df <- Step.1.df
Step.2.df[, "Event.Mean"] <- round(Step.2.df[, "Event.Mean"], 3)
Step.2.df[, -1] <- round(Step.2.df[, -1] + Grand.Mean, 2)
Step.2.df
#          Event.Mean  BW.1  BW.2  BW.3  BW.4
#Quarter.1     29.290 29.89 33.16 28.90 32.21
#Quarter.2     30.110 30.26 31.20 31.17 31.53
#Quarter.3     30.780 30.71 32.83 29.40 31.22
#Quarter.4     31.620 31.84 32.19 30.01 30.12
#Quarter.5     33.748 31.66 30.32 32.17 30.00
#Quarter.6     31.930 32.36 31.29 29.64 30.87
#Quarter.7     30.512 31.55 29.38 30.86 32.38
#Quarter.8     30.345 29.20 33.58 31.12 30.28


# Step 3
#-------
n.Wells <- ncol(Step.2.df)
windows()
matplot(y = Step.2.df[, -1], type = "l", 
	lty = 1:n.Wells, col = 1:n.Wells, lwd = 2, 
	xlim = c(0, 10), ylim = c(28, 36), 
	xlab = "Quarter", ylab = "Adjusted Manganese (ppm)",
	main = "Figure 14-16. Parallel Time Series Plot of Adjusted Manganese Concentrations", 
	cex.main = 1.1)
legend("topleft", names(Step.2.df[, -1]), lty = 1:n.Wells, 
	lwd = rep(2, n.Wells), col = 1:n.Wells, bty = "n")

rm(Mn.df, Mn.w.Qtr.Means.df, Grand.Mean, fit, Residuals, 
	new.EPA.df, Step.1.df, Step.2.df, n.Wells)


#####################################################################################


# Example 14-10, p. 14-38 to 14-40
#---------------------------------

kendallSeasonalTrendTest(Unadj.Conc ~ Month + Year, 
	data = EPA.09.Ex.14.8.df)


#Results of Hypothesis Test
#--------------------------
#
#Null Hypothesis:                 All 12 values of tau = 0
#
#Alternative Hypothesis:          The seasonal taus are not all equal
#                                 (Chi-Square Heterogeneity Test)
#                                 At least one seasonal tau != 0
#                                 and all non-zero tau's have the
#                                 same sign (z Trend Test)
#
#Test Name:                       Seasonal Kendall Test for Trend
#                                 (with continuity correction)
#
#Estimated Parameter(s):          tau       =    0.9722222
#                                 slope     =    0.0600000
#                                 intercept = -131.7350000
#
#Estimation Method:               tau:        Weighted Average of
#                                             Seasonal Estimates
#                                 slope:      Hirsch et al.'s
#                                             Modification of
#                                             Thiel/Sen Estimator
#                                 intercept:  Median of
#                                             Seasonal Estimates
#
#Data:                            y      = Unadj.Conc
#                                 season = Month     
#                                 year   = Year      
#
#Data Source:                     EPA.09.Ex.14.8.df
#
#Sample Sizes:                    January   =  3
#                                 February  =  3
#                                 March     =  3
#                                 April     =  3
#                                 May       =  3
#                                 June      =  3
#                                 July      =  3
#                                 August    =  3
#                                 September =  3
#                                 October   =  3
#                                 November  =  3
#                                 December  =  3
#                                 Total     = 36
#
#Test Statistics:                 Chi-Square (Het) = 0.1071882
#                                 z (Trend)        = 5.1849514
#
#Test Statistic Parameter:        df = 11
#
#P-values:                        Chi-Square (Het) = 1.000000e+00
#                                 z (Trend)        = 2.160712e-07
#
#Confidence Interval for:         slope
#
#Confidence Interval Method:      Gilbert's Modification of
#                                 Theil/Sen Method
#
#Confidence Interval Type:        two-sided
#
#Confidence Level:                95%
#
#Confidence Interval:             LCL = 0.05786914
#                                 UCL = 0.07213086

#####
# File:     Script - EPA09, Chapter 10 Examples.R
#
# Purpose:  Reproduce Examples in Chapter 10 of the EPA Guidance Document
#
#           USEPA. (2009).  "Statistical Analysis of Ground Water 
#             Monitoring Data at RCRA Facilities, Unified Guidance."
#             EPA 530-R-09-007.
#             Office of Resource Conservation and Recovery, 
#             Program Information and Implementation Division.
#             March 2009.
#
#           Errata are listed in:
#           USEPA. (2010).  "Errata Sheet - March 2009 Unified Guidance."
#             EPA 530/R-09-007a.
#             Office of Resource Conservation and Recovery, 
#             Program Information and Implementation Division.
#             August 9, 2010.
#
# Author:   Steven P. Millard
#
# Last
# Updated:  August 24, 2012
#####

#NOTE:  Unless otherwise noted, differences between what is shown in the
#       EPA Guidance Document and results shown here are due to the 
#       EPA Guidance Document rounding intermediate results prior to 
#       the final result.

#######################################################################################

library(EnvStats)

# Example 10-1, pp. 10-11 to 10-12
#---------------------------------

#NOTE: By default, EnvironmentalStats computes the skew using the 
#      Fisher method, whereas the example here uses the 
#      method of moments; thus the need to use the skew.list
#      argument in the call to summaryFull.

# Just Mean, SD, CV, and Skew:

summaryFull(Nickel.ppb ~ 1, data = EPA.09.Ex.10.1.nickel.df,
	stats = c("n", "mean", "sd", "cv", "skew"),
	skew.list = list(method="moment"), data.name = "Nickel")
#                         Nickel
#N                         20       
#Mean                     169.5     
#Skew                       1.843   
#Standard Deviation       259.7     
#Coefficient of Variation   1.532


# All summary stats:

summaryFull(Nickel.ppb ~ 1, data = EPA.09.Ex.10.1.nickel.df,
	skew.list = list(method="moment"), data.name = "Nickel")
#                             Nickel
#N                             20       
#Mean                         169.5     
#Median                        57.4     
#10% Trimmed Mean             113       
#Geometric Mean                50.33    
#Skew                           1.843   
#Kurtosis                       3.417   
#Min                            1       
#Max                          942       
#Range                        941       
#1st Quartile                  17.75    
#3rd Quartile                 178.8     
#Standard Deviation           259.7     
#Geometric Standard Deviation   6.058   
#Interquartile Range          161.1     
#Median Absolute Deviation     67.31    
#Coefficient of Variation       1.532


summaryFull(log(Nickel.ppb) ~ 1, data = EPA.09.Ex.10.1.nickel.df,
	stats = c("n", "mean", "sd", "cv", "skew"),
	skew.list = list(method="moment"), data.name = "log(Nickel)")
#                         log(Nickel)
#N                        20             
#Mean                      3.919         
#Skew                     -0.245         
#Standard Deviation        1.801         
#Coefficient of Variation  0.4597


################################################################


# Example 10-2, pp. 10-14 to 10-15
#---------------------------------

gofTest(EPA.09.Ex.10.1.nickel.df$Nickel, data.name.x = "Nickel")

#Results of Goodness-of-Fit Test
#-------------------------------
#
#Test Method:                     Shapiro-Wilk GOF
#
#Hypothesized Distribution:       Normal
#
#Estimated Parameter(s):          mean = 169.5250
#                                 sd   = 259.7175
#
#Estimation Method:               mvue
#
#Data:                            Nickel
#
#Sample Size:                     20
#
#Test Statistic:                  W = 0.6788888
#
#Test Statistic Parameter:        n = 20
#
#P-value:                         2.17927e-05
#
#Alternative Hypothesis:          True cdf does not equal the
#                                 Normal Distribution.


###################################################################


# Example 10-3, pp. 10-17 to 10-18
#---------------------------------

gofTest(EPA.09.Ex.10.1.nickel.df$Nickel, data.name.x = "Nickel", 
	test = "ppcc")

#Results of Goodness-of-Fit Test
#-------------------------------
#
#Test Method:                     PPCC GOF
#
#Hypothesized Distribution:       Normal
#
#Estimated Parameter(s):          mean = 169.5250
#                                 sd   = 259.7175
#
#Estimation Method:               mvue
#
#Data:                            Nickel
#
#Sample Size:                     20
#
#Test Statistic:                  r = 0.8199825
#
#Test Statistic Parameter:        n = 20
#
#P-value:                         5.753418e-05
#
#Alternative Hypothesis:          True cdf does not equal the
#                                 Normal Distribution.


######################################################################


# Example 10-4, pp. 10-20 to 10-21
#---------------------------------

#NOTE: The table shown on page 10-12 shows nickel
#      concentrations by Month and Year.  However, 
#      the EPA Errata Sheet states "Year" should be "Well".
#
#      The table on page 10-21 shows values that 
#      correspond to the log-transformed values shown in 
#      the table on page 10-12.  However, the table on page 10-21
#      is labeled with Well number for the columns (not Year number),
#      and Month is labeled as 1, 2, 3, 4, 5 instead of 
#      Jan, Mar, Jun, Aug, Oct.
#
#      In this script, we will use the data in the table 
#      shown on page 10-12, and do a group test by Well.
#
#      NOTE: The Shapiro-Wilk statistics by Well shown on 
#            page 10-20 are incorrect, as is the overall group statistic.
#            However, the EPA Errata Sheet shows correct statistics.
 

# Show Shapiro-Wilks statistics by Well

SW.stats <- sapply(split(EPA.09.Ex.10.1.nickel.df$Nickel.ppb, 
	EPA.09.Ex.10.1.nickel.df$Well), 
	function(x) gofTest(x)$statistic)
round(SW.stats, 4)
#Well.1.W Well.2.W Well.3.W Well.4.W 
#  0.7578   0.7397   0.7066   0.8150 

rm(SW.stats)


gofGroupTest(Nickel.ppb ~ Well, data = EPA.09.Ex.10.1.nickel.df)

#Results of Group Goodness-of-Fit Test
-------------------------------------
#
#Test Method:                     Wilk-Shapiro GOF (Normal Scores)
#
#Hypothesized Distribution:       Normal
#
#Data:                            Nickel.ppb
#
#Grouping Variable:               Well
#
#Data Source:                     EPA.09.Ex.10.1.nickel.df
#
#Number of Groups:                4
#
#Sample Sizes:                    Well.1 = 5
#                                 Well.2 = 5
#                                 Well.3 = 5
#                                 Well.4 = 5
#
#Test Statistic:                  z (G) = -3.658696
#
#P-values for
#Individual Tests:                Well.1 = 0.03510747
#                                 Well.2 = 0.02385344
#                                 Well.3 = 0.01120775
#                                 Well.4 = 0.10681461
#
#P-value for
#Group Test:                      0.0001267509
#
#Alternative Hypothesis:          At least one group
#                                 does not come from a
#                                 Normal Distribution.


###################################################################


# Example 10-5, pp. 10-21 to 10-24
#---------------------------------


summaryFull(log(Nickel.ppb) ~ 1, data = EPA.09.Ex.10.1.nickel.df, 
	stats = c("n", "mean", "sd", "cv", "skew"),
	skew.list = list(method="moment"))
#                         log(Nickel.ppb)
#N                        20             
#Mean                      3.919         
#Skew                     -0.245         
#Standard Deviation        1.801         
#Coefficient of Variation  0.4597


gofTest(EPA.09.Ex.10.1.nickel.df$Nickel.ppb, dist = "lnorm", 
	data.name.x = "Nickel")

#Results of Goodness-of-Fit Test
#-------------------------------
#
#Test Method:                     Shapiro-Wilk GOF
#
#Hypothesized Distribution:       Lognormal
#
#Estimated Parameter(s):          meanlog = 3.918529
#                                 sdlog   = 1.801404
#
#Estimation Method:               mvue
#
#Data:                            Nickel
#
#Sample Size:                     20
#
#Test Statistic:                  W = 0.978946
#
#Test Statistic Parameter:        n = 20
#
#P-value:                         0.9197735
#
#Alternative Hypothesis:          True cdf does not equal the
#                                 Lognormal Distribution.


gofTest(EPA.09.Ex.10.1.nickel.df$Nickel, test = "ppcc", 
	dist = "lnorm", data.name.x = "Nickel")

#Results of Goodness-of-Fit Test
#-------------------------------
#
#Test Method:                     PPCC GOF
#
#Hypothesized Distribution:       Lognormal
#
#Estimated Parameter(s):          meanlog = 3.918529
#                                 sdlog   = 1.801404
#
#Estimation Method:               mvue
#
#Data:                            Nickel
#
#Sample Size:                     20
#
#Test Statistic:                  r = 0.9912528
#
#Test Statistic Parameter:        n = 20
#
#P-value:                         0.9187852
#
#Alternative Hypothesis:          True cdf does not equal the
#                                 Lognormal Distribution.

#####
# File:     Script - EPA09, Chapter 22 Examples.R
#
# Purpose:  Reproduce Examples in Chapter 22 of the EPA Guidance Document
#
#           USEPA. (2009).  "Statistical Analysis of Ground Water 
#             Monitoring Data at RCRA Facilities, Unified Guidance."
#             EPA 530-R-09-007.
#             Office of Resource Conservation and Recovery, 
#             Program Information and Implementation Division.
#             March 2009.
#
#           Errata are listed in:
#           USEPA. (2010).  "Errata Sheet - March 2009 Unified Guidance."
#             EPA 530/R-09-007a.
#             Office of Resource Conservation and Recovery, 
#             Program Information and Implementation Division.
#             August 9, 2010.
#
# Author:   Steven P. Millard
#
# Last
# Updated:  October 4, 2012
#####

#NOTE:  Unless otherwise noted, differences between what is shown in the
#       EPA Guidance Document and results shown here are due to the 
#       EPA Guidance Document rounding intermediate results prior to 
#       the final result.

#######################################################################################

library(EnvStats)

# Example 22-1, pp. 22-6 to 22-8
#-------------------------------

EPA.09.Ex.22.1.VC.df
#   Year Quarter     Period Well VC.ppb
#1     1       1 Background GW-1    6.3
#2     1       2 Background GW-1    9.5
#3     1       3 Background GW-1    8.1
#4     1       4 Background GW-1   11.9
#5     2       1 Compliance GW-1    7.3
#6     2       2 Compliance GW-1   11.2
#7     2       3 Compliance GW-1    6.0
#8     2       4 Compliance GW-1    7.5
#9     3       1 Compliance GW-1    8.4
#10    3       2 Compliance GW-1    6.4
#11    3       3 Compliance GW-1    8.9
#12    3       4 Compliance GW-1    4.9
#13    4       1 Compliance GW-1    9.6
#14    4       2 Compliance GW-1    9.7
#15    4       3 Compliance GW-1    8.7
#16    4       4 Compliance GW-1    8.7
#17    1       1 Background GW-2    5.9
#18    1       2 Background GW-2    3.0
#19    1       3 Background GW-2    8.8
#20    1       4 Background GW-2   12.0
#21    2       1 Compliance GW-2   11.2
#22    2       2 Compliance GW-2    8.6
#23    2       3 Compliance GW-2   12.6
#24    2       4 Compliance GW-2    7.2
#25    3       1 Compliance GW-2   13.8
#26    3       2 Compliance GW-2    5.6
#27    3       3 Compliance GW-2   11.0
#28    3       4 Compliance GW-2    9.8
#29    4       1 Compliance GW-2    6.3
#30    4       2 Compliance GW-2   10.4
#31    4       3 Compliance GW-2    7.5
#32    4       4 Compliance GW-2    9.7



# Step 1:  Summary Statistics and Time Series Plots
#--------------------------------------------------


# Summary Statistics by Well
#---------------------------

summaryStats(VC.ppb ~ Well, data = EPA.09.Ex.22.1.VC.df, 
	combine.groups = TRUE, digits = 1, stats.in.rows = TRUE)
#       GW-1 GW-2 Combined
#N      16   16   32      
#Mean    8.3  9    8.6    
#SD      1.9  2.9  2.4    
#Median  8.6  9.2  8.7    
#Min     4.9  3    3      
#Max    11.9 13.8 13.8 


# Summary Statistics by Period and Well
#--------------------------------------
VC     <- EPA.09.Ex.22.1.VC.df$VC.ppb
Period <- EPA.09.Ex.22.1.VC.df$Period
Well   <- EPA.09.Ex.22.1.VC.df$Well

summaryStats(VC, group = paste(Well, Period, sep = "."), 
	combine.groups = FALSE, stats.in.rows = TRUE, digits = 1)
#       GW-1.Background GW-1.Compliance GW-2.Background GW-2.Compliance
#N       4              12               4              12             
#Mean    8.9             8.1             7.4             9.5           
#SD      2.4             1.8             3.9             2.5           
#Median  8.8             8.6             7.4             9.8           
#Min     6.3             4.9             3               5.6           
#Max    11.9            11.2            12              13.8


# Group Shapiro-Wilk Test Shows p-values for Individual Wells
#------------------------------------------------------------

gofGroupTest(VC.ppb ~ Well, data = EPA.09.Ex.22.1.VC.df)
#
#Results of Group Goodness-of-Fit Test
#-------------------------------------
#
#Test Method:                     Wilk-Shapiro GOF (Normal Scores)
#
#Hypothesized Distribution:       Normal
#
#Data:                            VC.ppb
#
#Grouping Variable:               Well
#
#Data Source:                     EPA.09.Ex.22.1.VC.df
#
#Number of Groups:                2
#
#Sample Sizes:                    GW-1 = 16
#                                 GW-2 = 16
#
#Test Statistic:                  z (G) = 2.901581
#
#P-values for
#Individual Tests:                GW-1 = 0.9686679
#                                 GW-2 = 0.9875157
#
#P-value for
#Group Test:                      0.9981436
#
#Alternative Hypothesis:          At least one group
#                                 does not come from a
#                                 Normal Distribution.



# Time Series Plot
#-----------------
Year   <- EPA.09.Ex.22.1.VC.df$Year
Qtr    <- EPA.09.Ex.22.1.VC.df$Quarter

n1 <- sum(Well == "GW-1")
n2 <- sum(Well == "GW-2")
windows()
plot(1:n1, VC[Well == "GW-1"], xaxt = "n", 
	type = "b", pch = 15, lwd = 2, 
	ylim = c(0, 20),
	xlab = "Time (Years)",
	ylab = "Vinyl Chloride Concentration (ppb)",
	main = "Figure 22-1. Vinyl Chloride Time Series Plot")
	
axis(1, at = (1:n1)[Qtr == 1 & Well == "GW-1"], 
	labels = Year[Qtr == "1" & Well == "GW-1"])
points(1:n2, VC[Well == "GW-2"], type = "b", pch = 3, lty = 3, lwd = 2)
abline(h = 5, lty = 2, lwd = 2)
legend(1, 20, c("GW-1", "GW-2", "MCL = 5 ppb"), 
	pch = c(15, 3, 1), lty = c(1, 3, 2), 
	pt.cex = c(1, 1, 0), lwd = 2)



# Step 2:  Determine Type I Error level necessary in order to achieve
#          80% power to detect an increase in mean VC of 2 times
#          the 5 ppb GWPS based on n=4 observations.
#          Then compute one-sided lower confidence limits
#          for each well using the Year 2 data based on 
#          this Type I error level. 
#--------------------------------------------------------------------

R   <- 2
mu0 <- 5


# Approach 1:  
# Based on Guidance Document Method That *Does Not* Require
# an Estimate of SD or CV.  This method assumes:
# 1) sigma = mean under null hypothesis
# 2) delta/sigma = R - 1, where R is the ratio of the alternative mean
#    to the null mean
#------------------------------------------------------------------

required.alpha <- tTestAlpha(n.or.n1 = 4, 
	delta.over.sigma = R-1, power = 0.8, 
	sample.type = "one.sample", 
	alternative = "greater")
required.alpha
#[1] 0.1633382


# Lower one-sided confidence limits for Well GW-1:

enorm(VC[Well == "GW-1" & Year == "2"], ci = T, ci.type = "lower", 
	conf.level = 1 - required.alpha)$interval$limits["LCL"]
#     LCL 
#6.693358


# Lower one-sided confidence limits for Well GW-2:

enorm(VC[Well == "GW-2" & Year == "2"], ci = T, ci.type = "lower", 
	conf.level = 1 - required.alpha)$interval$limits["LCL"]
#     LCL 
#8.469282



# Approach 2:  
# Based on standard method that requires an estimate of SD or CV. 
#----------------------------------------------------------------

# Estimate standard deviation of VC based on Background data.
# Pool estimate of SDs based on both wells (GW-1 and GW-2)

VC.fit <- lm(VC.ppb ~ Well, data = EPA.09.Ex.22.1.VC.df, 
	subset = Period == "Background")
SD.Background <- summary(VC.fit)$sigma
SD.Background
#[1] 3.200976

#NOTE:  Note that the estimated SD of 3.2 ppb is much smaller than the 
#       assumed value of 5 ppb based on Approach 1 above.

tTestAlpha(n.or.n1 = 4, 
	delta.over.sigma = mu0 * (R - 1) / SD.Background, 
	power = 0.8, 
	sample.type = "one.sample", 
	alternative = "greater", approx = F)
#[1] 0.05767842

#NOTE:  Note the required Type I Error level based on Approach 2
#       is much smaller than that based on Approach 1.



# Step 3:  Compute one-sided lower confidence limits for each well
#          using the Year 2 data based on Type I Error Level = 0.01. 
#-------------------------------------------------------------------

# Use alpha = 0.01

# Lower one-sided confidence limits for Well GW-1:

enorm(VC[Well == "GW-1" & Year == "2"], ci = T, ci.type = "lower", 
	conf.level = 0.99)$interval$limits["LCL"]
#     LCL 
#2.926725


# Lower one-sided confidence limits for Well GW-2:

enorm(VC[Well == "GW-2" & Year == "2"], ci = T, ci.type = "lower", 
	conf.level = 0.99)$interval$limits["LCL"]
#    LCL 
#4.34498



# Step 4:  Determine Type I Error level necessary in order to achieve
#          80% power to detect an increase in mean VC of 2 times
#          the 5 ppb GWPS based on n=8 observations.
#          Then compute one-sided lower confidence limits
#          for each well using the Year 1 and Year 2 data based on 
#          this Type I error level. 
#--------------------------------------------------------------------

required.alpha <- tTestAlpha(n.or.n1 = 8, 
	delta.over.sigma = R-1, power = 0.8, 
	sample.type = "one.sample", 
	alternative = "greater")
required.alpha
#[1] 0.0458989

# Lower one-sided confidence limits for Well GW-1:

enorm(VC[Well == "GW-1" & Year %in% c("1", "2")], ci = T, ci.type = "lower", 
	conf.level = 1 - required.alpha)$interval$limits["LCL"]
#     LCL 
#6.963887


# Lower one-sided confidence limits for Well GW-2:

enorm(VC[Well == "GW-2" & Year %in% c("1", "2")], ci = T, ci.type = "lower", 
	conf.level = 1 - required.alpha)$interval$limits["LCL"]
#     LCL 
#6.403578 



# Step 5:  Compute one-sided lower confidence limits
#          for each well using the Year 2 and Year 3 data based on 
#          Type I error level from Step 4. 
#--------------------------------------------------------------------

# Lower one-sided confidence limits for Well GW-1:

enorm(VC[Well == "GW-1" & Year %in% c("2", "3")], ci = T, ci.type = "lower", 
	conf.level = 1 - required.alpha)$interval$limits["LCL"]
#     LCL 
#6.227279


# Lower one-sided confidence limits for Well GW-2:

enorm(VC[Well == "GW-2" & Year %in% c("2", "3")], ci = T, ci.type = "lower", 
	conf.level = 1 - required.alpha)$interval$limits["LCL"]
#     LCL 
#8.078256  



# Step 6:  Determine Type I Error level necessary in order to achieve
#          80% power to detect an increase in mean VC of 2 times
#          the 5 ppb GWPS based on n=12 observations.
#          Then compute one-sided lower confidence limits
#          for each well using the Years 2-4 data based on 
#          this Type I error level. 
#--------------------------------------------------------------------

required.alpha <- tTestAlpha(n.or.n1 = 12, 
	delta.over.sigma = R-1, power = 0.8, 
	sample.type = "one.sample", 
	alternative = "greater")
required.alpha
#[1] 0.01311214


# Lower one-sided confidence limits for Well GW-1:

enorm(VC[Well == "GW-1" & Year != "1"], ci = T, ci.type = "lower", 
	conf.level = 1 - required.alpha)$interval$limits["LCL"]
#     LCL 
#6.798091


# Lower one-sided confidence limits for Well GW-2:

enorm(VC[Well == "GW-2" & Year != "1"], ci = T, ci.type = "lower", 
	conf.level = 1 - required.alpha)$interval$limits["LCL"]
#     LCL 
#7.609904 



rm(Year, Qtr, Period, Well, VC, n1, n2, 
	R, mu0, required.alpha, VC.fit, SD.Background)



#########################################################################################


# Example 22-2, pp. 22-11 to 22-17
#---------------------------------

EPA.09.Ex.22.2.Specific.Conductance.df
#    Well       Date Specific.Conductance.umho
#1  GW-12 1987-10-16                      2100
#2  GW-12 1988-01-28                      2550
#   ...
#42 GW-13 1992-12-01                       530
#43 GW-13 1993-03-24                       625

Well <- EPA.09.Ex.22.2.Specific.Conductance.df$Well
Date <- EPA.09.Ex.22.2.Specific.Conductance.df$Date
SC   <- EPA.09.Ex.22.2.Specific.Conductance.df$Specific.Conductance.umho


#Step 1:  Time series plot for Well GW-12
#---------------------------------------

index <- Well == "GW-12"

windows()
plot(Date[index], SC[index], ylim = c(0, 3000), 
	xlab = "Sampling Date", 
	ylab = "Specific Conductance (umho)",
	main = "Figure 22-3. Time Series Plot of \nSpecific Conductance Measurements at GW-12")


#Step 2:  Fit regression line
#----------------------------

SC.fit <- lm(Specific.Conductance.umho ~ Date, 
	data = EPA.09.Ex.22.2.Specific.Conductance.df, 
	subset = Well == "GW-12")

summary(SC.fit)$coef
#               Estimate   Std. Error  t value     Pr(>|t|)
#(Intercept) 9526.116147 1042.1592274  9.14075 3.493624e-08
#Date          -1.087567    0.1384346 -7.85618 3.170120e-07

# NOTE:  These estimates of slope and intercept differ from those in the 
#        Guidance Document because our time variable is in terms of 
#        days since Jan 1, 1970, where as the units of time in the 
#        Guidance Document is Years.


windows()
plot(Date[index], SC[index], ylim = c(0, 3000), 
	xlab = "Sampling Date", 
	ylab = "Specific Conductance (umho)",
	main = "Figure 22-4. Regression of Specific Conductance vs.\nSampling Date at GW-12")
abline(SC.fit)


# Step 3:  Examine residuals
#---------------------------

windows()
qqPlot(SC.fit$residuals, xlab = "Z-score", add.line = T, 
	ylab = "Specific Conductance Residuals",
	main = "Figure 22-5. Probability Plot of \nSpecific Conductance Residuals at GW-12")

gofTest(SC.fit$residuals)
#
#Results of Goodness-of-Fit Test
#-------------------------------
#
#Test Method:                     Shapiro-Wilk GOF
#
#Hypothesized Distribution:       Normal
#
#Estimated Parameter(s):          mean = 3.538836e-16
#                                 sd   = 3.790014e+02
#
#Estimation Method:               mvue
#
#Data:                            SC.fit$residuals
#
#Sample Size:                     20
#
#Test Statistic:                  W = 0.960157
#
#Test Statistic Parameter:        n = 20
#
#P-value:                         0.5469918
#
#Alternative Hypothesis:          True cdf does not equal the
#                                 Normal Distribution.

windows()
plot(Date[index], SC.fit$residuals, xlab = "Sampling Date", 
	ylab = "Specific Conductance Residuals",
	main = "Figure 22-6. Plot of Specific Conductance Residuals vs. \nSampling Date at GW-12")
abline(h = 0, lty = 2)


# Alternatively, you can use used the built-in plotting function for linear models:
#windows()
#plot(SC.fit, ask = FALSE)



# Step 4:  Plot Specific Conductance at GW-12 vs. Date, along with
#          regression line and two-sided lower and upper 90% confidence limits
#          Note that the upper confidence limit considered by itself is 
#          equivalent to a one-sided upper 95% confidence limit.
#-----------------------------------------------------------------------------

Dates.for.prediction <- seq(min(Date[index]), max(Date[index]), length = 100)
CLs <- predict(SC.fit, newdata = data.frame(Date = Dates.for.prediction),
	interval = "confidence", level = 0.9)

windows()
plot(Date[index], SC[index], ylim = c(0, 3000), 
	xlab = "Sampling Date", 
	ylab = "Specific Conductance (umho)",
	main = "Figure 22-7. Two-sided 90% Confidence Bounds \nAround Trend Line at GW-12")
abline(SC.fit, lwd = 2)
lines(Dates.for.prediction, CLs[, "lwr"], lty = 3, lwd = 2, col = 4)
lines(Dates.for.prediction, CLs[, "upr"], lty = 3, lwd = 2, col = 4)
abline(h = 1000, lty = 2, lwd = 2, col = 2)

legend(as.numeric(as.Date("1988-01-01")), 500, 
	c("Regression Line", "90% Conf Limits", "Clean-Up Std"),
	lty = c(1, 3, 2), lwd = 2, col = c(1, 4, 2))


# Step 5:  Determine when the One-sided upper 95% confidence limit
#          drops below the clean-up standard of 1000 umho.

min(Dates.for.prediction[CLs[, "upr"] < 1000])
#[1] "1991-12-18".




# Step 6: Time series plot for Well GW-13
#         Also, remove first 4 observations
#------------------------------------------

index <- Well == "GW-13"

windows()
plot(Date[index], SC[index], type = "b", 
	ylim = c(0, 2500), 
	xlab = "Sampling Date", 
	ylab = "Specific Conductance (umho)",
	main = "Figure 22-8. Time Series Plot of \nSpecific Conductance Measurements at GW-13")
 
new.index <- index & (Date > Date[index][4])



# Step 7: Test normality of GW-13 data
#-------------------------------------

# Using all the data

gof.obj <- gofTest(SC[index])
gof.obj[c("statistic", "p.value")]
#$statistic
#        W 
#0.5809712 
#
#$p.value
#[1] 5.617319e-07

windows()
plot(gof.obj, plot.type = "Q-Q Plot",
	ylab = "Specific Conductance (umho)", 
	main = "Figure 22-9. Probability Plot at GW-13\nUsing Entire Sampling Record")


# Omitting the first 4 observations
#----------------------------------
gof.obj <- gofTest(SC[new.index])
gof.obj[c("statistic", "p.value")]
#$statistic
#        W 
#0.9542246 
#
#$p.value
#[1] 0.4647555

windows()
plot(gof.obj, plot.type = "Q-Q Plot",
	ylab = "Specific Conductance (umho)", 
	main = "Figure 22-10. Probability Plot at GW-13\nExcluding First Four Measures")


# Step 8:  Compute One-sided upper 95% confidence bounds for 
#          mean Specific Conductance at Well GW-13 using the first 8 
#          observations, and then omitting the first 4 observations
#--------------------------------------------------------------------

# Using the first 8 observations
enorm(SC[index][1:8], ci = T, ci.type = "upper")$interval$limits["UCL"]
#     UCL 
#1327.572 


# Using observations 5 to 8
enorm(SC[index][5:8], ci = T, ci.type = "upper")$interval$limits["UCL"]
#     UCL 
#515.3008



# Step 9:  Compute One-sided upper 95% confidence bounds for 
#          mean Specific Conductance at Well GW-13 using 
#          observations 5 to 12, and then using all observations 
#          except the first 4.
#--------------------------------------------------------------------


# Using observations 5 to 12
enorm(SC[index][5:12], ci = T, ci.type = "upper")$interval$limits["UCL"]
#   UCL 
#524.53


# Using all observations except the first 4
enorm(SC[new.index], ci = T, ci.type = "upper")$interval$limits["UCL"]
#     UCL 
#532.7065 



# Step 10:  Compute sample size necessary to detect a decrease in 
#           mean conductance from 1000 umho to 500 umho
#           based on estimated SD using all the data at Well GW-13
#           except the first 4 observations.
#-----------------------------------------------------------------

SD <- sd(SC[new.index])
SD
#[1] 74.27596

tTestN(delta.over.sigma = (500 - 1000) / SD, 
	alpha = 0.05, power = 0.95, 
	sample.type = "one.sample", alternative = "less", round.up = T)
#[1] 3

# NOTE:  The Guidance Document states n=6 is necessary using 
#        it's second approach.


rm(Well, Date, SC, index, SC.fit, Dates.for.prediction, 
	CLs, new.index, gof.obj, SD)



###############################################################################################


# Example 22-3, p. 22-20
#-----------------------


# Based on normal approximation to the binomial
#----------------------------------------------
propTestN(p.or.p1 = 0.3, p0.or.p2 = 0.1, alpha = 0.05, power = 0.9, 
	sample.type = "one.sample", alternative = "greater",   
	approx = T, round.up = T)
#[1] 30


# Based on exact binomial distribution
#-------------------------------------
propTestN(p.or.p1 = 0.3, p0.or.p2 = 0.1, alpha = 0.05, power = 0.9, 
	sample.type = "one.sample", alternative = "greater",   
	approx = F, round.up = T)
#$n
#[1] 34
#
#$power
#[1] 0.9214717
#
#$alpha
#[1] 0.04814433
#
#$q.critical.upper
#[1] 6


propTestN(p.or.p1 = 0.3, p0.or.p2 = 0.1, alpha = 0.07, power = 0.9,
	sample.type = "one.sample", alternative = "greater",   
	approx = F, round.up = T)
#$n
#[1] 29
#
#$power
#[1] 0.9068196
#
#$alpha
#[1] 0.06371744
#
#$q.critical.upper
#[1] 5


propTestN(p.or.p1 = 0.3, p0.or.p2 = 0.1, alpha = 0.1, power = 0.9, 
	sample.type = "one.sample", alternative = "greater",   
	approx = F, round.up = T)
#$n
#[1] 25
#
#$power
#[1] 0.909528
#
#$alpha
#[1] 0.09799362
#
#$q.critical.upper
#[1] 4


# So using the exact Binomial test, you would need a minimum sample size of 34, NOT 30,
# to detect an increase from 10% to 30% with 90% power and a Type I error of
# no greater than 5% (4.8%) in this case.
# Allowing a Type I Error of 6.3% would let us use a sample size of n=29. 


############################################################################################


# Example 22-4, pp. 22-21 to 22-22
#---------------------------------

# Step 1: Compute sample size necessary to detect a change in proprtion of
#         exceedances from 0.05 to (0.25 * 0.05) = 0.0125 using
#         a Type I error of 20% or 10% and a power of 80%
#--------------------------------------------------------------------------


k <- 0.25
p0 <- 0.05

# Based on normal approximation to the binomial
#----------------------------------------------

propTestN(p.or.p1 = k * p0, p0.or.p2 = p0, 
	alpha = 0.2, power = 0.8, 
	sample.type = "one.sample", alternative = "less",   
	approx = T, round.up = T)
#[1] 55
#Warning message:
#In propTestN(p.or.p1 = k * p0, p0.or.p2 = p0, alpha = 0.2,  :
#  The computed sample size 'n' is too small, relative to the given value of 'p', for the normal approximation to work well for the following element indices:
#         1 
    

propTestN(p.or.p1 = k * p0, p0.or.p2 = p0, 
	alpha = 0.1, power = 0.8, 
	sample.type = "one.sample", alternative = "less",   
	approx = T, round.up = T)
#[1] 99
#Warning message:
#In propTestN(p.or.p1 = k * p0, p0.or.p2 = p0, alpha = 0.1,  :
#  The computed sample size 'n' is too small, relative to the given value of 'p', for the normal approximation to work well for the following element indices:
#         1 




# Step 2a:  Compute sample size necessary to detect a change in proprtion of
#           exceedances from 0.1 to (0.25 * 0.1) = 0.025 using 
#           a Type I error of 10% and a power of 80%
#----------------------------------------------------------------------------

p0 <- 0.1

propTestN(p.or.p1 = k * p0, p0.or.p2 = p0, 
	alpha = 0.1, power = 0.8, 
	sample.type = "one.sample", alternative = "less",   
	approx = T, round.up = T)
#[1] 48
#Warning message:
#In propTestN(p.or.p1 = k * p0, p0.or.p2 = p0, alpha = 0.1, power = 0.8,  :
#  The computed sample size 'n' is too small, relative to the given value of 'p', for the normal approximation to work well for the following element indices:
#         1 


# Step 2b:  Compute sample size necessary to detect a change in proprtion of
#           exceedances from 0.05 to (0.1 * 0.05) = 0.005 using 
#           a Type I error of 10% and a power of 80%
#----------------------------------------------------------------------------

k <- 0.1
p0 <- 0.05

propTestN(p.or.p1 = k * p0, p0.or.p2 = p0, 
	alpha = 0.1, power = 0.8, 
	sample.type = "one.sample", alternative = "less",   
	approx = T, round.up = T)
#[1] 57
#Warning message:
#In propTestN(p.or.p1 = k * p0, p0.or.p2 = p0, alpha = 0.1, power = 0.8,  :
#  The computed sample size 'n' is too small, relative to the given value of 'p', for the normal approximation to work well for the following element indices:
#         1 


# Step 2c:  Compute sample size necessary to detect a change in proprtion of
#           exceedances from 0.05 to (0.1 * 0.05) = 0.005 using 
#           a Type I error of 10% and a power of 60%
#----------------------------------------------------------------------------

k  <- 0.25
p0 <- 0.05

propTestN(p.or.p1 = k * p0, p0.or.p2 = p0, 
	alpha = 0.1, power = 0.6, 
	sample.type = "one.sample", alternative = "less",   
	approx = T, round.up = T)
#[1] 68
#Warning message:
#In propTestN(p.or.p1 = k * p0, p0.or.p2 = p0, alpha = 0.1, power = 0.6,  :
#  The computed sample size 'n' is too small, relative to the given value of 'p', for the normal approximation to work well for the following element indices:
#         1 


rm(k, p0)

#####
# File:     Script - EPA09, Chapter 16 Examples.R
#
# Purpose:  Reproduce Examples in Chapter 16 of the EPA Guidance Document
#
#           USEPA. (2009).  "Statistical Analysis of Ground Water 
#             Monitoring Data at RCRA Facilities, Unified Guidance."
#             EPA 530-R-09-007.
#             Office of Resource Conservation and Recovery, 
#             Program Information and Implementation Division.
#             March 2009.
#
#           Errata are listed in:
#           USEPA. (2010).  "Errata Sheet - March 2009 Unified Guidance."
#             EPA 530/R-09-007a.
#             Office of Resource Conservation and Recovery, 
#             Program Information and Implementation Division.
#             August 9, 2010.
#
# Author:   Steven P. Millard
#
# Last
# Updated:  September 15, 2012
#####

#NOTE:  Unless otherwise noted, differences between what is shown in the
#       EPA Guidance Document and results shown here are due to the 
#       EPA Guidance Document rounding intermediate results prior to 
#       the final result.

#######################################################################################

library(EnvStats)

# Figure 16-1, p. 16-2
#---------------------

df.vec <- c(1, 3, 7, 25)
lty.vec <- c(1, 5, 4, 6)
col.vec <- 1:4
n <- length(df.vec)

windows()
pdfPlot(dist = "t", param.list = list(df = df.vec[1]), 
	curve.fill = F, xaxt = "n", 
	left.tail.cutoff = pt(-5, df = df.vec[1]), 
	right.tail.cutoff = pt(-5, df = df.vec[1]),
	xlab = "t-value", xlim = c(-5, 6),
	ylim = c(0, 0.4), main = "")
axis(1, at = seq(-5, 5, by = 2.5))

for(i in 2:n) {
	pdfPlot(dist = "t", param.list = list(df = df.vec[i]), 
		left.tail.cutoff = pt(-5, df = df.vec[i]), 
		right.tail.cutoff = pt(-5, df = df.vec[i]),
		add = T, pdf.col = col.vec[i], pdf.lty = lty.vec[i])
}

legend(3, 0.4, rev(paste(format(df.vec), "df")), lty = rev(lty.vec), 
	col = rev(col.vec), bty = "n", lwd = 2)

mtext(expression(paste("Figure 16-1. Student's ",
	italic(t), "-Distribtuion", sep = "")), cex = 1.25,
	line = 2.5)
mtext("for Varying Degrees of Freedom", cex = 1.25, 
	line = 1)

rm(df.vec, lty.vec, col.vec, n, i)


#######################################################################################

# Example 16-1, pp. 16-6 to 16-7
#-------------------------------

Sulfate   <- EPA.09.Ex.16.1.sulfate.df$Sulfate.ppm
Well.type <- EPA.09.Ex.16.1.sulfate.df$Well.type
fit    <- lm(Sulfate ~ Well.type, 
	data = EPA.09.Ex.16.1.sulfate.df)
Residuals <- fit$residuals

# The function summaryStats will compute summary statistics and
# also the p-value for testing the equality of means between groups.

summaryStats(Sulfate.ppm ~ Well.type, data = EPA.09.Ex.16.1.sulfate.df, 
	digits = 2, p.value = TRUE, alternative = "greater",
	stats.in.rows = TRUE)
#
#                        Background Downgradient Combined  
#N                         8          6           14       
#Mean                    536.25     608.33       567.14    
#SD                       26.69      18.35        43.4     
#Median                  540        605          565       
#Min                     490        590          490       
#Max                     570        630          630       
#p.value.between.greater                           0.000053
#95%.LCL.between                                  49.39    
#95%.UCL.between                                        Inf
#NA's                      0          2            2       
#N.Total                   8          8           16   


# The function stripChart will display the raw data by group, 
# show means and SDs for each group, and compute the p-value for 
# testing the equality of means between groups.

windows()
stripChart(Sulfate.ppm ~ Well.type, data = EPA.09.Ex.16.1.sulfate.df, 
	ylab = "Sulfate (ppm)", location.scale.digits = 2,
	p.value = TRUE, alternative = "greater")



# Probability plot on residuals
windows()
qqPlot(Residuals, add.line = T, 
	ylab = "Sulfate residuals (ppm)", 
	main = "Figure 16-2. Probability Plot of \nCombined Sulfate Residuals")


# The R function t.test performs Student's t-test.
# By default, var.equal is set to FALSE, so you have to set it
# to TRUE for this example.
t.test(Sulfate[Well.type == "Downgradient"], 
	Sulfate[Well.type == "Background"],
	alternative = "greater", var.equal = TRUE)
#
#Results of Hypothesis Test
#--------------------------
#
#Null Hypothesis:                 difference in means = 0
#
#Alternative Hypothesis:          True difference in means is greater than 0
#
#Test Name:                        Two Sample t-test
#
#Estimated Parameter(s):          mean of x = 608.3333
#                                 mean of y = 536.2500
#
#Data:                            Sulfate[Well.type == "Downgradient"] and Sulfate[Well.type == "Background"]
#
#Test Statistic:                  t = 5.660985
#
#P-value:                         5.271532e-05
#
#95% Confidence Interval:         LCL = 49.38883
#                                 UCL =      Inf


rm(Sulfate, Well.type, fit, Residuals)


#####################################################################################################

# Example 16-2, pp. 16-9 to 16-10
#--------------------------------

longToWide(EPA.09.Ex.16.2.benzene.df, "Benzene.ppb", "Month", "Well.type")
#    Background Downgradient
#Jan        0.5          0.5
#Feb        0.8          0.7
#Mar        1.6          4.6
#Apr        1.8          2.0
#May        1.1         16.7
#Jun       16.1         12.5
#Jul        1.6         26.3
#Aug        0.6        186.0


#NOTE: set var.equal=FALSE in the call to summaryStats
summaryStats(Benzene.ppb ~ Well.type, data = EPA.09.Ex.16.2.benzene.df,
	digits = 2, p.value = TRUE, test.arg.list = list(var.equal = FALSE),
	group.p.value.type = "between", alternative = "greater",
	stats.in.rows = TRUE)
#                              Background Downgradient Combined
#N                               8          8           16     
#Mean                            3.01      31.16        17.09  
#SD                              5.31      63.22        45.71  
#Median                          1.35       8.55         1.7   
#Min                             0.5        0.5          0.5   
#Max                            16.1      186          186     
#Welch.p.value.between.greater                           0.12  
#95%.LCL.between                                       -14.26  
#95%.UCL.between                                          Inf


Well.type <- EPA.09.Ex.16.2.benzene.df$Well.type
Benzene   <- EPA.09.Ex.16.2.benzene.df$Benzene.ppb

t.test(Benzene[Well.type == "Downgradient"], 
	Benzene[Well.type == "Background"],
	alternative = "greater", var.equal = FALSE)
#Results of Hypothesis Test
#--------------------------
#
#Null Hypothesis:                 difference in means = 0
#
#Alternative Hypothesis:          True difference in means is greater than 0
#
#Test Name:                       Welch Two Sample t-test
#
#Estimated Parameter(s):          mean of x = 31.1625
#                                 mean of y =  3.0125
#
#Data:                            Benzene[Well.type == "Downgradient"] and Benzene[Well.type == "Background"]
#
#Test Statistic:                  t = 1.254938
#
#Test Statistic Parameter:        df = 7.09878
#
#P-value:                         0.1246182
#
#95% Confidence Interval:         LCL = -14.25922
#                                 UCL =       Inf

set.seed(25)
windows()
stripChart(Benzene.ppb ~ Well.type, data = EPA.09.Ex.16.2.benzene.df,
	method = "jitter", ylim = c(-25, 200), 
	ylab = "Benzene (ppb)",
	p.value = TRUE, alternative = "greater", 
	test.arg.list = list(var.equal = FALSE))


rm(Well.type, Benzene)


#####################################################################################################

# Example 16-3, pp. 16-11 to 16-14
#---------------------------------

new.EPA.df <- EPA.09.Ex.16.2.benzene.df
new.EPA.df$Benzene.ppb <- log(new.EPA.df$Benzene.ppb)
names(new.EPA.df)[3] <- "log.Benzene.ppb"

table.df <- data.frame(
	longToWide(EPA.09.Ex.16.2.benzene.df, "Benzene.ppb", "Month", "Well.type"),
	longToWide(new.EPA.df, "log.Benzene.ppb", "Month", "Well.type")
	)
names(table.df)[3:4] <- c("log.Background", "log.Downgradient")
round(table.df, 3)
#    Background Downgradient log.Background log.Downgradient
#Jan        0.5          0.5         -0.693           -0.693
#Feb        0.8          0.7         -0.223           -0.357
#Mar        1.6          4.6          0.470            1.526
#Apr        1.8          2.0          0.588            0.693
#May        1.1         16.7          0.095            2.815
#Jun       16.1         12.5          2.779            2.526
#Jul        1.6         26.3          0.470            3.270
#Aug        0.6        186.0         -0.511            5.226


summaryStats(Benzene.ppb ~ Well.type, data = EPA.09.Ex.16.2.benzene.df)
#             N    Mean      SD Median Min   Max
#Background   8  3.0125  5.3108   1.35 0.5  16.1
#Downgradient 8 31.1625 63.2229   8.55 0.5 186.0


summaryStats(log(Benzene.ppb) ~ Well.type, data = EPA.09.Ex.16.2.benzene.df)
#             N   Mean     SD Median     Min    Max
#Background   8 0.3719 1.0825 0.2827 -0.6931 2.7788
#Downgradient 8 1.8757 1.9847 2.0259 -0.6931 5.2257
 

#Step 1 - Test raw data for normality
#------------------------------------

gofGroupTest(Benzene.ppb ~ Well.type, data = EPA.09.Ex.16.2.benzene.df)

#Results of Group Goodness-of-Fit Test
-------------------------------------
#
#Test Method:                     Wilk-Shapiro GOF (Normal Scores)
#
#Hypothesized Distribution:       Normal
#
#Data:                            Benzene.ppb
#
#Grouping Variable:               Well.type
#
#Data Source:                     EPA.09.Ex.16.2.benzene.df
#
#Number of Groups:                2
#
#Sample Sizes:                    Background   = 8
#                                 Downgradient = 8
#
#Test Statistic:                  z (G) = -5.801397
#
#P-values for
#Individual Tests:                Background   = 1.192816e-05
#                                 Downgradient = 3.459439e-05
#
#P-value for
#Group Test:                      3.288234e-09
#
#Alternative Hypothesis:          At least one group
#                                 does not come from a
#                                 Normal Distribution.



#Step 2 - Compute summary statistics and 
#         test log-transformed data for normality
#------------------------------------------------

summaryStats(log(Benzene.ppb) ~ Well.type,  
	data = EPA.09.Ex.16.2.benzene.df, 
	digits = 4, p.value = TRUE, 
	test.arg.list = list(var.equal = FALSE),
	alternative = "greater", stats.in.rows = TRUE)

#                              Background Downgradient Combined
#N                              8          8           16      
#Mean                           0.3719     1.8757       1.1238 
#SD                             1.0825     1.9847       1.7287 
#Median                         0.2827     2.0259       0.5289 
#Min                           -0.6931    -0.6931      -0.6931 
#Max                            2.7788     5.2257       5.2257 
#Welch.p.value.between.greater                          0.044  
#95%.LCL.between                                        0.0663 
#95%.UCL.between                                           Inf  


gofGroupTest(log(Benzene.ppb) ~ Well.type, data = EPA.09.Ex.16.2.benzene.df)

#Results of Group Goodness-of-Fit Test
#-------------------------------------
#
#Test Method:                     Wilk-Shapiro GOF (Normal Scores)
#
#Hypothesized Distribution:       Normal
#
#Data:                            log(Benzene.ppb)
#
#Grouping Variable:               Well.type
#
#Data Source:                     EPA.09.Ex.16.2.benzene.df
#
#Number of Groups:                2
#
#Sample Sizes:                    Background   = 8
#                                 Downgradient = 8
#
#Test Statistic:                  z (G) = -0.470135
#
#P-values for
#Individual Tests:                Background   = 0.04471158
#                                 Downgradient = 0.84933304
#
#P-value for
#Group Test:                      0.3191293
#
#Alternative Hypothesis:          At least one group
#                                 does not come from a
#                                 Normal Distribution.



# Steps 3-5 - Compute Welch t-test
#---------------------------------

Month       <- EPA.09.Ex.16.2.benzene.df$Month
Well.type   <- EPA.09.Ex.16.2.benzene.df$Well.type
Benzene     <- EPA.09.Ex.16.2.benzene.df$Benzene.ppb
log.Benzene <- log(Benzene)

t.test(log.Benzene[Well.type == "Downgradient"], 
	log.Benzene[Well.type == "Background"],
	alternative = "greater", var.equal = FALSE)
#
#Results of Hypothesis Test
#--------------------------
#
#Null Hypothesis:                 difference in means = 0
#
#Alternative Hypothesis:          True difference in means is greater than 0
#
#Test Name:                       Welch Two Sample t-test
#
#Estimated Parameter(s):          mean of x = 1.8757293
#                                 mean of y = 0.3718509
#
#Data:                            log.Benzene[Well.type == "Downgradient"] and log.Benzene[Well.type == "Background"]
#
#Test Statistic:                  t = 1.881485
#
#P-value:                         0.04352518
#
#95% Confidence Interval:         LCL = 0.06631003
#                                 UCL =        Inf


windows()
stripChart(log(Benzene.ppb) ~ Well.type, data = EPA.09.Ex.16.2.benzene.df,
	ylab = "log [ Benzene (ppb) ]",
	p.value = TRUE, alternative = "greater", 
	test.arg.list = list(var.equal = FALSE))


#Figure 16-3
#-----------
windows()
plot(as.numeric(Month), Benzene, type = "n", xaxt = "n",
	xlab = "Month", ylab = "Benzene (ppb)",
	main = "Figure 16-3. Benzene Time Series Plot")
axis(1, at = sort(unique(as.numeric(Month))), labels = levels(Month))

points(as.numeric(Month)[Well.type == "Background"], 
	Benzene[Well.type == "Background"],
	type = "b", pch = 3, lty = 2)
points(as.numeric(Month)[Well.type == "Downgradient"], 
	Benzene[Well.type == "Downgradient"],
	type = "b", pch = 15)

legend(1, 150, c("Downgradient", "Background"), 
	pch = c(15, 3), lty = 1:2)

rm(new.EPA.df, table.df, Month, Well.type, Benzene, log.Benzene)

#######################################################################################################

# Example 16-4, pp. 16-18 to 16-20
#---------------------------------

# NOTE: From the help file for wilcox.test:
#      "The literature is not unanimous about the definitions of the 
#       Wilcoxon rank sum and Mann-Whitney tests. The two most common 
#       definitions correspond to the sum of the ranks of the first sample 
#       with the minimum value subtracted or not: R subtracts and S-PLUS does not, 
#       giving a value which is larger by m(m+1)/2 for a first sample of size m. 
#       (It seems Wilcoxon's original paper used the unadjusted sum of the ranks 
#       but subsequent tables subtracted the minimum.) "


# Step 1
#-------

longToWide(EPA.09.Ex.16.4.copper.df, "Copper.ppb", "Month", "Well", paste.row.name = TRUE)
#        Well.1 Well.2 Well.3
#Month.1    4.2    5.2    9.4
#Month.2    5.8    6.4   10.1
#Month.3   11.3   11.3   14.5
#Month.4    7.0   11.5   16.1
#Month.5    7.0   10.1   21.5
#Month.6    8.2    9.7   17.6

new.EPA.df <- EPA.09.Ex.16.4.copper.df
new.EPA.df$Copper.ppb <- rank(new.EPA.df$Copper.ppb)
names(new.EPA.df)[4] <- "rank.Copper.ppb"
rank.df <- longToWide(new.EPA.df, "rank.Copper.ppb", "Month", "Well", 
	paste.row.name = TRUE)
rank.df
#        Well.1 Well.2 Well.3
#Month.1    1.0    2.0    8.0
#Month.2    3.0    4.0   10.5
#Month.3   12.5   12.5   15.0
#Month.4    5.5   14.0   16.0
#Month.5    5.5   10.5   18.0
#Month.6    7.0    9.0   17.0


# Step 2
#-------
colSums(rank.df)["Well.3"]
#Well.3 
#  84.5


# Step 3
#-------
Cu        <- EPA.09.Ex.16.4.copper.df$Copper.ppb
Well.type <- EPA.09.Ex.16.4.copper.df$Well.type

wilcox.test(Cu[Well.type == "Compliance"], Cu[Well.type == "Background"],
	alternative = "greater")

#Results of Hypothesis Test
#--------------------------
#
#Null Hypothesis:                 location shift = 0
#
#Alternative Hypothesis:          True location shift is greater than 0
#
#Test Name:                       Wilcoxon rank sum test with continuity correction
#
#Data:                            Cu[Well.type == "Compliance"] and Cu[Well.type == "Background"]
#
#Test Statistic:                  W = 63.5
#
#P-value:                         0.005659303
#
#Warning message:
#In wilcox.test.default(Cu[Well.type == "Compliance"], Cu[Well.type ==  :
#  cannot compute exact p-value with ties


rm(new.EPA.df, rank.df, Cu, Well.type)


#######################################################################################################

# Example 16-5, pp. 16-22 to 16-23
#---------------------------------

# NOTE: The EnvStats for R function 
#       twoSampleLinearRankTestCensored()
#       contains the Tarone-Ware test, along with several other
#       similar tests.

PCE <- EPA.09.Ex.16.5.PCE.df$PCE.ppb
Well.type <- EPA.09.Ex.16.5.PCE.df$Well.type
Censored <- EPA.09.Ex.16.5.PCE.df$Censored


# Tarone-Ware test with hypergeometric variance
#----------------------------------------------
twoSampleLinearRankTestCensored(
	x = PCE[Well.type == "Compliance"], 
	x.censored = Censored[Well.type == "Compliance"], 
	y = PCE[Well.type == "Background"], 
	y.censored = Censored[Well.type == "Background"], 
	test = "tarone.ware", 
	alternative = "greater", 
	variance = "hypergeometric") 

#Results of Hypothesis Test
#Based on Censored Data
#--------------------------
#
#Null Hypothesis:                 Fy(t) = Fx(t)
#
#Alternative Hypothesis:          Fy(t) > Fx(t) for at least one t
#
#Test Name:                       Two-Sample Linear Rank Test:
#                                 Tarone-Ware Test
#                                 with Hypergeometric Variance
#
#Censoring Side:                  left
#
#Data:                            x = PCE[Well.type == "Compliance"]
#                                 y = PCE[Well.type == "Background"]
#
#Censoring Variable:              x = Censored[Well.type == "Compliance"]
#                                 y = Censored[Well.type == "Background"]
#
#Sample Sizes:                    nx = 8
#                                 ny = 6
#
#Percent Censored:                x = 12.5%
#                                 y = 50.0%
#
#Test Statistics:                 nu     =  8.458912
#                                 var.nu = 20.912407
#                                 z      =  1.849748
#
#P-value:                         0.03217495



# Logrank test with hypergeometric variance
#------------------------------------------
twoSampleLinearRankTestCensored(
	x = PCE[Well.type == "Compliance"], 
	x.censored = Censored[Well.type == "Compliance"], 
	y = PCE[Well.type == "Background"], 
	y.censored = Censored[Well.type == "Background"], 
	test = "logrank", 
	alternative = "greater", 
	variance = "hypergeometric") 

#Results of Hypothesis Test
#Based on Censored Data
#--------------------------
#
#Null Hypothesis:                 Fy(t) = Fx(t)
#
#Alternative Hypothesis:          Fy(t) > Fx(t) for at least one t
#
#Test Name:                       Two-Sample Linear Rank Test:
#                                 Logrank Test
#                                 with Hypergeometric Variance
#
#Censoring Side:                  left
#
#Data:                            x = PCE[Well.type == "Compliance"]
#                                 y = PCE[Well.type == "Background"]
#
#Censoring Variable:              x = Censored[Well.type == "Compliance"]
#                                 y = Censored[Well.type == "Background"]
#
#Sample Sizes:                    nx = 8
#                                 ny = 6
#
#Percent Censored:                x = 12.5%
#                                 y = 50.0%
#
#Test Statistics:                 nu     = 2.830406
#                                 var.nu = 2.176723
#                                 z      = 1.918435
#
#P-value:                         0.02752793




# Peto-Peto test with hypergeometric variance
#--------------------------------------------
twoSampleLinearRankTestCensored(
	x = PCE[Well.type == "Compliance"], 
	x.censored = Censored[Well.type == "Compliance"], 
	y = PCE[Well.type == "Background"], 
	y.censored = Censored[Well.type == "Background"], 
	test = "peto.peto", 
	alternative = "greater", 
	variance = "hypergeometric")

#Results of Hypothesis Test
#Based on Censored Data
#--------------------------
#
#Null Hypothesis:                 Fy(t) = Fx(t)
#
#Alternative Hypothesis:          Fy(t) > Fx(t) for at least one t
#
#Test Name:                       Two-Sample Linear Rank Test:
#                                 Peto-Peto Test Using
#                                 Prentice Survival Estimator
#                                 with Hypergeometric Variance
#
#Censoring Side:                  left
#
#Data:                            x = PCE[Well.type == "Compliance"]
#                                 y = PCE[Well.type == "Background"]
#
#Censoring Variable:              x = Censored[Well.type == "Compliance"]
#                                 y = Censored[Well.type == "Background"]
#
#Sample Sizes:                    nx = 8
#                                 ny = 6
#
#Percent Censored:                x = 12.5%
#                                 y = 50.0%
#
#Test Statistics:                 nu     = 1.888889
#                                 var.nu = 1.028642
#                                 z      = 1.862406
#
#P-value:                         0.03127296


 
# Gehan test with hypergeometric variance
#----------------------------------------
twoSampleLinearRankTestCensored(
	x = PCE[Well.type == "Compliance"], 
	x.censored = Censored[Well.type == "Compliance"], 
	y = PCE[Well.type == "Background"], 
	y.censored = Censored[Well.type == "Background"], 
	test = "gehan", 
	alternative = "greater", 
	variance = "hypergeometric")

#Results of Hypothesis Test
#Based on Censored Data
#--------------------------
#
#Null Hypothesis:                 Fy(t) = Fx(t)
#
#Alternative Hypothesis:          Fy(t) > Fx(t) for at least one t
#
#Test Name:                       Two-Sample Linear Rank Test:
#                                 Gehan's Test
#                                 with Hypergeometric Variance
#
#Censoring Side:                  left
#
#Data:                            x = PCE[Well.type == "Compliance"]
#                                 y = PCE[Well.type == "Background"]
#
#Censoring Variable:              x = Censored[Well.type == "Compliance"]
#                                 y = Censored[Well.type == "Background"]
#
#Sample Sizes:                    nx = 8
#                                 ny = 6
#
#Percent Censored:                x = 12.5%
#                                 y = 50.0%
#
#Test Statistics:                 nu     =  27.000000
#                                 var.nu = 227.000000
#                                 z      =   1.792053
#
#P-value:                         0.03656224


rm(PCE, Well.type, Censored)

############################################################################

#####
# File:     Chapter05.R
#
# Purpose:  Reproduce Examples in Chapter 5 of the book:
#
#           Millard, SP. (2013).  EnvStats: An R Package for 
#             Environmental Statistics.  Springer-Verlag.
#
# Author:   Steven P. Millard
#
# Last
# Updated:  10/14/2012
#####


#######################################################################################

library(EnvStats)

############################################################

# 5.2.1 Estimating Parameters of a Normal Distribution 
#-----------------------------------------------------

attach(EPA.94b.tccb.df)
enorm.list <- enorm(log(TcCB[Area == "Reference"]), ci = TRUE)
enorm.list


# Figure 5.1
#-----------
windows()
hist(log(TcCB[Area == "Reference"]), freq = FALSE, 
  xlim = c(-2, 1), xlab = "log [ TcCB (ppb) ]", 
  ylim = c(0, 1), col = "cyan", 
  main = "Log(TcCB) Data for Reference Area\nwith Fitted Normal Distribution")
params <- enorm.list$parameters
pdfPlot(dist = "norm", param.list = as.list(params), add = TRUE)

rm(enorm.list, params)
detach("EPA.94b.tccb.df")

###################################################################

# 5.2.2 Estimating Parameters of a Lognormal Distribution
#--------------------------------------------------------
attach(EPA.94b.tccb.df)
elnormAlt.list <- elnormAlt(TcCB[Area == "Reference"], ci = TRUE)
elnormAlt.list


# Figure 5.2
#-----------
windows()
hist(TcCB[Area == "Reference"], freq = FALSE, 
  xlim = c(0, 2), xlab = "TcCB (ppb)", 
  ylim = c(0, 2), col = "cyan", 
  main = "TcCB Data for Reference Area \nwith Fitted Lognormal Distribution")
params <- elnormAlt.list$parameters
pdfPlot(dist = "lnormAlt", param.list = as.list(params), add = TRUE)

rm(elnormAlt.list, params)
detach("EPA.94b.tccb.df")


sort(NIOSH.89.air.lead.vec)
round(elnormAlt(NIOSH.89.air.lead.vec, ci = TRUE)$interval$limits)
round(elnormAlt(NIOSH.89.air.lead.vec, ci = TRUE, ci.method = "zou")$interval$limits)

############################################################################

#5.3.1 Estimating Quantiles of a Normal Distribution
#----------------------------------------------------
EPA.09.Ex.21.1.aldicarb.df

attach(EPA.09.Ex.21.1.aldicarb.df)

eqnorm(Aldicarb.ppb[Well == "Well.1"], p = 0.95, ci = TRUE, ci.type = "lower", conf.level = 0.99)

sapply(split(Aldicarb.ppb, Well), function(x) {
  eqnorm(x, p = 0.95, ci = TRUE, ci.type = "lower", 
  conf.level = 0.99)$interval$limits["LCL"]
  })

sapply(split(Aldicarb.ppb, Well), function(x) {
  eqnorm(x, p = 0.95, ci = TRUE, ci.type = "upper", 
  conf.level = 0.99)$interval$limits["UCL"]
  })

detach("EPA.09.Ex.21.1.aldicarb.df")

####################################################################################

#5.3.2 Estimating Quantiles of a Lognormal Distribution
#------------------------------------------------------

EPA.09.Ex.17.3.chrysene.df

attach(EPA.09.Ex.17.3.chrysene.df)

Chrysene <- Chrysene.ppb[Well.type == "Background"]
eqlnorm(Chrysene, p = 0.95, ci = TRUE, ci.type = "upper", conf.level = 0.95)

rm(Chrysene)
detach("EPA.09.Ex.17.3.chrysene.df")

##################################################################################

#5.3.3 Estimating Quantiles of a Gamma Distribution
#--------------------------------------------------

attach(EPA.09.Ex.17.3.chrysene.df)

Chrysene <- Chrysene.ppb[Well.type == "Background"]

eqgamma(Chrysene, p = 0.95, ci = TRUE, ci.type = "upper", conf.level = 0.95)

rm(Chrysene)
detach("EPA.09.Ex.17.3.chrysene.df")

##################################################################################


#5.3.4 Nonparametric Estimates of Quantiles
#------------------------------------------

Sample.Size <- c(seq(5, 25, by = 5), 50, 75, 100)
conf.level <- tolIntNparConfLevel(Sample.Size, coverage = 0.95, ti.type = "upper")
cbind(Sample.Size, Confidence.Level = round(100 * conf.level))
rm(Sample.Size, conf.level)


EPA.09.Ex.21.6.nitrate.df[, 1:3]

EPA.09.Ex.21.6.nitrate.df[, c(2, 4:5)]

Nitrate <- EPA.09.Ex.21.6.nitrate.df$ Nitrate.mg.per.l
eqnpar(Nitrate, p = 0.95, ci = TRUE, ci.type = "lower", approx.conf.level = 0.95) 

eqnpar(Nitrate, p = 0.95, ci = TRUE, ci.type = "lower", lcl.rank = 10) 

eqnpar(Nitrate, p = 0.95, ci = TRUE, ci.type = "upper", approx.conf.level = 0.95) 

tolIntNparN(coverage = 0.95, ti.type = "upper", conf.level = 0.95)

rm(Nitrate)

#####
# File:     Chapter07.R
#
# Purpose:  Reproduce Examples in Chapter 7 of the book:
#
#           Millard, SP. (2013).  EnvStats: An R Package for 
#             Environmental Statistics.  Springer-Verlag.
#
# Author:   Steven P. Millard
#
# Last
# Updated:  2013/06/09
#####


#######################################################################################

library(EnvStats)

############################################################

# 7.2.1 One Sample Goodness-of-Fit Tests for Normality 
#-----------------------------------------------------

attach(EPA.94b.tccb.df)
TcCB.Ref <- TcCB[Area == "Reference"]
sw.list.norm <- gofTest(TcCB.Ref)
sw.list.norm

sw.list.lnormAlt <- gofTest(TcCB.Ref, dist = "lnormAlt")
sw.list.lnormAlt

# Figure 7.1
#-----------
windows()
plot(sw.list.norm)

# Figure 7.2
#-----------
windows()
plot(sw.list.lnormAlt)

windows()
plot(sw.list.norm, plot.type = "Tukey")

detach("EPA.94b.tccb.df")
rm(TcCB.Ref, sw.list.norm, sw.list.lnormAlt)

#######################################################################################

# 7.2.2 Testing Several Groups for Normality
#-------------------------------------------

EPA.09.Ex.10.1.nickel.df

# Figure 7.3
#-----------
windows()
stripChart(Nickel.ppb ~ Well, data = EPA.09.Ex.10.1.nickel.df, 
	show.ci = FALSE, points.cex = 1.5, col = 1:4, ylab = "Nickel (ppb)")
mtext("Nickel Concentrations by Well", line = 3, font = 2, cex = 1.5)

# Figure 7.4
#-----------
windows()
stripChart(log10(Nickel.ppb) ~ Well, data = EPA.09.Ex.10.1.nickel.df, 
	show.ci = FALSE, points.cex = 1.5, col = 1:4, 
	ylab = expression(paste(log[10], "[ Nickel (ppb) ]")))
mtext("Log10-Transformed Nickel Concentrations by Well", line = 3, font = 2, cex = 1.5)


sw.list <- gofGroupTest(Nickel.ppb ~ Well, 
	data = EPA.09.Ex.10.1.nickel.df)
sw.list

# Figure 7.5
#-----------
windows()
plot(sw.list)


sw.log.list <- gofGroupTest(Nickel.ppb ~ Well, 
	data = EPA.09.Ex.10.1.nickel.df, dist = "lnorm")
sw.log.list

# Figure 7.6
#-----------
windows()
plot(sw.log.list)

rm(sw.list, sw.log.list)


###################################################################################################

# 7.2.3 One Sample Goodness-of-Fit Tests for Other Distributions
#---------------------------------------------------------------

attach(EPA.92c.benzene1.df)

Benzene[Censored] <- 1

table(Benzene)

lambda.hat <- epois(Benzene)$parameters

lambda.hat

ppois(c(-1, 0, 2, Inf), lambda = lambda.hat)

diff(ppois(c(-1, 0, 2, Inf), lambda = lambda.hat))

chisq.list <- gofTest(Benzene, test = "chisq", dist = "pois", cut.points = c(-1, 0, 2, Inf))

# Figure 7.7
#-----------
windows()
plot(chisq.list)


rm(Benzene, lambda.hat, chisq.list)
detach("EPA.92c.benzene1.df")


########################################################################################################

# 7.2.4 Two-Sample Goodness-of-Fit Test to Compare Samples
#---------------------------------------------------------

attach(EPA.94b.tccb.df)

log.TcCB.ref <- log(TcCB[Area=="Reference"])

log.TcCB.clean <- log(TcCB[Area=="Cleanup"])

ks.list <- gofTest(x = log.TcCB.ref, y = log.TcCB.clean, test = "ks")

ks.list

# Figure 7.8
#-----------
windows()
plot(ks.list)

rm(log.TcCB.ref, log.TcCB.clean, ks.list)
detach("EPA.94b.tccb.df")

#########################################################################################################

# 7.3.1 Two- and k-Sample Comparisons for Location
#-------------------------------------------------
summaryStats(log(TcCB) ~ Area, data = EPA.94b.tccb.df, 
	digits = 2, p.value = TRUE, stats.in.rows = TRUE)


summaryStats(log(TcCB) ~ Area, data = EPA.94b.tccb.df, 
	digits = 2, p.value = TRUE, stats.in.rows = TRUE,
	test.arg.list = list(var.equal = FALSE))

windows()
stripChart(log(TcCB) ~ Area, data = EPA.94b.tccb.df, 
	col = c("red", "blue"), p.value = TRUE,
	ylab = "Log [ TcCB (ppb) ]")
mtext("Strip Chart of TcCB Data with Test Results", cex = 1.5, line = 3, font = 2)

#################################################################################################

# 7.3.2 Chen’s Modified One-Sample t-Test for Skewed Data
#--------------------------------------------------------
hist(EPA.02d.Ex.9.mg.per.L.vec, col = "cyan", xlab = "Concentration (mg/L)", 
	main = "Concentrations at Exposure Unit for Exhibit 9 (USEPA, 2002d)")

gofTest(EPA.02d.Ex.9.mg.per.L.vec)$p.value

gofTest(EPA.02d.Ex.9.mg.per.L.vec, dist = "lnorm")$p.value

chenTTest(EPA.02d.Ex.9.mg.per.L.vec, mu = 50)


#################################################################################################

# 7.5.1 Testing for Trend in the Presence of Seasons
#---------------------------------------------------
Total.P.df

with(Total.P.df, plot(CB3.3e, type = "o", xaxt = "n", 
	xlab = "Time", ylab = "Total P (mg)"))

with(Total.P.df, axis(1, at = (1:length(CB3.3e))[Month == "Jan"], 
	labels = Year[Month == "Jan"]))

title(main = "Total Phosphorus at Station CB3.3e")

kendallSeasonalTrendTest(CB3.3e ~ Month + Year, data = Total.P.df)

#####
# File:     Script - EPA09, Chapter 11 Examples.R
#
# Purpose:  Reproduce Examples in Chapter 11 of the EPA Guidance Document
#
#           USEPA. (2009).  "Statistical Analysis of Ground Water 
#             Monitoring Data at RCRA Facilities, Unified Guidance."
#             EPA 530-R-09-007.
#             Office of Resource Conservation and Recovery, 
#             Program Information and Implementation Division.
#             March 2009.
#
# Author:   Steven P. Millard
#
# Last
# Updated:  September 3, 2012
#####

#NOTE:  Unless otherwise noted, differences between what is shown in the
#       EPA Guidance Document and results shown here are due to the 
#       EPA Guidance Document rounding intermediate results prior to 
#       the final result.

#######################################################################################


# Example 11-1, pp. 11-2 to 11-4
#-------------------------------

head(EPA.09.Ex.11.1.arsenic.df)
#  Arsenic.ppb Month Well
#1        22.9     1    1
#2         3.1     2    1
#3        35.7     3    1
#4         4.2     4    1
#5         2.0     1    2
#6         1.2     2    2

longToWide(EPA.09.Ex.11.1.arsenic.df, "Arsenic.ppb", "Month", "Well", 
	paste.row.name = TRUE, paste.col.name = TRUE)
#        Well.1 Well.2 Well.3 Well.4 Well.5 Well.6
#Month.1   22.9    2.0    2.0    7.8   24.9    0.3
#Month.2    3.1    1.2  109.4    9.3    1.3    4.8
#Month.3   35.7    7.8    4.5   25.9    0.8    2.8
#Month.4    4.2   52.0    2.5    2.0   27.0    1.2

summaryStats(Arsenic.ppb ~ Well, data = EPA.09.Ex.11.1.arsenic.df)
#  N   Mean      SD Median Min   Max
#1 4 16.475 15.7104  13.55 3.1  35.7
#2 4 15.750 24.3450   4.90 1.2  52.0
#3 4 29.600 53.2110   3.50 2.0 109.4
#4 4 11.250 10.2614   8.55 2.0  25.9
#5 4 13.500 14.4030  13.10 0.8  27.0
#6 4  2.275  1.9755   2.00 0.3   4.8

Resids <- lm(Arsenic.ppb ~ Well, data = EPA.09.Ex.11.1.arsenic.df)$residuals
new.df <- data.frame(EPA.09.Ex.11.1.arsenic.df, Resids)
Resids.mat <- longToWide(new.df, "Resids", "Month", "Well", 
	paste.row.name = TRUE, paste.col.name = TRUE)
Resids.mat 
#         Well.1 Well.2 Well.3 Well.4 Well.5 Well.6
#Month.1   6.425 -13.75  -27.6  -3.45   11.4 -1.975
#Month.2 -13.375 -14.55   79.8  -1.95  -12.2  2.525
#Month.3  19.225  -7.95  -25.1  14.65  -12.7  0.525
#Month.4 -12.275  36.25  -27.1  -9.25   13.5 -1.075

windows()
boxplot(Resids ~ Well, data = new.df, 
	names = paste("Well", levels(new.df$Well)),
	ylab = "Arsenic Residuals (ppb)",
	main = "Figure 11-1. Side-by-Side Box Plots of Arsenic Residuals")

rm(Resids, new.df, Resids.mat)


##################################################################################


# Example 11-2, pp. 11-7 to 11-8
#-------------------------------

varGroupTest(Arsenic.ppb ~ Well, data = EPA.09.Ex.11.1.arsenic.df)

#Results of Hypothesis Test
#--------------------------
#
#Null Hypothesis:                 Ratio of each pair of variances = 1
#
#Alternative Hypothesis:          At least one variance differs
#
#Test Name:                       Levene's Test for
#                                 Homogenity of Variance
#
#Estimated Parameter(s):          Well.1 =  246.8158
#                                 Well.2 =  592.6767
#                                 Well.3 = 2831.4067
#                                 Well.4 =  105.2967
#                                 Well.5 =  207.4467
#                                 Well.6 =    3.9025
#
#Data:                            Arsenic.ppb
#
#Grouping Variable:               Well
#
#Data Source:                     EPA.09.Ex.11.1.arsenic.df
#
#Sample Sizes:                    Well.1 = 4
#                                 Well.2 = 4
#                                 Well.3 = 4
#                                 Well.4 = 4
#                                 Well.5 = 4
#                                 Well.6 = 4
#
#Test Statistic:                  F = 4.564176
#
#Test Statistic Parameters:       num df   =  5
#                                 denom df = 18
#
#P-value:                         0.007294084


##################################################################################


# Example 11-3, pp. 11-9 to 11-10
#--------------------------------

Stats <- summaryStats(Arsenic.ppb ~ Well, data = EPA.09.Ex.11.1.arsenic.df, 
	combine.groups = F, digits = 3)
Stats
#  N   Mean     SD Median Min   Max
#1 4 16.480 15.710  13.55 3.1  35.7
#2 4 15.750 24.345   4.90 1.2  52.0
#3 4 29.600 53.211   3.50 2.0 109.4
#4 4 11.250 10.261   8.55 2.0  25.9
#5 4 13.500 14.403  13.10 0.8  27.0
#6 4  2.275  1.975   2.00 0.3   4.8


windows()
plot(Stats[, "Mean"], Stats[, "SD"], pch = 16,
	xlab = "Mean Arsenic (ppb)",
	ylab = "SD Arsenic (ppb)",
	main = "Figure 11-3. Arsenic Mean-Standard Deviation Plot")


Stats <- summaryStats(log(Arsenic.ppb) ~ Well, 
	data = EPA.09.Ex.11.1.arsenic.df, 
	combine.groups = F, digits = 3)
windows()
plot(Stats[, "Mean"], Stats[, "SD"], pch = 16,
	xlim = c(0, 3), ylim = c(0, 3),
	xlab = "Log-Mean Arsenic log(ppb)",
	ylab = "Log-SD Arsenic log(ppb)",
	main = "Figure 11-4. Log(Arsenic) Mean-Standard Deviation Plot")

rm(Stats)

#####
# File:     Script - EPA09, Chapter 20 Examples.R
#
# Purpose:  Reproduce Examples in Chapter 20 of the EPA Guidance Document
#
#           USEPA. (2009).  "Statistical Analysis of Ground Water 
#             Monitoring Data at RCRA Facilities, Unified Guidance."
#             EPA 530-R-09-007.
#             Office of Resource Conservation and Recovery, 
#             Program Information and Implementation Division.
#             March 2009.
#
#           Errata are listed in:
#           USEPA. (2010).  "Errata Sheet - March 2009 Unified Guidance."
#             EPA 530/R-09-007a.
#             Office of Resource Conservation and Recovery, 
#             Program Information and Implementation Division.
#             August 9, 2010.
#
# Author:   Steven P. Millard
#
# Last
# Updated:  October 3, 2012
#####

#NOTE:  Unless otherwise noted, differences between what is shown in the
#       EPA Guidance Document and results shown here are due to the 
#       EPA Guidance Document rounding intermediate results prior to 
#       the final result.

#######################################################################################

library(EnvStats)

#NOTE:  Functions for producing quality control statistics and graphs
#       are available in the R package qcc.  You must have this 
#       package installed in order to load it.

library(qcc)

#######################################################################################

# Example 20-1, pp. 20-4 to 20-6
#-------------------------------

head(EPA.09.Ex.20.1.nickel.df)
#  Month Year   Period Nickel.ppb
#1     1 1995 Baseline       32.8
#2     2 1995 Baseline       15.2
#3     3 1995 Baseline       13.5
#4     4 1995 Baseline       39.6
#5     5 1995 Baseline       37.1
#6     6 1995 Baseline       10.4

longToWide(EPA.09.Ex.20.1.nickel.df, "Nickel.ppb", 
	"Month", "Period", paste.row.name = TRUE)
#        Baseline Compliance
#Month.1     32.8       19.0
#Month.2     15.2       34.5
#Month.3     13.5       17.8
#Month.4     39.6       23.6
#Month.5     37.1       34.8
#Month.6     10.4       28.8
#Month.7     31.9       23.7
#Month.8     20.6       81.8


# Summary statistics by Period
#-----------------------------

summaryStats(Nickel.ppb ~ Period, 
	data = EPA.09.Ex.20.1.nickel.df,
	combine.groups = TRUE, stats.in.rows = TRUE, 
	digits = 1)
#       Baseline Compliance Combined
#N       8        8         16      
#Mean   25.1     33         29.1    
#SD     11.5     20.7       16.7    
#Median 26.2     26.2       26.2    
#Min    10.4     17.8       10.4    
#Max    39.6     81.8       81.8  


# Step 1:  Shapiro-Wilk Test on Background Data
#----------------------------------------------

gof.list <- gofTest(Nickel.ppb ~ 1, 
	data = EPA.09.Ex.20.1.nickel.df, 
	subset = Period == "Baseline")
gof.list
#
#Results of Goodness-of-Fit Test
#-------------------------------
#
#Test Method:                     Shapiro-Wilk GOF
#
#Hypothesized Distribution:       Normal
#
#Estimated Parameter(s):          mean = 25.13750
#                                 sd   = 11.51818
#
#Estimation Method:               mvue
#
#Data:                            Nickel.ppb
#
#Subset With:                     Period == "Baseline"
#
#Data Source:                     EPA.09.Ex.20.1.nickel.df
#
#Sample Size:                     8
#
#Test Statistic:                  W = 0.8964134
#
#Test Statistic Parameter:        n = 8
#
#P-value:                         0.2681304
#
#Alternative Hypothesis:          True cdf does not equal the
#                                 Normal Distribution.


windows()
plot(gof.list, plot.type = "Q-Q Plot",
	ylab = "Nickel Concentration (ppb)",
	main = "Figure 20-1. Probability Plot of Baseline Nickel Data")



# Steps 2-6 Create Shewhart and CUSUM control charts 
#---------------------------------------------------

Month <- EPA.09.Ex.20.1.nickel.df$Month
Period <- EPA.09.Ex.20.1.nickel.df$Period
Nickel <- EPA.09.Ex.20.1.nickel.df$Nickel.ppb

Nickel.Baseline   <- Nickel[Period == "Baseline"]
Nickel.Compliance <- Nickel[Period == "Compliance"]
Baseline.mean <- mean(Nickel.Baseline)
Baseline.sd   <- sd(Nickel.Baseline)
h <- 5


# CUSUM chart
#------------
windows()
cusum.Nickel <- cusum(data = Nickel.Compliance, 
	sizes = 1, center = Baseline.mean, 
	std.dev = Baseline.sd, 
	decision.interval = h, se.shift = 1,
	data.name = "Nickel Conc (ppb)", 
	xlab = "Month",
	title = "Figure 20-2a. Cusum Control Chart for Nickel Measurements") 


# Combined Shewhart-CUSUM chart
#------------------------------

cusum.obs   <- Baseline.mean + Baseline.sd * cusum.Nickel$pos

windows()
par(mar = c(5, 4, 4, 4) + 0.1)
plot(1:length(Nickel.Compliance), Nickel.Compliance, 
	type = "n", lty = 2, ylim = c(0, 100),
	xlab = "Sampling Event", ylab = "Nickel Conc (ppb)",
	main = "Figure 20-2. Shewhart-CUSUM Control Chart for Nickel Measurements")
points(1:length(Nickel.Compliance), Nickel.Compliance, 
	type = "b", lty = 2, lwd = 2)
points(1:length(Nickel.Compliance), cusum.obs, 
	type = "b", pch = 15, col = 2, lwd = 2)
abline(h = Baseline.mean + h * Baseline.sd, col = 4, lwd = 3)
axis(side = 4, at = Baseline.mean + h * Baseline.sd, labels = "h-limit", 
	tick = FALSE, las = 2)
legend(5, 15, c("Nickel", "CUSUM"), pch = c(1, 15), 
	lty = 2:1, col = 1:2, lwd = 2, bty = "n")

rm(Month, Period, Nickel, Nickel.Baseline, gof.list, 
	Nickel.Compliance, Baseline.mean, Baseline.sd, 
	h, cusum.Nickel, cusum.obs)

#####
# File:     Chapter02.R
#
# Purpose:  Reproduce Examples in Chapter 2 of the book:
#
#           Millard, SP. (2013).  EnvStats: An R Package for 
#             Environmental Statistics.  Springer-Verlag.
#
# Author:   Steven P. Millard
#
# Last
# Updated:  2013/02/03
#####


#######################################################################################

library(EnvStats)

############################################################

# 2.8.1	Confidence Interval for the Mean of a Normal Distribution
#----------------------------------------------------------------
EPA.09.Ex.16.1.sulfate.df

Sulfate.back <- with(EPA.09.Ex.16.1.sulfate.df,
	Sulfate.ppm[Well.type == "Background"])
 
enorm(Sulfate.back, ci = TRUE)

enorm(Sulfate.back, ci = TRUE, ci.param = "variance")$interval

ciNormHalfWidth(n.or.n1 = 8, sigma.hat = c(15, 30, 60))

ciNormHalfWidth(n.or.n1 = 4, sigma.hat = 30)

ciNormN(half.width = 10, sigma.hat = 30)

# Figure 2.1
#-----------
windows()
plotCiNormDesign(sigma.hat=30, range.x.var=c(4, 80), 
  conf=0.99, xlim=c(0, 80), ylim=c(0, 90), 
  main = paste("Half-Width vs. Sample Size for CI for Mean",
    "with Estimated SD=30 and Various Confidence Levels", sep = "\n"))
plotCiNormDesign(sigma.hat=30, range.x.var=c(4, 80), conf=0.95, plot.lty=2, 
	plot.col = 2, add= TRUE)
plotCiNormDesign(sigma.hat=30, range.x.var=c(4, 80), conf=0.90, plot.lty=3, 
	plot.col = 4, add= TRUE)
legend("topright", paste(c("99%", "95%", "90%"), "Confidence"), col= c(1, 2, 4), 
	lty=1:3, lwd=3, bty = "n")

#--------------------------------------------------------------------------------------

Sulfate.down <- with(EPA.09.Ex.16.1.sulfate.df,
	Sulfate.ppm[Well.type == "Downgradient"])

enorm(Sulfate.down)

t.test(Sulfate.down, Sulfate.back, var.equal = TRUE)$conf.int

summary(lm(Sulfate.ppm ~ Well.type, data = EPA.09.Ex.16.1.sulfate.df))$sigma

ciTableMean(n1 = 8, n2 = 8, diff = c(100, 50, 0), 
  SD = c(15, 25, 50), digits = 0)


rm(Sulfate.back, Sulfate.down)

############################################################

# 2.8.2	Confidence Interval for a Binomal Proportion
#---------------------------------------------------

EPA.92c.benzene1.df

with(EPA.92c.benzene1.df, ebinom(Censored, ci = TRUE))

ciBinomHalfWidth(n.or.n1 = 36, p.hat = c(0.75, 0.85, 0.95))

ciBinomHalfWidth(n.or.n1 = 10, p.hat = 0.9)

ciBinomN(half.width = 0.03, p.hat = 0.9)

# Figure 2.2
#-----------
windows()
plotCiBinomDesign(p.hat=0.9, range.x.var=c(10, 200), conf=0.99, 
  xlim=c(0, 200), ylim=c(0, 0.3), 
  main=paste("Half-Width vs. Sample Size for CI for p", 
  "With Estimated p=0.9 and Various Confidence Levels", sep = "\n"))
plotCiBinomDesign(p.hat=0.9, range.x.var=c(10, 200), conf=0.95, plot.col = 2, plot.lty=2, add= TRUE)
plotCiBinomDesign(p.hat=0.9, range.x.var=c(10, 200), conf=0.90, plot.col = 4, plot.lty=3, add= TRUE)
legend("topright", paste(c("99%", "95%", "90%"), "Confidence"), col = c(1, 2, 4), lty=1:3, lwd=3, bty = "n")
mtext("CI Method = Score normal approximation, with continuity correction", line = 0)

#--------------------------------------------------------------------------------------

ciTableProp(n1 = 36, p1.hat = c(0.2, 0.4, 0.6), 
  n2 = 36, p2.hat.minus.p1.hat = c(0.3, 0.15, 0))

############################################################

# 2.8.3	Nonparametric Confidence Interval for a Percentile
#---------------------------------------------------------

EPA.92c.copper2.df

Cu.Bkgrd <- with(EPA.92c.copper2.df, Copper[Well.type == "Background"])

eqnpar(Cu.Bkgrd, p = 0.95)

ciNparConfLevel(n=24, p=0.95, ci.type="upper")

ciNparConfLevel(n=12, p=0.95, ci.type="upper")

ciNparN(p=0.95, ci.type="upper")

# Figure 2.3
#-----------
windows()
plotCiNparDesign(p=0.95, ci.type="upper", 
  range.x.var=c(2, 100), ylim=c(0, 1))


rm(Cu.Bkgrd)

############################################################

# 2.9.1	Prediction Interval for a Normal Distribution
#----------------------------------------------------

EPA.92c.arsenic3.df

As.Bkgrd <- with(EPA.92c.arsenic3.df, Arsenic[Well.type == "Background"])
predIntNorm(As.Bkgrd, k = 4, method = "exact")


# Figure 2.4
#-----------
windows()
plotPredIntNormDesign(range.x.var=c(4, 50), k=4, sigma.hat=17, 
  xlim=c(0, 50), ylim=c(30, 110), 
  main=paste("Half-Width vs. Sample Size for Prediction Interval", 
  "With Estimate SD=17 and Various Numbers of Future Values", sep = "\n"))
plotPredIntNormDesign(range.x.var=c(4, 50), k=2, sigma.hat=17, 
	plot.col = 2, plot.lty=2, add= TRUE)
plotPredIntNormDesign(range.x.var=c(4, 50), k=1, sigma.hat=17, 
	plot.col = 4, plot.lty=3, add= TRUE)
legend("topright", c("k=4", "k=2", "k=1"), col = c(1, 2, 4), lty=1:3, lwd = 3, bty = "n")

rm(As.Bkgrd)

############################################################

# 2.9.2 Nonparametric Prediction Interval
#----------------------------------------

predIntNparN(m = rep(c(1, 5, 10), 2), 
  conf.level = rep(c(0.9, 0.95), each = 3))

# Figure 2.5
#-----------
windows()
plotPredIntNparDesign(range.x.var = c(2, 100), k = 1, m = 1, 
  xlim = c(0, 100), ylim = c(0, 1),
  main=paste("Confidence Level vs. Sample Size for Nonparametric PI", 
  "With Various Values of m (Two-Sided PI)", sep = "\n"))
plotPredIntNparDesign(range.x.var=c(2, 100), k=5, m=5, plot.col = 2, plot.lty=2, add= TRUE)
plotPredIntNparDesign(range.x.var=c(2, 100), k=10, m=10, plot.col = 4, plot.lty=3, add= TRUE)
legend("bottomright", c("m=  1", "m=  5", "m=10"), col = c(1, 2, 4), lty = 1:3, lwd=3, bty = "n")


############################################################

# 2.10.1 Tolerance Interval for a Normal Distribution
#----------------------------------------------------


As.Bkgrd <- with(EPA.92c.arsenic3.df, Arsenic[Well.type == "Background"])
tolIntNorm(As.Bkgrd,  coverage = 0.95, cov.type = "content", 
    ti.type = "two-sided", conf.level = 0.99)

# Figure 2.6
#-----------
windows()
plotTolIntNormDesign(range.x.var = c(5, 50), sigma.hat = 17, 
  coverage = 0.99, conf = 0.99, 
  xlim = c(0, 50), ylim = c(0, 200), 
  main=paste("Half-Width vs. Sample Size for TI With Estimated", 
  "SD = 17 and Various Values of Coverage (99% Confidence)", 
  sep = "\n"))
plotTolIntNormDesign(range.x.var=c(5, 50), sigma.hat=17, coverage=0.95, 
  conf=0.99, plot.col = 2, plot.lty=2, add= TRUE)
plotTolIntNormDesign(range.x.var=c(5, 50), sigma.hat=17, coverage=0.90, 
  conf=0.99, plot.col = 4, plot.lty=3, add= TRUE)
legend("topright", paste(c("99%", "95%", "90%"), "Coverage"), col = c(1, 2, 4), 
	lty=1:3, lwd=3, bty = "n")

rm(As.Bkgrd)

############################################################

# 2.10.2 Nonparametric Tolerance Interval
#----------------------------------------

tolIntNparN(coverage = rep(c(0.8, 0.9, 0.95), 2), 
  conf.level = rep(c(0.9, 0.95), each = 3))


# Figure 2.7
#-----------
windows()
plotTolIntNparDesign(range.x.var = c(2, 100), coverage = 0.8, 
  xlim = c(0, 100), ylim = c(0, 1), 
  main=paste("Confidence Level vs. Sample Size for Nonparametric TI", 
  "With Various Values of Coverage (Two-Sided TI)", 
  sep = "\n"))
plotTolIntNparDesign(range.x.var = c(2, 100), coverage = 0.90, 
  plot.col = 2, plot.lty = 2, add = TRUE)
plotTolIntNparDesign(range.x.var = c(2, 100), coverage = 0.95, 
  plot.col = 4, plot.lty = 3, add = TRUE)
legend("bottomright", paste(c("80%", "90%", "95%"), "Coverage"), 
  col = c(1, 2, 4), lty = 1:3, lwd = 3, bty = "n")

#########################################################################

# 2.11.1 Testing the Mean of a Normal Distribution
#-------------------------------------------------

summaryStats(VC.ppb ~ Well, data = EPA.09.Ex.22.1.VC.df, 
  subset = Period == "Background", digits = 1)

VC.lm.fit <- lm(VC.ppb ~ Well, data = EPA.09.Ex.22.1.VC.df, 
  subset = Period == "Background")

summary(VC.lm.fit)$sigma

sqrt(enorm(VC.lm.fit$residuals, ci = TRUE, ci.param = "variance")$interval$limits)

tTestAlpha(n.or.n1 = 4, delta.over.sigma = 5 / c(3.2, 6), 
  power = 0.8, sample.type = "one.sample", 
  alternative = "greater")

tTestPower(n.or.n1 = c(4, 8, 12), delta.over.sigma = 5 / 3.2, 
  alpha = 0.01, alternative = "greater")

tTestN(delta.over.sigma = 5 / 6, alpha = 0.01, power = 0.9, 
  alternative = "greater")

rm(VC.lm.fit)


# Figure 2.8
#-----------
windows()
plotTTestDesign(alpha = 0.01, delta.over.sigma = 1, range.x.var = c(2, 35), 
  xlim = c(0, 35), ylim = c(0, 1), alternative="greater", approx = FALSE)


# Figure 2.9
#-----------
windows()
plotTTestDesign(y.var = "delta.over.sigma", alpha = 0.01, power = 0.9, 
  range.x.var = c(2, 15), xlim = c(0, 15), ylim = c(0, 40), 
  alternative = "greater", approx = FALSE)


#########################################################################

# 2.11.2 Testing a Binomial Proportion
#-------------------------------------------------

# Sample size based on normal approximation to the binomial
# without continuity correction
#----------------------------------------------------------
propTestN(p.or.p1 = 0.3, p0.or.p2 = 0.1, alpha = 0.05, 
  power = 0.9, sample.type = "one.sample", 
  alternative = "greater", approx = TRUE, round.up = TRUE)

# Simulation showing true Type I error rate using test based on
# normal approximation WITHOUT continuity correction is about 7%, not 5%
#-----------------------------------------------------------------------
set.seed(274)
N <- 10000
Reject.vec <- logical(N)
for(i in 1:N) {
  Reject.vec[i] <- prop.test(
    x = rbinom(n = 1, size = 30, prob = 0.1), 
    n = 30, p = 0.1, alternative = "greater", correct = FALSE)$p.value < 0.05
}
mean(Reject.vec)

binom.test(x = sum(Reject.vec), n = length(Reject.vec), p = 0.05)$conf.int


# Simulation showing true Type I error rate using test based on
# normal approximation WITH continuity correction is about 2.6%, not 5%
#-----------------------------------------------------------------------
set.seed(538)
N <- 10000
Reject.vec <- logical(N)
for(i in 1:N) {
  Reject.vec[i] <- prop.test(
    x = rbinom(n = 1, size = 30, prob = 0.1), 
    n = 30, p = 0.1, alternative = "greater", correct = TRUE)$p.value < 0.05
}
mean(Reject.vec)

binom.test(x = sum(Reject.vec), n = length(Reject.vec), p = 0.05)$conf.int

rm(N, Reject.vec, i)


# Sample size based on exact binomial test
#-----------------------------------------
propTestN(p.or.p1 = 0.3, p0.or.p2 = 0.1, alpha = 0.05, 
  power = 0.9, sample.type = "one.sample", 
  alternative = "greater", approx = FALSE, round.up = TRUE)

propTestN(p.or.p1 = 0.3, p0.or.p2 = 0.1, alpha = 0.05, 
  tol.alpha = 0.01, power = 0.9, sample.type = "one.sample", 
  alternative = "greater", approx = FALSE, round.up = TRUE)


#########################################################################


# 2.11.3 Testing Multiple Wells for Compliance with Simultaneous Prediction Intervals
#------------------------------------------------------------------------------------
nc <- 20
nw <- 100
conf.level <- (1 - 0.1)^(1 / (nc * nw))
conf.level

n <- 25
r <- 2

# Compute power of detecting an increase of three standard deviations 
# in concentration using the prediction interval based on the “1-of-2” 
# resampling rule.
#---------------------------------------------------------------------
predIntNormSimultaneousTestPower(n = n, k = 1, m = 2, r = r, 
  rule = "k.of.m", delta.over.sigma = 3, pi.type = "upper", 
  conf.level = conf.level)


# Reproduce table shown in Step 2 on page 19-23 of the EPA (2009) 
# guidance document.
#----------------------------------------------------------------
rule.vec <- c(rep("k.of.m", 3), "Modified.CA", rep("k.of.m", 3))
m.vec <- c(2, 3, 4, 4, 1, 2, 1)
n.mean.vec <- c(rep(1, 4), 2, 2, 3)
n.scenarios <- length(rule.vec)

K.vec <- predIntNormSimultaneousK(
		n = n, k = 1, m = m.vec,  
		n.mean = n.mean.vec,
		r = r, rule = rule.vec, 
		pi.type = "upper", conf.level = conf.level)

Power.vec <- predIntNormSimultaneousTestPower(
		n = n, k = 1, m = m.vec, 
		n.mean = n.mean.vec, r = r, 
		rule = rule.vec, delta.over.sigma = 3, 
		pi.type = "upper", conf.level = conf.level)

data.frame(Rule = rule.vec, k = rep(1, n.scenarios), 
	m = m.vec, N.Mean = n.mean.vec, 
	K = round(K.vec, 2), 
	Power = round(Power.vec, 2), 
	Total.Samples = m.vec * n.mean.vec)




# Figure 2.10
#------------
# Power for designs based on SINGLE future observations
#------------------------------------------------------
windows()
par(mar = c(5,4,6,1) + 0.1)
plotPredIntNormSimultaneousTestPowerCurve(n = n, 
	k = 1, m = 4, r = r, rule="k.of.m", pi.type = "upper", 
	conf.level = conf.level,  
	xlab = "SD Units Above Background",
	main = "")
plotPredIntNormSimultaneousTestPowerCurve(n = n, 
	k = 1, m = 3, r = r, rule="k.of.m", pi.type = "upper", 
	conf.level = conf.level,  
	add = TRUE, plot.col = 2, plot.lty = 2)
plotPredIntNormSimultaneousTestPowerCurve(n = n, 
	k = 1, m = 2, r = r, rule="k.of.m", pi.type = "upper", 
	conf.level = conf.level,  
	add = TRUE, plot.col = 3, plot.lty = 3)
plotPredIntNormSimultaneousTestPowerCurve(n = n, 
	r = r, rule="Modified.CA", pi.type = "upper", 
	conf.level = conf.level,  
	add = TRUE, plot.col = 4, plot.lty = 4)
legend(0, 1, c("1-of-4", "Modified CA", "1-of-3", "1-of-2"), 
	col = c(1, 4, 2, 3), lty = c(1, 4, 2, 3), lwd = 2, bty="n")
mtext(paste('Power of 1-of-2, 1-of-3, 1-of-4, and Modified CA Designs to',
	"\nDetect An Increase At", nw, "Wells for SWFPR = 10%"), 
	line = 3, cex = 1.25)
mtext(paste("(Based on", n, "Background Observations and\n", 
	"Adjusted for", nc, "Consituents and", r, "Evaluations per year)"), 
	line = 1)


# Figure 2.11
#------------
# Power for designs based on the MEAN of future observations
#-----------------------------------------------------------
windows()
par(mar = c(5,4,6,1) + 0.1)
plotPredIntNormSimultaneousTestPowerCurve(n = n, 
	k = 1, m = 2, n.mean = 2, r = r, rule="k.of.m", 
	pi.type = "upper", conf.level = conf.level,  
	xlab = "SD Units Above Background",
	main = "")
plotPredIntNormSimultaneousTestPowerCurve(n = n, 
	k = 1, m = 1, n.mean = 2, r = r, rule="k.of.m", 
	pi.type = "upper", 
	conf.level = conf.level, 
	add = TRUE, plot.col = 2, plot.lty = 2)
plotPredIntNormSimultaneousTestPowerCurve(n = n, 
	k = 1, m = 1, n.mean = 3, r = r, rule="k.of.m", 
	pi.type = "upper", conf.level = conf.level, 
	add = TRUE, plot.col = 3, plot.lty = 3)
legend(0, 1, c("1-of-2, Order 2", "1-of-1, Order 3", "1-of-1, Order 2"), 
	col = c(1, 3, 2), lty = c(1, 3, 2), lwd = 2, 
	bty="n")
mtext(paste('Power of 1-of-1 and 1-of-2 Designs Based on Means to Detect',
	"\nAn Increase At", nw, "Wells for SWFPR = 10%"), 
	line = 3, cex = 1.25)
mtext(paste("(Based on", n, "Background Observations and\n", 
	"Adjusted for", nc, "Consituents and", r, "Evaluations per Year)"), 
	line = 1)


rm(nc, nw, conf.level, n, r, rule.vec, m.vec, n.mean.vec, 
  n.scenarios, K.vec, Power.vec)

#####
# File:     Script - EPA09, Chapter 06 Examples.R
#
# Purpose:  Reproduce Examples in Chapter 6 of the EPA Guidance Document
#
#           USEPA. (2009).  "Statistical Analysis of Ground Water 
#             Monitoring Data at RCRA Facilities, Unified Guidance."
#             EPA 530-R-09-007.
#             Office of Resource Conservation and Recovery, 
#             Program Information and Implementation Division.
#             March 2009.
#
# Author:   Steven P. Millard
#
# Last
# Updated:  2013/10/15
#####

#NOTE:  Unless otherwise noted, differences between what is shown in the
#       EPA Guidance Document and results shown here are due to the 
#       EPA Guidance Document rounding intermediate results prior to 
#       the final result.

#######################################################################################

library(EnvStats)

# Figure 6-2, p. 6-15
#--------------------
windows()
plotPredIntNormTestPowerCurve(n = 10, k = 1, 
	range.delta.over.sigma = c(0, 5), 
	pi.type = "upper", conf.level = 0.99, 
	ylim = c(0, 1), 
	xlab = expression(paste(Delta, " (SDs above Background)")), 
	ylab = "Power", cex.main = 1.1, 
	main = "Figure 6-2. Normal Power Curve (n = 10) for 99% Prediction Limit Test")

##############################################################################

# Figure 6-3, p. 6-17
#--------------------
windows()
plotPredIntNormTestPowerCurve(n = 10, k = 1, 
	range.delta.over.sigma = c(0, 5), 
	pi.type = "upper", conf.level = 0.99, 
	ylim = c(0, 1), 
	xlab = "SD Units Above BG", 
	ylab = "Power",
	main = "Figure 6-3. EPA Reference Power Curves")

plotPredIntNormTestPowerCurve(n = 10, k = 2, conf.level = 0.99, 
	add = TRUE, plot.col = "red", plot.lty = 2)

plotPredIntNormTestPowerCurve(n = 10, k = 4, conf.level = 0.99, 
	add = TRUE, plot.col = "blue", plot.lty = 3)

legend("topleft", c("Quarterly", "Semi-Annual", "Annual"), lty = 3:1, 
	lwd = 3 * par("cex"), col = c("blue", "red", "black")) 

##################################################################

# Example 6-1, p. 6-18
#---------------------
predIntNormTestPower(n = 10, k = 1, 
	delta.over.sigma = (15 - 6) / 2, 
	pi.type = "upper", conf.level = 0.99)
#[1] 0.9012473



# Example 6-3, pp. 6-20 to 6-21
#------------------------------
stats   <- summaryStats(Sulfate.ppm ~ 1, data = EPA.09.Ex.6.3.sulfate.df,
	data.name = "Sulfate", digits = 1)
stats
#         N Mean   SD Median Min Max
#Sulfate 10  545 29.7    546 490 590

n     <- stats[, "N"]
SD    <- stats[, "SD"]
delta <- c(0, 200)

windows()
plotPredIntNormTestPowerCurve(n = n, k = 1, 
	axes = F,
	range.delta.over.sigma = range(delta / SD), 
	pi.type = "upper", conf.level = 0.99, 
	ylim = c(0, 1), 
	xlab = "Sulfate Conc. Increase (ppm)", 
	ylab = "Power",
	main = "Figure 6-3. Approximate s-Based Power Curve for Sulfate")
axis(2)
x.axis.ticks <- seq(0, 200, by = 50)
axis(1, at = x.axis.ticks / SD, labels = x.axis.ticks)
box()
abline(v = 75 / SD, lty = 2, lwd = 2)

predIntNormTestPower(n = n, k = 1, delta.over.sigma = 75 / SD, 
	pi.type = "upper", conf.level = 0.99)
#[1] 0.3916402

rm(stats, n, SD, delta, x.axis.ticks)
